//package project;

import org.omg.PortableServer.*;
import org.omg.CosNaming.*;

public class Connection {
  String[] args = null;
  NameComponent nome[] = new NameComponent[3];

  public networkR1.NetworkR1 getConnected() throws Exception {
      // Initialize the ORB.
      org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,null);

      // Obtain the root context.
      org.omg.CORBA.Object rootObj = orb.resolve_initial_references("NameService");
      NamingContextExt root = NamingContextExtHelper.narrow(rootObj);
      // Locate an account manager through the Naming Service.
      // Note that casting is needed as a workaround for a JDK 1.1.x bug.

      nome[0] = new NameComponent("ITALIA","FederationContext");
      nome[1] = new NameComponent("2.0.0","Version");
      nome[2] = new NameComponent("SiemensBologna/ITALIA","NetworkR1");
      org.omg.CORBA.Object mgrObj = ((NamingContext)root).resolve(nome);
      /*org.omg.CORBA.Object mgrObj = ((NamingContext)root).resolve(root.to_name("NetworkManager"));
      NamingContext context_1 = NamingContextHelper.narrow(((NamingContext)root).resolve(nome_0));
      NamingContext context_2 = NamingContextHelper.narrow(context_1.resolve(nome_1));
      org.omg.CORBA.Object mgrObj = context_2.resolve(nome_2);*/

      networkR1.NetworkR1 netR1 =  networkR1.NetworkR1Helper.narrow(mgrObj);
      return netR1;
  }
}
