package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::FixedEventHeader
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/FixedEventHeader:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct FixedEventHeader {
  ...
};
 * </pre>
 */
public final class FixedEventHeader implements org.omg.CORBA.portable.IDLEntity {
  
  public CosNotification.EventType event_type;
  
  public java.lang.String event_name;

  public FixedEventHeader () {
  }

  public FixedEventHeader (final CosNotification.EventType event_type, 
                           final java.lang.String event_name) {
    this.event_type = event_type;
    this.event_name = event_name;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct CosNotification.FixedEventHeader {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("CosNotification.EventType event_type=");
    _ret.append(event_type);
    _ret.append(",\n");
    _ret.append("java.lang.String event_name=");
    _ret.append(event_name != null?'\"' + event_name + '\"':null);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof CosNotification.FixedEventHeader) {
      _cmpMap.put(_currentThread, o);
      final CosNotification.FixedEventHeader obj = (CosNotification.FixedEventHeader)o;
      boolean res = true;
      do {
        res = this.event_type == obj.event_type ||
         (this.event_type != null && obj.event_type != null && this.event_type.equals(obj.event_type));
        if (!res) break;
        res = this.event_name == obj.event_name ||
         (this.event_name != null && obj.event_name != null && this.event_name.equals(obj.event_name));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
