package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::PropertyError
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/PropertyError:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct PropertyError {
  ...
};
 * </pre>
 */
public final class PropertyError implements org.omg.CORBA.portable.IDLEntity {
  
  public CosNotification.QoSError_code code;
  
  public java.lang.String name;
  
  public CosNotification.PropertyRange available_range;

  public PropertyError () {
  }

  public PropertyError (final CosNotification.QoSError_code code, 
                        final java.lang.String name, 
                        final CosNotification.PropertyRange available_range) {
    this.code = code;
    this.name = name;
    this.available_range = available_range;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct CosNotification.PropertyError {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("CosNotification.QoSError_code code=");
    _ret.append(code);
    _ret.append(",\n");
    _ret.append("java.lang.String name=");
    _ret.append(name != null?'\"' + name + '\"':null);
    _ret.append(",\n");
    _ret.append("CosNotification.PropertyRange available_range=");
    _ret.append(available_range);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof CosNotification.PropertyError) {
      _cmpMap.put(_currentThread, o);
      final CosNotification.PropertyError obj = (CosNotification.PropertyError)o;
      boolean res = true;
      do {
        res = this.code == obj.code ||
         (this.code != null && obj.code != null && this.code.equals(obj.code));
        if (!res) break;
            res = this.name == obj.name ||
             (this.name != null && obj.name != null && this.name.equals(obj.name));
        if (!res) break;
        res = this.available_range == obj.available_range ||
         (this.available_range != null && obj.available_range != null && this.available_range.equals(obj.available_range));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
