package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::PropertyError
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/PropertyError:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct PropertyError {
  ...
};
 * </pre>
 */
public final class PropertyErrorHelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static CosNotification.PropertyError read (final org.omg.CORBA.portable.InputStream _input) {
    final CosNotification.PropertyError _result = new CosNotification.PropertyError();
    _result.code = CosNotification.QoSError_codeHelper.read(_input);
    _result.name = _input.read_string();
    _result.available_range = CosNotification.PropertyRangeHelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final CosNotification.PropertyError _vis_value) {
    CosNotification.QoSError_codeHelper.write(_output, _vis_value.code);
    _output.write_string((java.lang.String)_vis_value.name);
    CosNotification.PropertyRangeHelper.write(_output, _vis_value.available_range);
  }

  public static void insert (final org.omg.CORBA.Any any, final CosNotification.PropertyError _vis_value) {
    any.insert_Streamable(new CosNotification.PropertyErrorHolder(_vis_value));
  }

  public static CosNotification.PropertyError extract (final org.omg.CORBA.Any any) {
    CosNotification.PropertyError _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      CosNotification.PropertyErrorHolder _vis_holder = new CosNotification.PropertyErrorHolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = CosNotification.PropertyErrorHelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[3];
          members[0] = new org.omg.CORBA.StructMember("code", CosNotification.QoSError_codeHelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("name", CosNotification.PropertyNameHelper.type(), null);
          members[2] = new org.omg.CORBA.StructMember("available_range", CosNotification.PropertyRangeHelper.type(), null);
          _type = _orb().create_struct_tc(id(), "PropertyError", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:omg.org/CosNotification/PropertyError:1.0";
  }
}
