package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::QoSAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/QoSAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface QoSAdmin {
  ...
};
 * </pre>
 */
public interface QoSAdminOperations {
  /**
   * <pre>
   *   CosNotification.QoSProperties get_qos ();
   * </pre>
   */
  public CosNotification.Property[] get_qos ();

  /**
   * <pre>
   *   void set_qos (in CosNotification.QoSProperties qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void set_qos (CosNotification.Property[] qos) throws CosNotification.UnsupportedQoS;

  /**
   * <pre>
   *   void validate_qos (in CosNotification.QoSProperties required_qos,
                     out CosNotification.NamedPropertyRangeSeq available_qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void validate_qos (CosNotification.Property[] required_qos, 
                            CosNotification.NamedPropertyRangeSeqHolder available_qos) throws CosNotification.UnsupportedQoS;

}
