package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::StructuredEvent
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/StructuredEvent:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct StructuredEvent {
  ...
};
 * </pre>
 */
public final class StructuredEvent implements org.omg.CORBA.portable.IDLEntity {
  
  public CosNotification.EventHeader header;
  
  public CosNotification.Property[] filterable_data;
  
  public org.omg.CORBA.Any remainder_of_body;

  public StructuredEvent () {
  }

  public StructuredEvent (final CosNotification.EventHeader header, 
                          final CosNotification.Property[] filterable_data, 
                          final org.omg.CORBA.Any remainder_of_body) {
    this.header = header;
    this.filterable_data = filterable_data;
    this.remainder_of_body = remainder_of_body;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct CosNotification.StructuredEvent {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("CosNotification.EventHeader header=");
    _ret.append(header);
    _ret.append(",\n");
    _ret.append("CosNotification.Property[] filterable_data=");
    _ret.append("{");
    if (filterable_data == null) {
      _ret.append(filterable_data);
    } else {
      for (int $counter18 = 0; $counter18 < filterable_data.length; $counter18++) {
        _ret.append(filterable_data[$counter18]);
        if ($counter18 < filterable_data.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("org.omg.CORBA.Any remainder_of_body=");
    _ret.append(remainder_of_body);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof CosNotification.StructuredEvent) {
      _cmpMap.put(_currentThread, o);
      final CosNotification.StructuredEvent obj = (CosNotification.StructuredEvent)o;
      boolean res = true;
      do {
        res = this.header == obj.header ||
         (this.header != null && obj.header != null && this.header.equals(obj.header));
        if (!res) break;
            if (res = (this.filterable_data.length == obj.filterable_data.length)) {
              for (int $counter19 = 0; res && $counter19 < this.filterable_data.length; $counter19++) {
                res = this.filterable_data[$counter19] == obj.filterable_data[$counter19] ||
                 (this.filterable_data[$counter19] != null && obj.filterable_data[$counter19] != null && this.filterable_data[$counter19].equals(obj.filterable_data[$counter19]));
              }
            }
        if (!res) break;
        res = this.remainder_of_body == obj.remainder_of_body ||
         (this.remainder_of_body != null && obj.remainder_of_body != null && this.remainder_of_body.equals(obj.remainder_of_body));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
