package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::UnsupportedAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/UnsupportedAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * exception UnsupportedAdmin {
  ...
};
 * </pre>
 */
public final class UnsupportedAdmin extends org.omg.CORBA.UserException {
  
  public CosNotification.PropertyError[] admin_err;

  public UnsupportedAdmin () {
    super(CosNotification.UnsupportedAdminHelper.id());
  }

  public UnsupportedAdmin (CosNotification.PropertyError[] admin_err) {
    this();
    this.admin_err = admin_err;
  }

  public UnsupportedAdmin (java.lang.String _reason, CosNotification.PropertyError[] admin_err) {
    super(CosNotification.UnsupportedAdminHelper.id() + ' ' + _reason);
    this.admin_err = admin_err;
  }

  public java.lang.String toString () {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("exception CosNotification.UnsupportedAdmin {");
    _ret.append("\n");
    _ret.append("CosNotification.PropertyError[] admin_err=");
    _ret.append("{");
    if (admin_err == null) {
      _ret.append(admin_err);
    } else {
      for (int $counter14 = 0; $counter14 < admin_err.length; $counter14++) {
        _ret.append(admin_err[$counter14]);
        if ($counter14 < admin_err.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _ret.append("}");
    return _ret.toString();
  }

  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;
    if (o instanceof CosNotification.UnsupportedAdmin) {
      final CosNotification.UnsupportedAdmin obj = (CosNotification.UnsupportedAdmin)o;
      boolean res = true;
      do {
          if (res = (this.admin_err.length == obj.admin_err.length)) {
            for (int $counter15 = 0; res && $counter15 < this.admin_err.length; $counter15++) {
              res = this.admin_err[$counter15] == obj.admin_err[$counter15] ||
               (this.admin_err[$counter15] != null && obj.admin_err[$counter15] != null && this.admin_err[$counter15].equals(obj.admin_err[$counter15]));
            }
          }
      } while (false);
      return res;
    }
    else {
      return false;
    }
  }
}
