package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::QoSAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/QoSAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface QoSAdmin {
  ...
};
 * </pre>
 */
public class _QoSAdminStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements QoSAdmin {
  final public static java.lang.Class _opsClass = CosNotification.QoSAdminOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:omg.org/CosNotification/QoSAdmin:1.0"
  };

  /**
   * <pre>
   *   CosNotification.QoSProperties get_qos ();
   * </pre>
   */
  public CosNotification.Property[] get_qos () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        CosNotification.Property[] _result;
        try {
          _output = this._request("get_qos", true);
          _input = this._invoke(_output);
          _result = CosNotification.QoSPropertiesHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("get_qos", _opsClass);
        if (_so == null) {
          continue;
        }
        final CosNotification.QoSAdminOperations _self = (CosNotification.QoSAdminOperations)_so.servant;
        try {
          return _self.get_qos();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   void set_qos (in CosNotification.QoSProperties qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void set_qos (CosNotification.Property[] qos) throws  CosNotification.UnsupportedQoS {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("set_qos", true);
          CosNotification.QoSPropertiesHelper.write(_output, qos);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(CosNotification.UnsupportedQoSHelper.id())) {
            throw             CosNotification.UnsupportedQoSHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("set_qos", _opsClass);
        if (_so == null) {
          continue;
        }
        final CosNotification.QoSAdminOperations _self = (CosNotification.QoSAdminOperations)_so.servant;
        try {
          _self.set_qos(qos);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void validate_qos (in CosNotification.QoSProperties required_qos,
                     out CosNotification.NamedPropertyRangeSeq available_qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void validate_qos (CosNotification.Property[] required_qos, 
                            CosNotification.NamedPropertyRangeSeqHolder available_qos) throws  CosNotification.UnsupportedQoS {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("validate_qos", true);
          CosNotification.QoSPropertiesHelper.write(_output, required_qos);
          _input = this._invoke(_output);
          available_qos.value = CosNotification.NamedPropertyRangeSeqHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(CosNotification.UnsupportedQoSHelper.id())) {
            throw             CosNotification.UnsupportedQoSHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("validate_qos", _opsClass);
        if (_so == null) {
          continue;
        }
        final CosNotification.QoSAdminOperations _self = (CosNotification.QoSAdminOperations)_so.servant;
        try {
          _self.validate_qos(required_qos, available_qos);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
