package common;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/common.idl"
 * <li> <b>IDL Name</b>      ::cummon::Common
 * <li> <b>Repository Id</b> IDL:cummon/Common:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Common {
  ...
};
 * </pre>
 */
public class CommonPOATie extends CommonPOA {
  private common.CommonOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public CommonPOATie (final common.CommonOperations _delegate) {
    this._delegate = _delegate;
  }

  public CommonPOATie (final common.CommonOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public common.CommonOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final common.CommonOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   void setUserLabel (in globaldefs.NamingAttributes_T objectName,
                     in string userLabel)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setUserLabel (globaldefs.NameAndStringValue_T[] objectName, 
                            java.lang.String userLabel) throws  globaldefs.ProcessingFailureException {
    this._delegate.setUserLabel(objectName, userLabel);
  }

  /**
   * <pre>
   *   void setOwner (in globaldefs.NamingAttributes_T objectName,
                 in string owner)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setOwner (globaldefs.NameAndStringValue_T[] objectName, 
                        java.lang.String owner) throws  globaldefs.ProcessingFailureException {
    this._delegate.setOwner(objectName, owner);
  }

}
