package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::EquipmentIterator
 * <li> <b>Repository Id</b> IDL:equipmentInventory/EquipmentIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EquipmentIterator {
  ...
};
 * </pre>
 */
public interface EquipmentIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out equipmentInventory.Equipment_T equipment)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (equipmentInventory.Equipment_THolder equipment) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out equipmentInventory.EquipmentList_T equipmentList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         equipmentInventory.EquipmentList_THolder equipmentList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
