package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::EquipmentInventoryMgr
 * <li> <b>Repository Id</b> IDL:equipmentInventory/EquipmentInventoryMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EquipmentInventoryMgr {
  ...
};
 * </pre>
 */
public class _EquipmentInventoryMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements EquipmentInventoryMgr {
  final public static java.lang.Class _opsClass = equipmentInventory.EquipmentInventoryMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:equipmentInventory/EquipmentInventoryMgr:1.0"
  };

  /**
   * <pre>
   *   void getEquipment (in globaldefs.NamingAttributes_T equipmentName,
                     out equipmentInventory.Equipment_T equipment)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getEquipment (globaldefs.NameAndStringValue_T[] equipmentName, 
                            equipmentInventory.Equipment_THolder equipment) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getEquipment", true);
          globaldefs.NamingAttributes_THelper.write(_output, equipmentName);
          _input = this._invoke(_output);
          equipment.value = equipmentInventory.Equipment_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getEquipment", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentInventoryMgrOperations _self = (equipmentInventory.EquipmentInventoryMgrOperations)_so.servant;
        try {
          _self.getEquipment(equipmentName, equipment);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllEquipment (in globaldefs.NamingAttributes_T managedElementOrEquipmentName,
                        in unsigned long how_many,
                        out equipmentInventory.EquipmentList_T eqList,
                        out equipmentInventory.EquipmentIterator eqIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEquipment (globaldefs.NameAndStringValue_T[] managedElementOrEquipmentName, 
                               int how_many, 
                               equipmentInventory.EquipmentList_THolder eqList, 
                               equipmentInventory.EquipmentIteratorHolder eqIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllEquipment", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementOrEquipmentName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          eqList.value = equipmentInventory.EquipmentList_THelper.read(_input);
          eqIt.value = equipmentInventory.EquipmentIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllEquipment", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentInventoryMgrOperations _self = (equipmentInventory.EquipmentInventoryMgrOperations)_so.servant;
        try {
          _self.getAllEquipment(managedElementOrEquipmentName, how_many, eqList, 
                                eqIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllEquipmentNames (in globaldefs.NamingAttributes_T managedElementOrEquipmentName,
                             in unsigned long how_many,
                             out globaldefs.NamingAttributesList_T nameList,
                             out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEquipmentNames (globaldefs.NameAndStringValue_T[] managedElementOrEquipmentName, 
                                    int how_many, 
                                    globaldefs.NamingAttributesList_THolder nameList, 
                                    globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllEquipmentNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementOrEquipmentName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllEquipmentNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentInventoryMgrOperations _self = (equipmentInventory.EquipmentInventoryMgrOperations)_so.servant;
        try {
          _self.getAllEquipmentNames(managedElementOrEquipmentName, how_many, nameList, 
                                     nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllSupportedPTPNames (in globaldefs.NamingAttributes_T equipmentName,
                                in unsigned long how_many,
                                out globaldefs.NamingAttributesList_T nameList,
                                out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllSupportedPTPNames (globaldefs.NameAndStringValue_T[] equipmentName, 
                                       int how_many, 
                                       globaldefs.NamingAttributesList_THolder nameList, 
                                       globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllSupportedPTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, equipmentName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllSupportedPTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentInventoryMgrOperations _self = (equipmentInventory.EquipmentInventoryMgrOperations)_so.servant;
        try {
          _self.getAllSupportedPTPNames(equipmentName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllSupportingEquipmentNames (in globaldefs.NamingAttributes_T ptpName,
                                       in unsigned long how_many,
                                       out globaldefs.NamingAttributesList_T nameList,
                                       out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllSupportingEquipmentNames (globaldefs.NameAndStringValue_T[] ptpName, 
                                              int how_many, 
                                              globaldefs.NamingAttributesList_THolder nameList, 
                                              globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllSupportingEquipmentNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, ptpName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllSupportingEquipmentNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentInventoryMgrOperations _self = (equipmentInventory.EquipmentInventoryMgrOperations)_so.servant;
        try {
          _self.getAllSupportingEquipmentNames(ptpName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
