package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::EquipmentIterator
 * <li> <b>Repository Id</b> IDL:equipmentInventory/EquipmentIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EquipmentIterator {
  ...
};
 * </pre>
 */
public class _EquipmentIteratorStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements EquipmentIterator {
  final public static java.lang.Class _opsClass = equipmentInventory.EquipmentIteratorOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:equipmentInventory/EquipmentIterator:1.0"
  };

  /**
   * <pre>
   *   boolean next_one (out equipmentInventory.Equipment_T equipment)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (equipmentInventory.Equipment_THolder equipment) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        boolean _result;
        try {
          _output = this._request("next_one", true);
          _input = this._invoke(_output);
          _result = _input.read_boolean();
          equipment.value = equipmentInventory.Equipment_THelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("next_one", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentIteratorOperations _self = (equipmentInventory.EquipmentIteratorOperations)_so.servant;
        try {
          return _self.next_one(equipment);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out equipmentInventory.EquipmentList_T equipmentList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         equipmentInventory.EquipmentList_THolder equipmentList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        boolean _result;
        try {
          _output = this._request("next_n", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          _result = _input.read_boolean();
          equipmentList.value = equipmentInventory.EquipmentList_THelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("next_n", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentIteratorOperations _self = (equipmentInventory.EquipmentIteratorOperations)_so.servant;
        try {
          return _self.next_n(how_many, equipmentList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        int _result;
        try {
          _output = this._request("getLength", true);
          _input = this._invoke(_output);
          _result = _input.read_ulong();
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getLength", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentIteratorOperations _self = (equipmentInventory.EquipmentIteratorOperations)_so.servant;
        try {
          return _self.getLength();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("destroy", true);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("destroy", _opsClass);
        if (_so == null) {
          continue;
        }
        final equipmentInventory.EquipmentIteratorOperations _self = (equipmentInventory.EquipmentIteratorOperations)_so.servant;
        try {
          _self.destroy();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
