package globaldefs;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/globaldefs.idl"
 * <li> <b>IDL Name</b>      ::globaldefs::ExceptionType_T
 * <li> <b>Repository Id</b> IDL:globaldefs/ExceptionType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ExceptionType_T {EXCPT_NOT_IMPLEMENTED, EXCPT_INTERNAL_ERROR,
                      EXCPT_INVALID_INPUT, EXCPT_TP_IN_USE,
                      EXCPT_TP_INVALID_ENDPOINT, EXCPT_ENTITY_NOT_FOUND,
                      EXCPT_TIMESLOT_IN_USE, EXCPT_PROTECTION_EFFORT_NOT_MET,
                      EXCPT_NOT_IN_VALID_STATE, EXCPT_UNABLE_TO_COMPLY,
                      EXCPT_TRAFFIC_DESCRIPTOR_IN_USE, EXCPT_NE_COMM_LOSS,
                      EXCPT_CAPACITY_EXCEEDED, EXCPT_TOO_MANY_OPEN_ITERATORS};
 * </pre>
 */
public final class ExceptionType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _EXCPT_NOT_IMPLEMENTED = 0;
  
  public static final int _EXCPT_INTERNAL_ERROR = 1;
  
  public static final int _EXCPT_INVALID_INPUT = 2;
  
  public static final int _EXCPT_TP_IN_USE = 3;
  
  public static final int _EXCPT_TP_INVALID_ENDPOINT = 4;
  
  public static final int _EXCPT_ENTITY_NOT_FOUND = 5;
  
  public static final int _EXCPT_TIMESLOT_IN_USE = 6;
  
  public static final int _EXCPT_PROTECTION_EFFORT_NOT_MET = 7;
  
  public static final int _EXCPT_NOT_IN_VALID_STATE = 8;
  
  public static final int _EXCPT_UNABLE_TO_COMPLY = 9;
  
  public static final int _EXCPT_TRAFFIC_DESCRIPTOR_IN_USE = 10;
  
  public static final int _EXCPT_NE_COMM_LOSS = 11;
  
  public static final int _EXCPT_CAPACITY_EXCEEDED = 12;
  
  public static final int _EXCPT_TOO_MANY_OPEN_ITERATORS = 13;

  
  public static final ExceptionType_T EXCPT_NOT_IMPLEMENTED = new ExceptionType_T(_EXCPT_NOT_IMPLEMENTED);
  
  public static final ExceptionType_T EXCPT_INTERNAL_ERROR = new ExceptionType_T(_EXCPT_INTERNAL_ERROR);
  
  public static final ExceptionType_T EXCPT_INVALID_INPUT = new ExceptionType_T(_EXCPT_INVALID_INPUT);
  
  public static final ExceptionType_T EXCPT_TP_IN_USE = new ExceptionType_T(_EXCPT_TP_IN_USE);
  
  public static final ExceptionType_T EXCPT_TP_INVALID_ENDPOINT = new ExceptionType_T(_EXCPT_TP_INVALID_ENDPOINT);
  
  public static final ExceptionType_T EXCPT_ENTITY_NOT_FOUND = new ExceptionType_T(_EXCPT_ENTITY_NOT_FOUND);
  
  public static final ExceptionType_T EXCPT_TIMESLOT_IN_USE = new ExceptionType_T(_EXCPT_TIMESLOT_IN_USE);
  
  public static final ExceptionType_T EXCPT_PROTECTION_EFFORT_NOT_MET = new ExceptionType_T(_EXCPT_PROTECTION_EFFORT_NOT_MET);
  
  public static final ExceptionType_T EXCPT_NOT_IN_VALID_STATE = new ExceptionType_T(_EXCPT_NOT_IN_VALID_STATE);
  
  public static final ExceptionType_T EXCPT_UNABLE_TO_COMPLY = new ExceptionType_T(_EXCPT_UNABLE_TO_COMPLY);
  
  public static final ExceptionType_T EXCPT_TRAFFIC_DESCRIPTOR_IN_USE = new ExceptionType_T(_EXCPT_TRAFFIC_DESCRIPTOR_IN_USE);
  
  public static final ExceptionType_T EXCPT_NE_COMM_LOSS = new ExceptionType_T(_EXCPT_NE_COMM_LOSS);
  
  public static final ExceptionType_T EXCPT_CAPACITY_EXCEEDED = new ExceptionType_T(_EXCPT_CAPACITY_EXCEEDED);
  
  public static final ExceptionType_T EXCPT_TOO_MANY_OPEN_ITERATORS = new ExceptionType_T(_EXCPT_TOO_MANY_OPEN_ITERATORS);

  protected ExceptionType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ExceptionType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return EXCPT_NOT_IMPLEMENTED;
      case 1: return EXCPT_INTERNAL_ERROR;
      case 2: return EXCPT_INVALID_INPUT;
      case 3: return EXCPT_TP_IN_USE;
      case 4: return EXCPT_TP_INVALID_ENDPOINT;
      case 5: return EXCPT_ENTITY_NOT_FOUND;
      case 6: return EXCPT_TIMESLOT_IN_USE;
      case 7: return EXCPT_PROTECTION_EFFORT_NOT_MET;
      case 8: return EXCPT_NOT_IN_VALID_STATE;
      case 9: return EXCPT_UNABLE_TO_COMPLY;
      case 10: return EXCPT_TRAFFIC_DESCRIPTOR_IN_USE;
      case 11: return EXCPT_NE_COMM_LOSS;
      case 12: return EXCPT_CAPACITY_EXCEEDED;
      case 13: return EXCPT_TOO_MANY_OPEN_ITERATORS;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "EXCPT_NOT_IMPLEMENTED";
      case 1: return "EXCPT_INTERNAL_ERROR";
      case 2: return "EXCPT_INVALID_INPUT";
      case 3: return "EXCPT_TP_IN_USE";
      case 4: return "EXCPT_TP_INVALID_ENDPOINT";
      case 5: return "EXCPT_ENTITY_NOT_FOUND";
      case 6: return "EXCPT_TIMESLOT_IN_USE";
      case 7: return "EXCPT_PROTECTION_EFFORT_NOT_MET";
      case 8: return "EXCPT_NOT_IN_VALID_STATE";
      case 9: return "EXCPT_UNABLE_TO_COMPLY";
      case 10: return "EXCPT_TRAFFIC_DESCRIPTOR_IN_USE";
      case 11: return "EXCPT_NE_COMM_LOSS";
      case 12: return "EXCPT_CAPACITY_EXCEEDED";
      case 13: return "EXCPT_TOO_MANY_OPEN_ITERATORS";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof globaldefs.ExceptionType_T
      ? this._value == ((globaldefs.ExceptionType_T)o)._value
      : false;
  }
}
