package managedElement;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElement.idl"
 * <li> <b>IDL Name</b>      ::managedElement::ManagedElementIterator
 * <li> <b>Repository Id</b> IDL:managedElement/ManagedElementIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementIterator {
  ...
};
 * </pre>
 */
public class ManagedElementIteratorPOATie extends ManagedElementIteratorPOA {
  private managedElement.ManagedElementIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public ManagedElementIteratorPOATie (final managedElement.ManagedElementIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public ManagedElementIteratorPOATie (final managedElement.ManagedElementIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public managedElement.ManagedElementIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final managedElement.ManagedElementIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out managedElement.ManagedElement_T me)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (managedElement.ManagedElement_THolder me) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(me);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out managedElement.ManagedElementList_T meList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         managedElement.ManagedElementList_THolder meList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, meList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
