package managedElement;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElement.idl"
 * <li> <b>IDL Name</b>      ::managedElement::ManagedElementType_T
 * <li> <b>Repository Id</b> IDL:managedElement/ManagedElementType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ManagedElementType_T {MET_ADM, MET_DCS, MET_END_TERMINAL,
                           MET_HARDWIRED_TERM, MET_REGEN, MET_OLT, MET_OLA,
                           MET_OADM, MET_OCS, MET_ATM, MET_SUBMARINE_PFE};
 * </pre>
 */
public final class ManagedElementType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _MET_ADM = 0;
  
  public static final int _MET_DCS = 1;
  
  public static final int _MET_END_TERMINAL = 2;
  
  public static final int _MET_HARDWIRED_TERM = 3;
  
  public static final int _MET_REGEN = 4;
  
  public static final int _MET_OLT = 5;
  
  public static final int _MET_OLA = 6;
  
  public static final int _MET_OADM = 7;
  
  public static final int _MET_OCS = 8;
  
  public static final int _MET_ATM = 9;
  
  public static final int _MET_SUBMARINE_PFE = 10;

  
  public static final ManagedElementType_T MET_ADM = new ManagedElementType_T(_MET_ADM);
  
  public static final ManagedElementType_T MET_DCS = new ManagedElementType_T(_MET_DCS);
  
  public static final ManagedElementType_T MET_END_TERMINAL = new ManagedElementType_T(_MET_END_TERMINAL);
  
  public static final ManagedElementType_T MET_HARDWIRED_TERM = new ManagedElementType_T(_MET_HARDWIRED_TERM);
  
  public static final ManagedElementType_T MET_REGEN = new ManagedElementType_T(_MET_REGEN);
  
  public static final ManagedElementType_T MET_OLT = new ManagedElementType_T(_MET_OLT);
  
  public static final ManagedElementType_T MET_OLA = new ManagedElementType_T(_MET_OLA);
  
  public static final ManagedElementType_T MET_OADM = new ManagedElementType_T(_MET_OADM);
  
  public static final ManagedElementType_T MET_OCS = new ManagedElementType_T(_MET_OCS);
  
  public static final ManagedElementType_T MET_ATM = new ManagedElementType_T(_MET_ATM);
  
  public static final ManagedElementType_T MET_SUBMARINE_PFE = new ManagedElementType_T(_MET_SUBMARINE_PFE);

  protected ManagedElementType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ManagedElementType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return MET_ADM;
      case 1: return MET_DCS;
      case 2: return MET_END_TERMINAL;
      case 3: return MET_HARDWIRED_TERM;
      case 4: return MET_REGEN;
      case 5: return MET_OLT;
      case 6: return MET_OLA;
      case 7: return MET_OADM;
      case 8: return MET_OCS;
      case 9: return MET_ATM;
      case 10: return MET_SUBMARINE_PFE;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "MET_ADM";
      case 1: return "MET_DCS";
      case 2: return "MET_END_TERMINAL";
      case 3: return "MET_HARDWIRED_TERM";
      case 4: return "MET_REGEN";
      case 5: return "MET_OLT";
      case 6: return "MET_OLA";
      case 7: return "MET_OADM";
      case 8: return "MET_OCS";
      case 9: return "MET_ATM";
      case 10: return "MET_SUBMARINE_PFE";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof managedElement.ManagedElementType_T
      ? this._value == ((managedElement.ManagedElementType_T)o)._value
      : false;
  }
}
