package managedElementManager;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElementMgr.idl"
 * <li> <b>IDL Name</b>      ::managedElementManager::ManagedElementMgr
 * <li> <b>Repository Id</b> IDL:managedElementManager/ManagedElementMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementMgr {
  ...
};
 * </pre>
 */
public abstract class ManagedElementMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, managedElementManager.ManagedElementMgrOperations {

  public managedElementManager.ManagedElementMgr _this () {
   return managedElementManager.ManagedElementMgrHelper.narrow(super._this_object());
  }

  public managedElementManager.ManagedElementMgr _this (org.omg.CORBA.ORB orb) {
    return managedElementManager.ManagedElementMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:managedElementManager/ManagedElementMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getAllManagedElements", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("getAllManagedElementNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("getContainingSubnetworks", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getAllPTPs", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getAllPTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
    _methods.put("getTP", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 5));
    _methods.put("getManagedElement", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 6));
    _methods.put("getContainedTPs", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 7));
    _methods.put("getContainedTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 8));
    _methods.put("getContainedActualTPs", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 9));
    _methods.put("getContainedActualTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 10));
    _methods.put("getContainingTPs", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 11));
    _methods.put("getContainingTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 12));
    _methods.put("getAllActiveAlarms", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 13));
    _methods.put("setTPData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 14));
    _methods.put("getAllCrossConnections", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 15));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return managedElementManager.ManagedElementMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (managedElementManager.ManagedElementMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        managedElement.ManagedElementList_THolder meList = new managedElement.ManagedElementList_THolder();
        managedElement.ManagedElementIteratorHolder meIt = new managedElement.ManagedElementIteratorHolder();
        _self.getAllManagedElements(how_many, meList, meIt);
        _output = _handler.createReply();
        managedElement.ManagedElementList_THelper.write(_output, meList.value);
        managedElement.ManagedElementIteratorHelper.write(_output, meIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllManagedElementNames(how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementName;
        managedElementName = globaldefs.NamingAttributes_THelper.read(_input);
        globaldefs.NamingAttributesList_THolder subnetNames = new globaldefs.NamingAttributesList_THolder();
        _self.getContainingSubnetworks(managedElementName, subnetNames);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, subnetNames.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementName;
        managedElementName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        terminationPoint.TerminationPointIteratorHolder tpIt = new terminationPoint.TerminationPointIteratorHolder();
        _self.getAllPTPs(managedElementName, layerRateList, how_many, tpList, tpIt);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
        terminationPoint.TerminationPointIteratorHelper.write(_output, tpIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementName;
        managedElementName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllPTPNames(managedElementName, layerRateList, how_many, nameList, 
                             nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 5: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        terminationPoint.TerminationPoint_THolder tp = new terminationPoint.TerminationPoint_THolder();
        _self.getTP(tpName, tp);
        _output = _handler.createReply();
        terminationPoint.TerminationPoint_THelper.write(_output, tp.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 6: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementName;
        managedElementName = globaldefs.NamingAttributes_THelper.read(_input);
        managedElement.ManagedElement_THolder managedElement = new managedElement.ManagedElement_THolder();
        _self.getManagedElement(managedElementName, managedElement);
        _output = _handler.createReply();
        managedElement.ManagedElement_THelper.write(_output, managedElement.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 7: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        terminationPoint.TerminationPointIteratorHolder tpIt = new terminationPoint.TerminationPointIteratorHolder();
        _self.getContainedTPs(tpName, layerRateList, how_many, tpList, tpIt);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
        terminationPoint.TerminationPointIteratorHelper.write(_output, tpIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 8: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getContainedTPNames(tpName, layerRateList, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 9: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        terminationPoint.TerminationPointIteratorHolder tpIt = new terminationPoint.TerminationPointIteratorHolder();
        _self.getContainedActualTPs(tpName, layerRateList, how_many, tpList, tpIt);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
        terminationPoint.TerminationPointIteratorHelper.write(_output, tpIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 10: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getContainedActualTPNames(tpName, layerRateList, how_many, nameList, 
                                        nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 11: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        _self.getContainingTPs(tpName, tpList);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 12: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        globaldefs.NamingAttributesList_THolder tpNameList = new globaldefs.NamingAttributesList_THolder();
        _self.getContainingTPNames(tpName, tpNameList);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, tpNameList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 13: {
      try {
        globaldefs.NameAndStringValue_T[] meName;
        meName = globaldefs.NamingAttributes_THelper.read(_input);
        java.lang.String[] excludeProbCauseList;
        excludeProbCauseList = notifications.ProbableCauseList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        notifications.EventList_THolder eventList = new notifications.EventList_THolder();
        notifications.EventIteratorHolder eventIt = new notifications.EventIteratorHolder();
        _self.getAllActiveAlarms(meName, excludeProbCauseList, how_many, eventList, 
                                 eventIt);
        _output = _handler.createReply();
        notifications.EventList_THelper.write(_output, eventList.value);
        notifications.EventIteratorHelper.write(_output, eventIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 14: {
      try {
        subnetworkConnection.TPData_T tpInfo;
        tpInfo = subnetworkConnection.TPData_THelper.read(_input);
        terminationPoint.TerminationPoint_THolder modifiedTP = new terminationPoint.TerminationPoint_THolder();
        _self.setTPData(tpInfo, modifiedTP);
        _output = _handler.createReply();
        terminationPoint.TerminationPoint_THelper.write(_output, modifiedTP.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 15: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementName;
        managedElementName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] connectionRateList;
        connectionRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        subnetworkConnection.CrossConnectList_THolder ccList = new subnetworkConnection.CrossConnectList_THolder();
        subnetworkConnection.CCIteratorHolder ccIt = new subnetworkConnection.CCIteratorHolder();
        _self.getAllCrossConnections(managedElementName, connectionRateList, how_many, 
                                     ccList, ccIt);
        _output = _handler.createReply();
        subnetworkConnection.CrossConnectList_THelper.write(_output, ccList.value);
        subnetworkConnection.CCIteratorHelper.write(_output, ccIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
}
