package managedElementManager;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElementMgr.idl"
 * <li> <b>IDL Name</b>      ::managedElementManager::ManagedElementMgr
 * <li> <b>Repository Id</b> IDL:managedElementManager/ManagedElementMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementMgr {
  ...
};
 * </pre>
 */
public class _ManagedElementMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements ManagedElementMgr {
  final public static java.lang.Class _opsClass = managedElementManager.ManagedElementMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:managedElementManager/ManagedElementMgr:1.0"
  };

  /**
   * <pre>
   *   void getAllManagedElements (in unsigned long how_many,
                              out managedElement.ManagedElementList_T meList,
                              out managedElement.ManagedElementIterator meIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllManagedElements (int how_many, 
                                     managedElement.ManagedElementList_THolder meList, 
                                     managedElement.ManagedElementIteratorHolder meIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllManagedElements", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          meList.value = managedElement.ManagedElementList_THelper.read(_input);
          meIt.value = managedElement.ManagedElementIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllManagedElements", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllManagedElements(how_many, meList, meIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllManagedElementNames (in unsigned long how_many,
                                  out globaldefs.NamingAttributesList_T nameList,
                                  out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllManagedElementNames (int how_many, 
                                         globaldefs.NamingAttributesList_THolder nameList, 
                                         globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllManagedElementNames", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllManagedElementNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllManagedElementNames(how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainingSubnetworks (in globaldefs.NamingAttributes_T managedElementName,
                                 out globaldefs.NamingAttributesList_T subnetNames)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainingSubnetworks (globaldefs.NameAndStringValue_T[] managedElementName, 
                                        globaldefs.NamingAttributesList_THolder subnetNames) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainingSubnetworks", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementName);
          _input = this._invoke(_output);
          subnetNames.value = globaldefs.NamingAttributesList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainingSubnetworks", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainingSubnetworks(managedElementName, subnetNames);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllPTPs (in globaldefs.NamingAttributes_T managedElementName,
                   in transmissionParameters.LayerRateList_T layerRateList,
                   in unsigned long how_many,
                   out terminationPoint.TerminationPointList_T tpList,
                   out terminationPoint.TerminationPointIterator tpIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllPTPs (globaldefs.NameAndStringValue_T[] managedElementName, 
                          short[] layerRateList, 
                          int how_many, 
                          terminationPoint.TerminationPointList_THolder tpList, 
                          terminationPoint.TerminationPointIteratorHolder tpIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllPTPs", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
          tpIt.value = terminationPoint.TerminationPointIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllPTPs", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllPTPs(managedElementName, layerRateList, how_many, tpList, 
                           tpIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllPTPNames (in globaldefs.NamingAttributes_T managedElementName,
                       in transmissionParameters.LayerRateList_T layerRateList,
                       in unsigned long how_many,
                       out globaldefs.NamingAttributesList_T nameList,
                       out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllPTPNames (globaldefs.NameAndStringValue_T[] managedElementName, 
                              short[] layerRateList, 
                              int how_many, 
                              globaldefs.NamingAttributesList_THolder nameList, 
                              globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllPTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllPTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllPTPNames(managedElementName, layerRateList, how_many, nameList, 
                               nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getTP (in globaldefs.NamingAttributes_T tpName,
              out terminationPoint.TerminationPoint_T tp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getTP (globaldefs.NameAndStringValue_T[] tpName, 
                     terminationPoint.TerminationPoint_THolder tp) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getTP", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _input = this._invoke(_output);
          tp.value = terminationPoint.TerminationPoint_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getTP", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getTP(tpName, tp);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getManagedElement (in globaldefs.NamingAttributes_T managedElementName,
                          out managedElement.ManagedElement_T managedElement)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getManagedElement (globaldefs.NameAndStringValue_T[] managedElementName, 
                                 managedElement.ManagedElement_THolder managedElement) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getManagedElement", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementName);
          _input = this._invoke(_output);
          managedElement.value = managedElement.ManagedElement_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getManagedElement", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getManagedElement(managedElementName, managedElement);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainedTPs (in globaldefs.NamingAttributes_T tpName,
                        in transmissionParameters.LayerRateList_T layerRateList,
                        in unsigned long how_many,
                        out terminationPoint.TerminationPointList_T tpList,
                        out terminationPoint.TerminationPointIterator tpIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainedTPs (globaldefs.NameAndStringValue_T[] tpName, 
                               short[] layerRateList, 
                               int how_many, 
                               terminationPoint.TerminationPointList_THolder tpList, 
                               terminationPoint.TerminationPointIteratorHolder tpIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainedTPs", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
          tpIt.value = terminationPoint.TerminationPointIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainedTPs", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainedTPs(tpName, layerRateList, how_many, tpList, tpIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainedTPNames (in globaldefs.NamingAttributes_T tpName,
                            in transmissionParameters.LayerRateList_T layerRateList,
                            in unsigned long how_many,
                            out globaldefs.NamingAttributesList_T nameList,
                            out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainedTPNames (globaldefs.NameAndStringValue_T[] tpName, 
                                   short[] layerRateList, 
                                   int how_many, 
                                   globaldefs.NamingAttributesList_THolder nameList, 
                                   globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainedTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainedTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainedTPNames(tpName, layerRateList, how_many, nameList, 
                                    nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainedActualTPs (in globaldefs.NamingAttributes_T tpName,
                              in transmissionParameters.LayerRateList_T layerRateList,
                              in unsigned long how_many,
                              out terminationPoint.TerminationPointList_T tpList,
                              out terminationPoint.TerminationPointIterator tpIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainedActualTPs (globaldefs.NameAndStringValue_T[] tpName, 
                                     short[] layerRateList, 
                                     int how_many, 
                                     terminationPoint.TerminationPointList_THolder tpList, 
                                     terminationPoint.TerminationPointIteratorHolder tpIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainedActualTPs", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
          tpIt.value = terminationPoint.TerminationPointIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainedActualTPs", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainedActualTPs(tpName, layerRateList, how_many, tpList, 
                                      tpIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainedActualTPNames (in globaldefs.NamingAttributes_T tpName,
                                  in transmissionParameters.LayerRateList_T layerRateList,
                                  in unsigned long how_many,
                                  out globaldefs.NamingAttributesList_T nameList,
                                  out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainedActualTPNames (globaldefs.NameAndStringValue_T[] tpName, 
                                         short[] layerRateList, 
                                         int how_many, 
                                         globaldefs.NamingAttributesList_THolder nameList, 
                                         globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainedActualTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainedActualTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainedActualTPNames(tpName, layerRateList, how_many, nameList, 
                                          nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainingTPs (in globaldefs.NamingAttributes_T tpName,
                         out terminationPoint.TerminationPointList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainingTPs (globaldefs.NameAndStringValue_T[] tpName, 
                                terminationPoint.TerminationPointList_THolder tpList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainingTPs", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainingTPs", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainingTPs(tpName, tpList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getContainingTPNames (in globaldefs.NamingAttributes_T tpName,
                             out globaldefs.NamingAttributesList_T tpNameList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getContainingTPNames (globaldefs.NameAndStringValue_T[] tpName, 
                                    globaldefs.NamingAttributesList_THolder tpNameList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getContainingTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _input = this._invoke(_output);
          tpNameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getContainingTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getContainingTPNames(tpName, tpNameList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllActiveAlarms (in globaldefs.NamingAttributes_T meName,
                           in notifications.ProbableCauseList_T excludeProbCauseList,
                           in unsigned long how_many,
                           out notifications.EventList_T eventList,
                           out notifications.EventIterator eventIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllActiveAlarms (globaldefs.NameAndStringValue_T[] meName, 
                                  java.lang.String[] excludeProbCauseList, 
                                  int how_many, 
                                  notifications.EventList_THolder eventList, 
                                  notifications.EventIteratorHolder eventIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllActiveAlarms", true);
          globaldefs.NamingAttributes_THelper.write(_output, meName);
          notifications.ProbableCauseList_THelper.write(_output, excludeProbCauseList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          eventList.value = notifications.EventList_THelper.read(_input);
          eventIt.value = notifications.EventIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllActiveAlarms", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllActiveAlarms(meName, excludeProbCauseList, how_many, eventList, 
                                   eventIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void setTPData (in subnetworkConnection.TPData_T tpInfo,
                  out terminationPoint.TerminationPoint_T modifiedTP)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setTPData (subnetworkConnection.TPData_T tpInfo, 
                         terminationPoint.TerminationPoint_THolder modifiedTP) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("setTPData", true);
          subnetworkConnection.TPData_THelper.write(_output, tpInfo);
          _input = this._invoke(_output);
          modifiedTP.value = terminationPoint.TerminationPoint_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("setTPData", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.setTPData(tpInfo, modifiedTP);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllCrossConnections (in globaldefs.NamingAttributes_T managedElementName,
                               in transmissionParameters.LayerRateList_T connectionRateList,
                               in unsigned long how_many,
                               out subnetworkConnection.CrossConnectList_T ccList,
                               out subnetworkConnection.CCIterator ccIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllCrossConnections (globaldefs.NameAndStringValue_T[] managedElementName, 
                                      short[] connectionRateList, 
                                      int how_many, 
                                      subnetworkConnection.CrossConnectList_THolder ccList, 
                                      subnetworkConnection.CCIteratorHolder ccIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllCrossConnections", true);
          globaldefs.NamingAttributes_THelper.write(_output, managedElementName);
          transmissionParameters.LayerRateList_THelper.write(_output, connectionRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          ccList.value = subnetworkConnection.CrossConnectList_THelper.read(_input);
          ccIt.value = subnetworkConnection.CCIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllCrossConnections", _opsClass);
        if (_so == null) {
          continue;
        }
        final managedElementManager.ManagedElementMgrOperations _self = (managedElementManager.ManagedElementMgrOperations)_so.servant;
        try {
          _self.getAllCrossConnections(managedElementName, connectionRateList, 
                                       how_many, ccList, ccIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
}
