package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::MultiLayerSubnetworkMgr
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/MultiLayerSubnetworkMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface MultiLayerSubnetworkMgr {
  ...
};
 * </pre>
 */
public abstract class MultiLayerSubnetworkMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations {

  public multiLayerSubnetwork.MultiLayerSubnetworkMgr _this () {
   return multiLayerSubnetwork.MultiLayerSubnetworkMgrHelper.narrow(super._this_object());
  }

  public multiLayerSubnetwork.MultiLayerSubnetworkMgr _this (org.omg.CORBA.ORB orb) {
    return multiLayerSubnetwork.MultiLayerSubnetworkMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:multiLayerSubnetwork/MultiLayerSubnetworkMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getAllManagedElements", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("getAllManagedElementNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("getMultiLayerSubnetwork", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getAllTopologicalLinks", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getAllEdgePoints", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
    _methods.put("getAssociatedTP", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 5));
    _methods.put("getTPGroupingRelationships", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 6));
    _methods.put("getAllSubnetworkConnections", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 7));
    _methods.put("getAllSubnetworkConnectionsWithTPList", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 8));
    _methods.put("getRoute", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 9));
    _methods.put("getSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 10));
    _methods.put("createSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 11));
    _methods.put("activateSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 12));
    _methods.put("createAndActivateSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 13));
    _methods.put("deactivateSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 14));
    _methods.put("deleteSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 15));
    _methods.put("deactivateAndDeleteSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 16));
    _methods.put("checkValidSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 17));
    _methods.put("getAllGTPs", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 18));
    _methods.put("bridgeSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 19));
    _methods.put("rollSNC", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 20));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return multiLayerSubnetwork.MultiLayerSubnetworkMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        managedElement.ManagedElementList_THolder meList = new managedElement.ManagedElementList_THolder();
        managedElement.ManagedElementIteratorHolder meIt = new managedElement.ManagedElementIteratorHolder();
        _self.getAllManagedElements(subnetName, how_many, meList, meIt);
        _output = _handler.createReply();
        managedElement.ManagedElementList_THelper.write(_output, meList.value);
        managedElement.ManagedElementIteratorHelper.write(_output, meIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllManagedElementNames(subnetName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        multiLayerSubnetwork.MultiLayerSubnetwork_THolder subnetwork = new multiLayerSubnetwork.MultiLayerSubnetwork_THolder();
        _self.getMultiLayerSubnetwork(subnetName, subnetwork);
        _output = _handler.createReply();
        multiLayerSubnetwork.MultiLayerSubnetwork_THelper.write(_output, subnetwork.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        topologicalLink.TopologicalLinkList_THolder topoList = new topologicalLink.TopologicalLinkList_THolder();
        topologicalLink.TopologicalLinkIteratorHolder topoIt = new topologicalLink.TopologicalLinkIteratorHolder();
        _self.getAllTopologicalLinks(subnetName, how_many, topoList, topoIt);
        _output = _handler.createReply();
        topologicalLink.TopologicalLinkList_THelper.write(_output, topoList.value);
        topologicalLink.TopologicalLinkIteratorHelper.write(_output, topoIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] layerRateList;
        layerRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        terminationPoint.TerminationPointIteratorHolder tpIt = new terminationPoint.TerminationPointIteratorHolder();
        _self.getAllEdgePoints(subnetName, layerRateList, how_many, tpList, tpIt);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
        terminationPoint.TerminationPointIteratorHelper.write(_output, tpIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 5: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        _self.getAssociatedTP(tpName, tpList);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 6: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        _self.getTPGroupingRelationships(tpName, nameList);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 7: {
      try {
        globaldefs.NameAndStringValue_T[] subnetName;
        subnetName = globaldefs.NamingAttributes_THelper.read(_input);
        short[] connectionRateList;
        connectionRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        subnetworkConnection.SubnetworkConnectionList_THolder sncList = new subnetworkConnection.SubnetworkConnectionList_THolder();
        subnetworkConnection.SNCIteratorHolder sncIt = new subnetworkConnection.SNCIteratorHolder();
        _self.getAllSubnetworkConnections(subnetName, connectionRateList, how_many, 
                                          sncList, sncIt);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnectionList_THelper.write(_output, sncList.value);
        subnetworkConnection.SNCIteratorHelper.write(_output, sncIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 8: {
      try {
        globaldefs.NameAndStringValue_T[][] tpNameList;
        tpNameList = globaldefs.NamingAttributesList_THelper.read(_input);
        short[] connectionRateList;
        connectionRateList = transmissionParameters.LayerRateList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        subnetworkConnection.SubnetworkConnectionList_THolder sncList = new subnetworkConnection.SubnetworkConnectionList_THolder();
        subnetworkConnection.SNCIteratorHolder sncIt = new subnetworkConnection.SNCIteratorHolder();
        _self.getAllSubnetworkConnectionsWithTPList(tpNameList, connectionRateList, 
                                                    how_many, sncList, sncIt);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnectionList_THelper.write(_output, sncList.value);
        subnetworkConnection.SNCIteratorHelper.write(_output, sncIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 9: {
      try {
        globaldefs.NameAndStringValue_T[] sncName;
        sncName = globaldefs.NamingAttributes_THelper.read(_input);
        subnetworkConnection.Route_THolder route = new subnetworkConnection.Route_THolder();
        _self.getRoute(sncName, route);
        _output = _handler.createReply();
        subnetworkConnection.Route_THelper.write(_output, route.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 10: {
      try {
        globaldefs.NameAndStringValue_T[] sncName;
        sncName = globaldefs.NamingAttributes_THelper.read(_input);
        subnetworkConnection.SubnetworkConnection_THolder snc = new subnetworkConnection.SubnetworkConnection_THolder();
        _self.getSNC(sncName, snc);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, snc.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 11: {
      try {
        subnetworkConnection.SNCCreateData_T createData;
        createData = subnetworkConnection.SNCCreateData_THelper.read(_input);
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        _self.createSNC(createData, theSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 12: {
      try {
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        _self.activateSNC(theSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 13: {
      try {
        subnetworkConnection.SNCCreateData_T createData;
        createData = subnetworkConnection.SNCCreateData_THelper.read(_input);
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        _self.createAndActivateSNC(createData, theSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 14: {
      try {
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        _self.deactivateSNC(theSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 15: {
      try {
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        boolean forced;
        forced = _input.read_boolean();
        _self.deleteSNC(theSNC, forced);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 16: {
      try {
        subnetworkConnection.SubnetworkConnection_THolder theSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        _self.deactivateAndDeleteSNC(theSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 17: {
      try {
        subnetworkConnection.SNCCreateData_T sncData;
        sncData = subnetworkConnection.SNCCreateData_THelper.read(_input);
        org.omg.CORBA.BooleanHolder valid = new org.omg.CORBA.BooleanHolder();
        _self.checkValidSNC(sncData, valid);
        _output = _handler.createReply();
        _output.write_boolean((boolean)valid.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 18: {
      try {
        globaldefs.NameAndStringValue_T[] subnetworkName;
        subnetworkName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        terminationPoint.TerminationPointList_THolder tpList = new terminationPoint.TerminationPointList_THolder();
        terminationPoint.TerminationPointIteratorHolder tpIt = new terminationPoint.TerminationPointIteratorHolder();
        _self.getAllGTPs(subnetworkName, how_many, tpList, tpIt);
        _output = _handler.createReply();
        terminationPoint.TerminationPointList_THelper.write(_output, tpList.value);
        terminationPoint.TerminationPointIteratorHelper.write(_output, tpIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 19: {
      try {
        subnetworkConnection.SubnetworkConnection_T initialSNC;
        initialSNC = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        subnetworkConnection.SNCCreateData_T bridgeCreateData;
        bridgeCreateData = subnetworkConnection.SNCCreateData_THelper.read(_input);
        subnetworkConnection.SubnetworkConnection_THolder bridgeSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        _self.bridgeSNC(initialSNC, bridgeCreateData, bridgeSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, bridgeSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 20: {
      try {
        subnetworkConnection.SubnetworkConnection_THolder initialSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        initialSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        subnetworkConnection.GradesOfImpact_T rollCriteria;
        rollCriteria = subnetworkConnection.GradesOfImpact_THelper.read(_input);
        subnetworkConnection.SubnetworkConnection_THolder rolledSNC = new subnetworkConnection.SubnetworkConnection_THolder();
        rolledSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        _self.rollSNC(initialSNC, rollCriteria, rolledSNC);
        _output = _handler.createReply();
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, initialSNC.value);
        subnetworkConnection.SubnetworkConnection_THelper.write(_output, rolledSNC.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
