package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::MultiLayerSubnetwork_T
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/MultiLayerSubnetwork_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct MultiLayerSubnetwork_T {
  ...
};
 * </pre>
 */
public final class MultiLayerSubnetwork_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public multiLayerSubnetwork.Technology_T technology;
  
  public multiLayerSubnetwork.Topology_T subnetworkType;
  
  public short[] supportedRates;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public MultiLayerSubnetwork_T () {
  }

  public MultiLayerSubnetwork_T (final globaldefs.NameAndStringValue_T[] name, 
                                 final java.lang.String userLabel, 
                                 final java.lang.String nativeEMSName, 
                                 final java.lang.String owner, 
                                 final multiLayerSubnetwork.Technology_T technology, 
                                 final multiLayerSubnetwork.Topology_T subnetworkType, 
                                 final short[] supportedRates, 
                                 final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.technology = technology;
    this.subnetworkType = subnetworkType;
    this.supportedRates = supportedRates;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct multiLayerSubnetwork.MultiLayerSubnetwork_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("multiLayerSubnetwork.Technology_T technology=");
    _ret.append(technology);
    _ret.append(",\n");
    _ret.append("multiLayerSubnetwork.Topology_T subnetworkType=");
    _ret.append(subnetworkType);
    _ret.append(",\n");
    _ret.append("short[] supportedRates=");
    _ret.append("{");
    if (supportedRates == null) {
      _ret.append(supportedRates);
    } else {
      for (int $counter1 = 0; $counter1 < supportedRates.length; $counter1++) {
        _ret.append(supportedRates[$counter1]);
        if ($counter1 < supportedRates.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter2 = 0; $counter2 < additionalInfo.length; $counter2++) {
        _ret.append(additionalInfo[$counter2]);
        if ($counter2 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof multiLayerSubnetwork.MultiLayerSubnetwork_T) {
      _cmpMap.put(_currentThread, o);
      final multiLayerSubnetwork.MultiLayerSubnetwork_T obj = (multiLayerSubnetwork.MultiLayerSubnetwork_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter3 = 0; res && $counter3 < this.name.length; $counter3++) {
                res = this.name[$counter3] == obj.name[$counter3] ||
                 (this.name[$counter3] != null && obj.name[$counter3] != null && this.name[$counter3].equals(obj.name[$counter3]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.technology == obj.technology ||
         (this.technology != null && obj.technology != null && this.technology.equals(obj.technology));
        if (!res) break;
        res = this.subnetworkType == obj.subnetworkType ||
         (this.subnetworkType != null && obj.subnetworkType != null && this.subnetworkType.equals(obj.subnetworkType));
        if (!res) break;
          if (res = (this.supportedRates.length == obj.supportedRates.length)) {
            for (int $counter4 = 0; res && $counter4 < this.supportedRates.length; $counter4++) {
                res = this.supportedRates[$counter4] == obj.supportedRates[$counter4];
            }
          }
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter5 = 0; res && $counter5 < this.additionalInfo.length; $counter5++) {
              res = this.additionalInfo[$counter5] == obj.additionalInfo[$counter5] ||
               (this.additionalInfo[$counter5] != null && obj.additionalInfo[$counter5] != null && this.additionalInfo[$counter5].equals(obj.additionalInfo[$counter5]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
