package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::MultiLayerSubnetwork_T
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/MultiLayerSubnetwork_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct MultiLayerSubnetwork_T {
  ...
};
 * </pre>
 */
public final class MultiLayerSubnetwork_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static multiLayerSubnetwork.MultiLayerSubnetwork_T read (final org.omg.CORBA.portable.InputStream _input) {
    final multiLayerSubnetwork.MultiLayerSubnetwork_T _result = new multiLayerSubnetwork.MultiLayerSubnetwork_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.technology = multiLayerSubnetwork.Technology_THelper.read(_input);
    _result.subnetworkType = multiLayerSubnetwork.Topology_THelper.read(_input);
    _result.supportedRates = transmissionParameters.LayerRateList_THelper.read(_input);
    _result.additionalInfo = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final multiLayerSubnetwork.MultiLayerSubnetwork_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    multiLayerSubnetwork.Technology_THelper.write(_output, _vis_value.technology);
    multiLayerSubnetwork.Topology_THelper.write(_output, _vis_value.subnetworkType);
    transmissionParameters.LayerRateList_THelper.write(_output, _vis_value.supportedRates);
    globaldefs.NVSList_THelper.write(_output, _vis_value.additionalInfo);
  }

  public static void insert (final org.omg.CORBA.Any any, final multiLayerSubnetwork.MultiLayerSubnetwork_T _vis_value) {
    any.insert_Streamable(new multiLayerSubnetwork.MultiLayerSubnetwork_THolder(_vis_value));
  }

  public static multiLayerSubnetwork.MultiLayerSubnetwork_T extract (final org.omg.CORBA.Any any) {
    multiLayerSubnetwork.MultiLayerSubnetwork_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      multiLayerSubnetwork.MultiLayerSubnetwork_THolder _vis_holder = new multiLayerSubnetwork.MultiLayerSubnetwork_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = multiLayerSubnetwork.MultiLayerSubnetwork_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[8];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("technology", multiLayerSubnetwork.Technology_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("subnetworkType", multiLayerSubnetwork.Topology_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("supportedRates", transmissionParameters.LayerRateList_THelper.type(), null);
          members[7] = new org.omg.CORBA.StructMember("additionalInfo", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "MultiLayerSubnetwork_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:multiLayerSubnetwork/MultiLayerSubnetwork_T:1.0";
  }
}
