package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::SubnetworkIterator
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/SubnetworkIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface SubnetworkIterator {
  ...
};
 * </pre>
 */
public class SubnetworkIteratorPOATie extends SubnetworkIteratorPOA {
  private multiLayerSubnetwork.SubnetworkIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public SubnetworkIteratorPOATie (final multiLayerSubnetwork.SubnetworkIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public SubnetworkIteratorPOATie (final multiLayerSubnetwork.SubnetworkIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public multiLayerSubnetwork.SubnetworkIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final multiLayerSubnetwork.SubnetworkIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out multiLayerSubnetwork.MultiLayerSubnetwork_T subnetwork)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (multiLayerSubnetwork.MultiLayerSubnetwork_THolder subnetwork) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(subnetwork);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out multiLayerSubnetwork.SubnetworkList_T subnetworkList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         multiLayerSubnetwork.SubnetworkList_THolder subnetworkList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, subnetworkList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
