package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::Technology_T
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/Technology_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum Technology_T {TECH_NA, TECH_PDH_ASYNC, TECH_SDH_SONET, TECH_DWDM,
                   TECH_ATM, TECH_IP};
 * </pre>
 */
public final class Technology_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _TECH_NA = 0;
  
  public static final int _TECH_PDH_ASYNC = 1;
  
  public static final int _TECH_SDH_SONET = 2;
  
  public static final int _TECH_DWDM = 3;
  
  public static final int _TECH_ATM = 4;
  
  public static final int _TECH_IP = 5;

  
  public static final Technology_T TECH_NA = new Technology_T(_TECH_NA);
  
  public static final Technology_T TECH_PDH_ASYNC = new Technology_T(_TECH_PDH_ASYNC);
  
  public static final Technology_T TECH_SDH_SONET = new Technology_T(_TECH_SDH_SONET);
  
  public static final Technology_T TECH_DWDM = new Technology_T(_TECH_DWDM);
  
  public static final Technology_T TECH_ATM = new Technology_T(_TECH_ATM);
  
  public static final Technology_T TECH_IP = new Technology_T(_TECH_IP);

  protected Technology_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static Technology_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return TECH_NA;
      case 1: return TECH_PDH_ASYNC;
      case 2: return TECH_SDH_SONET;
      case 3: return TECH_DWDM;
      case 4: return TECH_ATM;
      case 5: return TECH_IP;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "TECH_NA";
      case 1: return "TECH_PDH_ASYNC";
      case 2: return "TECH_SDH_SONET";
      case 3: return "TECH_DWDM";
      case 4: return "TECH_ATM";
      case 5: return "TECH_IP";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof multiLayerSubnetwork.Technology_T
      ? this._value == ((multiLayerSubnetwork.Technology_T)o)._value
      : false;
  }
}
