package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::MultiLayerSubnetworkMgr
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/MultiLayerSubnetworkMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface MultiLayerSubnetworkMgr {
  ...
};
 * </pre>
 */
public class _MultiLayerSubnetworkMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements MultiLayerSubnetworkMgr {
  final public static java.lang.Class _opsClass = multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:multiLayerSubnetwork/MultiLayerSubnetworkMgr:1.0"
  };

  /**
   * <pre>
   *   void getAllManagedElements (in globaldefs.NamingAttributes_T subnetName,
                              in unsigned long how_many,
                              out managedElement.ManagedElementList_T meList,
                              out managedElement.ManagedElementIterator meIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllManagedElements (globaldefs.NameAndStringValue_T[] subnetName, 
                                     int how_many, 
                                     managedElement.ManagedElementList_THolder meList, 
                                     managedElement.ManagedElementIteratorHolder meIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllManagedElements", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          meList.value = managedElement.ManagedElementList_THelper.read(_input);
          meIt.value = managedElement.ManagedElementIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllManagedElements", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllManagedElements(subnetName, how_many, meList, meIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllManagedElementNames (in globaldefs.NamingAttributes_T subnetName,
                                  in unsigned long how_many,
                                  out globaldefs.NamingAttributesList_T nameList,
                                  out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllManagedElementNames (globaldefs.NameAndStringValue_T[] subnetName, 
                                         int how_many, 
                                         globaldefs.NamingAttributesList_THolder nameList, 
                                         globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllManagedElementNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllManagedElementNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllManagedElementNames(subnetName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getMultiLayerSubnetwork (in globaldefs.NamingAttributes_T subnetName,
                                out multiLayerSubnetwork.MultiLayerSubnetwork_T subnetwork)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getMultiLayerSubnetwork (globaldefs.NameAndStringValue_T[] subnetName, 
                                       multiLayerSubnetwork.MultiLayerSubnetwork_THolder subnetwork) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getMultiLayerSubnetwork", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          _input = this._invoke(_output);
          subnetwork.value = multiLayerSubnetwork.MultiLayerSubnetwork_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getMultiLayerSubnetwork", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getMultiLayerSubnetwork(subnetName, subnetwork);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllTopologicalLinks (in globaldefs.NamingAttributes_T subnetName,
                               in unsigned long how_many,
                               out topologicalLink.TopologicalLinkList_T topoList,
                               out topologicalLink.TopologicalLinkIterator topoIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopologicalLinks (globaldefs.NameAndStringValue_T[] subnetName, 
                                      int how_many, 
                                      topologicalLink.TopologicalLinkList_THolder topoList, 
                                      topologicalLink.TopologicalLinkIteratorHolder topoIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTopologicalLinks", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          topoList.value = topologicalLink.TopologicalLinkList_THelper.read(_input);
          topoIt.value = topologicalLink.TopologicalLinkIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTopologicalLinks", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllTopologicalLinks(subnetName, how_many, topoList, topoIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllEdgePoints (in globaldefs.NamingAttributes_T subnetName,
                         in transmissionParameters.LayerRateList_T layerRateList,
                         in unsigned long how_many,
                         out terminationPoint.TerminationPointList_T tpList,
                         out terminationPoint.TerminationPointIterator tpIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEdgePoints (globaldefs.NameAndStringValue_T[] subnetName, 
                                short[] layerRateList, 
                                int how_many, 
                                terminationPoint.TerminationPointList_THolder tpList, 
                                terminationPoint.TerminationPointIteratorHolder tpIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllEdgePoints", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          transmissionParameters.LayerRateList_THelper.write(_output, layerRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
          tpIt.value = terminationPoint.TerminationPointIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllEdgePoints", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllEdgePoints(subnetName, layerRateList, how_many, tpList, tpIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAssociatedTP (in globaldefs.NamingAttributes_T tpName,
                        out terminationPoint.TerminationPointList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAssociatedTP (globaldefs.NameAndStringValue_T[] tpName, 
                               terminationPoint.TerminationPointList_THolder tpList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAssociatedTP", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAssociatedTP", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAssociatedTP(tpName, tpList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getTPGroupingRelationships (in globaldefs.NamingAttributes_T tpName,
                                   out globaldefs.NamingAttributesList_T nameList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getTPGroupingRelationships (globaldefs.NameAndStringValue_T[] tpName, 
                                          globaldefs.NamingAttributesList_THolder nameList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getTPGroupingRelationships", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getTPGroupingRelationships", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getTPGroupingRelationships(tpName, nameList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllSubnetworkConnections (in globaldefs.NamingAttributes_T subnetName,
                                    in transmissionParameters.LayerRateList_T connectionRateList,
                                    in unsigned long how_many,
                                    out subnetworkConnection.SubnetworkConnectionList_T sncList,
                                    out subnetworkConnection.SNCIterator sncIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllSubnetworkConnections (globaldefs.NameAndStringValue_T[] subnetName, 
                                           short[] connectionRateList, 
                                           int how_many, 
                                           subnetworkConnection.SubnetworkConnectionList_THolder sncList, 
                                           subnetworkConnection.SNCIteratorHolder sncIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllSubnetworkConnections", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetName);
          transmissionParameters.LayerRateList_THelper.write(_output, connectionRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          sncList.value = subnetworkConnection.SubnetworkConnectionList_THelper.read(_input);
          sncIt.value = subnetworkConnection.SNCIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllSubnetworkConnections", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllSubnetworkConnections(subnetName, connectionRateList, how_many, 
                                            sncList, sncIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllSubnetworkConnectionsWithTPList (in globaldefs.NamingAttributesList_T tpNameList,
                                              in transmissionParameters.LayerRateList_T connectionRateList,
                                              in unsigned long how_many,
                                              out subnetworkConnection.SubnetworkConnectionList_T sncList,
                                              out subnetworkConnection.SNCIterator sncIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllSubnetworkConnectionsWithTPList (globaldefs.NameAndStringValue_T[][] tpNameList, 
                                                     short[] connectionRateList, 
                                                     int how_many, 
                                                     subnetworkConnection.SubnetworkConnectionList_THolder sncList, 
                                                     subnetworkConnection.SNCIteratorHolder sncIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllSubnetworkConnectionsWithTPList", true);
          globaldefs.NamingAttributesList_THelper.write(_output, tpNameList);
          transmissionParameters.LayerRateList_THelper.write(_output, connectionRateList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          sncList.value = subnetworkConnection.SubnetworkConnectionList_THelper.read(_input);
          sncIt.value = subnetworkConnection.SNCIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllSubnetworkConnectionsWithTPList", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllSubnetworkConnectionsWithTPList(tpNameList, connectionRateList, 
                                                      how_many, sncList, sncIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getRoute (in globaldefs.NamingAttributes_T sncName,
                 out subnetworkConnection.Route_T route)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getRoute (globaldefs.NameAndStringValue_T[] sncName, 
                        subnetworkConnection.Route_THolder route) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getRoute", true);
          globaldefs.NamingAttributes_THelper.write(_output, sncName);
          _input = this._invoke(_output);
          route.value = subnetworkConnection.Route_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getRoute", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getRoute(sncName, route);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getSNC (in globaldefs.NamingAttributes_T sncName,
               out subnetworkConnection.SubnetworkConnection_T snc)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getSNC (globaldefs.NameAndStringValue_T[] sncName, 
                      subnetworkConnection.SubnetworkConnection_THolder snc) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getSNC", true);
          globaldefs.NamingAttributes_THelper.write(_output, sncName);
          _input = this._invoke(_output);
          snc.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getSNC(sncName, snc);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void createSNC (in subnetworkConnection.SNCCreateData_T createData,
                  out subnetworkConnection.SubnetworkConnection_T theSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void createSNC (subnetworkConnection.SNCCreateData_T createData, 
                         subnetworkConnection.SubnetworkConnection_THolder theSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("createSNC", true);
          subnetworkConnection.SNCCreateData_THelper.write(_output, createData);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("createSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.createSNC(createData, theSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void activateSNC (inout subnetworkConnection.SubnetworkConnection_T theSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void activateSNC (subnetworkConnection.SubnetworkConnection_THolder theSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("activateSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("activateSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.activateSNC(theSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void createAndActivateSNC (in subnetworkConnection.SNCCreateData_T createData,
                             out subnetworkConnection.SubnetworkConnection_T theSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void createAndActivateSNC (subnetworkConnection.SNCCreateData_T createData, 
                                    subnetworkConnection.SubnetworkConnection_THolder theSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("createAndActivateSNC", true);
          subnetworkConnection.SNCCreateData_THelper.write(_output, createData);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("createAndActivateSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.createAndActivateSNC(createData, theSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void deactivateSNC (inout subnetworkConnection.SubnetworkConnection_T theSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deactivateSNC (subnetworkConnection.SubnetworkConnection_THolder theSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("deactivateSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("deactivateSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.deactivateSNC(theSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void deleteSNC (inout subnetworkConnection.SubnetworkConnection_T theSNC,
                  in boolean forced)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deleteSNC (subnetworkConnection.SubnetworkConnection_THolder theSNC, 
                         boolean forced) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("deleteSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
          _output.write_boolean((boolean)forced);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("deleteSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.deleteSNC(theSNC, forced);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void deactivateAndDeleteSNC (inout subnetworkConnection.SubnetworkConnection_T theSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deactivateAndDeleteSNC (subnetworkConnection.SubnetworkConnection_THolder theSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("deactivateAndDeleteSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, theSNC.value);
          _input = this._invoke(_output);
          theSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("deactivateAndDeleteSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.deactivateAndDeleteSNC(theSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void checkValidSNC (in subnetworkConnection.SNCCreateData_T sncData,
                      out boolean valid)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void checkValidSNC (subnetworkConnection.SNCCreateData_T sncData, 
                             org.omg.CORBA.BooleanHolder valid) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("checkValidSNC", true);
          subnetworkConnection.SNCCreateData_THelper.write(_output, sncData);
          _input = this._invoke(_output);
          valid.value = _input.read_boolean();
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("checkValidSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.checkValidSNC(sncData, valid);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllGTPs (in globaldefs.NamingAttributes_T subnetworkName,
                   in unsigned long how_many,
                   out terminationPoint.TerminationPointList_T tpList,
                   out terminationPoint.TerminationPointIterator tpIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllGTPs (globaldefs.NameAndStringValue_T[] subnetworkName, 
                          int how_many, 
                          terminationPoint.TerminationPointList_THolder tpList, 
                          terminationPoint.TerminationPointIteratorHolder tpIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllGTPs", true);
          globaldefs.NamingAttributes_THelper.write(_output, subnetworkName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          tpList.value = terminationPoint.TerminationPointList_THelper.read(_input);
          tpIt.value = terminationPoint.TerminationPointIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllGTPs", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.getAllGTPs(subnetworkName, how_many, tpList, tpIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void bridgeSNC (in subnetworkConnection.SubnetworkConnection_T initialSNC,
                  in subnetworkConnection.SNCCreateData_T bridgeCreateData,
                  out subnetworkConnection.SubnetworkConnection_T bridgeSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void bridgeSNC (subnetworkConnection.SubnetworkConnection_T initialSNC, 
                         subnetworkConnection.SNCCreateData_T bridgeCreateData, 
                         subnetworkConnection.SubnetworkConnection_THolder bridgeSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("bridgeSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, initialSNC);
          subnetworkConnection.SNCCreateData_THelper.write(_output, bridgeCreateData);
          _input = this._invoke(_output);
          bridgeSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("bridgeSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.bridgeSNC(initialSNC, bridgeCreateData, bridgeSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void rollSNC (inout subnetworkConnection.SubnetworkConnection_T initialSNC,
                in subnetworkConnection.GradesOfImpact_T rollCriteria,
                inout subnetworkConnection.SubnetworkConnection_T rolledSNC)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void rollSNC (subnetworkConnection.SubnetworkConnection_THolder initialSNC, 
                       subnetworkConnection.GradesOfImpact_T rollCriteria, 
                       subnetworkConnection.SubnetworkConnection_THolder rolledSNC) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("rollSNC", true);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, initialSNC.value);
          subnetworkConnection.GradesOfImpact_THelper.write(_output, rollCriteria);
          subnetworkConnection.SubnetworkConnection_THelper.write(_output, rolledSNC.value);
          _input = this._invoke(_output);
          initialSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
          rolledSNC.value = subnetworkConnection.SubnetworkConnection_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("rollSNC", _opsClass);
        if (_so == null) {
          continue;
        }
        final multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations _self = (multiLayerSubnetwork.MultiLayerSubnetworkMgrOperations)_so.servant;
        try {
          _self.rollSNC(initialSNC, rollCriteria, rolledSNC);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
