package networkR1;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/networkR1.idl"
 * <li> <b>IDL Name</b>      ::nutworkR1::NetworkR1
 * <li> <b>Repository Id</b> IDL:nutworkR1/NetworkR1:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NetworkR1 {
  ...
};
 * </pre>
 */
public abstract class NetworkR1POA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, networkR1.NetworkR1Operations {

  public networkR1.NetworkR1 _this () {
   return networkR1.NetworkR1Helper.narrow(super._this_object());
  }

  public networkR1.NetworkR1 _this (org.omg.CORBA.ORB orb) {
    return networkR1.NetworkR1Helper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:nutworkR1/NetworkR1:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("_get_name", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("_get_emsVersion", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("_get_type", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getAllTopLevelSubnetworks", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getAllTopLevelSubnetworkNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
    _methods.put("getAllTopLevelTopologicalLinks", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 5));
    _methods.put("getAllTopLevelTopologicalLinkNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 6));
    _methods.put("getAllEMSActiveAlarms", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 7));
    _methods.put("getMultiLayerSubnetworkMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 8));
    _methods.put("getManagedElementMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 9));
    _methods.put("getEquipmentInventoryMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 10));
    _methods.put("getPerformanceManagementMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 11));
    _methods.put("getProtectionMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 12));
    _methods.put("getTrafficDescriptorMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 13));
    _methods.put("getGuiCutThroughMgr", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 14));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return networkR1.NetworkR1POA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (networkR1.NetworkR1Operations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
        java.lang.String _result = _self.name();
        _output = _handler.createReply();
        _output.write_string((java.lang.String)_result);
        return _output;
      }
      case 1: {
        java.lang.String _result = _self.emsVersion();
        _output = _handler.createReply();
        _output.write_string((java.lang.String)_result);
        return _output;
      }
      case 2: {
        java.lang.String _result = _self.type();
        _output = _handler.createReply();
        _output.write_string((java.lang.String)_result);
        return _output;
      }
      case 3: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        multiLayerSubnetwork.SubnetworkList_THolder sList = new multiLayerSubnetwork.SubnetworkList_THolder();
        multiLayerSubnetwork.SubnetworkIteratorHolder sIt = new multiLayerSubnetwork.SubnetworkIteratorHolder();
        _self.getAllTopLevelSubnetworks(how_many, sList, sIt);
        _output = _handler.createReply();
        multiLayerSubnetwork.SubnetworkList_THelper.write(_output, sList.value);
        multiLayerSubnetwork.SubnetworkIteratorHelper.write(_output, sIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllTopLevelSubnetworkNames(how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 5: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        topologicalLink.TopologicalLinkList_THolder topoList = new topologicalLink.TopologicalLinkList_THolder();
        topologicalLink.TopologicalLinkIteratorHolder topoIt = new topologicalLink.TopologicalLinkIteratorHolder();
        _self.getAllTopLevelTopologicalLinks(how_many, topoList, topoIt);
        _output = _handler.createReply();
        topologicalLink.TopologicalLinkList_THelper.write(_output, topoList.value);
        topologicalLink.TopologicalLinkIteratorHelper.write(_output, topoIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 6: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllTopLevelTopologicalLinkNames(how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 7: {
      try {
        java.lang.String[] excludeProbCauseList;
        excludeProbCauseList = notifications.ProbableCauseList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        notifications.EventList_THolder eventList = new notifications.EventList_THolder();
        notifications.EventIteratorHolder eventIt = new notifications.EventIteratorHolder();
        _self.getAllEMSActiveAlarms(excludeProbCauseList, how_many, eventList, 
                                    eventIt);
        _output = _handler.createReply();
        notifications.EventList_THelper.write(_output, eventList.value);
        notifications.EventIteratorHelper.write(_output, eventIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 8: {
      try {
        multiLayerSubnetwork.MultiLayerSubnetworkMgr _result = _self.getMultiLayerSubnetworkMgr();
        _output = _handler.createReply();
        multiLayerSubnetwork.MultiLayerSubnetworkMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 9: {
      try {
        managedElementManager.ManagedElementMgr _result = _self.getManagedElementMgr();
        _output = _handler.createReply();
        managedElementManager.ManagedElementMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 10: {
      try {
        equipmentInventory.EquipmentInventoryMgr _result = _self.getEquipmentInventoryMgr();
        _output = _handler.createReply();
        equipmentInventory.EquipmentInventoryMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 11: {
      try {
        performance.PerformanceManagementMgr _result = _self.getPerformanceManagementMgr();
        _output = _handler.createReply();
        performance.PerformanceManagementMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 12: {
      try {
        protection.ProtectionMgr _result = _self.getProtectionMgr();
        _output = _handler.createReply();
        protection.ProtectionMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 13: {
      try {
        trafficDescriptor.TrafficDescriptorMgr _result = _self.getTrafficDescriptorMgr();
        _output = _handler.createReply();
        trafficDescriptor.TrafficDescriptorMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 14: {
      try {
        guiCutThrough.GuiCutThroughMgr _result = _self.getGuiCutThroughMgr();
        _output = _handler.createReply();
        guiCutThrough.GuiCutThroughMgrHelper.write(_output, _result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
