package networkR1;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/networkR1.idl"
 * <li> <b>IDL Name</b>      ::nutworkR1::NetworkR1
 * <li> <b>Repository Id</b> IDL:nutworkR1/NetworkR1:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NetworkR1 {
  ...
};
 * </pre>
 */
public class NetworkR1POATie extends NetworkR1POA {
  private networkR1.NetworkR1Operations _delegate;
  private org.omg.PortableServer.POA _poa;

  public NetworkR1POATie (final networkR1.NetworkR1Operations _delegate) {
    this._delegate = _delegate;
  }

  public NetworkR1POATie (final networkR1.NetworkR1Operations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public networkR1.NetworkR1Operations _delegate () {
    return this._delegate;
  }

  public void _delegate (final networkR1.NetworkR1Operations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   readonly attribute string name;
   * </pre>
   */
  public java.lang.String name () {
    return this._delegate.name();
  }

  /**
   * <pre>
   *   readonly attribute string emsVersion;
   * </pre>
   */
  public java.lang.String emsVersion () {
    return this._delegate.emsVersion();
  }

  /**
   * <pre>
   *   readonly attribute string type;
   * </pre>
   */
  public java.lang.String type () {
    return this._delegate.type();
  }

  /**
   * <pre>
   *   void getAllTopLevelSubnetworks (in unsigned long how_many,
                                  out multiLayerSubnetwork.SubnetworkList_T sList,
                                  out multiLayerSubnetwork.SubnetworkIterator sIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworks (int how_many, 
                                         multiLayerSubnetwork.SubnetworkList_THolder sList, 
                                         multiLayerSubnetwork.SubnetworkIteratorHolder sIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllTopLevelSubnetworks(how_many, sList, sIt);
  }

  /**
   * <pre>
   *   void getAllTopLevelSubnetworkNames (in unsigned long how_many,
                                      out globaldefs.NamingAttributesList_T nameList,
                                      out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworkNames (int how_many, 
                                             globaldefs.NamingAttributesList_THolder nameList, 
                                             globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllTopLevelSubnetworkNames(how_many, nameList, nameIt);
  }

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinks (in unsigned long how_many,
                                       out topologicalLink.TopologicalLinkList_T topoList,
                                       out topologicalLink.TopologicalLinkIterator topoIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinks (int how_many, 
                                              topologicalLink.TopologicalLinkList_THolder topoList, 
                                              topologicalLink.TopologicalLinkIteratorHolder topoIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllTopLevelTopologicalLinks(how_many, topoList, topoIt);
  }

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinkNames (in unsigned long how_many,
                                           out globaldefs.NamingAttributesList_T nameList,
                                           out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinkNames (int how_many, 
                                                  globaldefs.NamingAttributesList_THolder nameList, 
                                                  globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllTopLevelTopologicalLinkNames(how_many, nameList, nameIt);
  }

  /**
   * <pre>
   *   void getAllEMSActiveAlarms (in notifications.ProbableCauseList_T excludeProbCauseList,
                              in unsigned long how_many,
                              out notifications.EventList_T eventList,
                              out notifications.EventIterator eventIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEMSActiveAlarms (java.lang.String[] excludeProbCauseList, 
                                     int how_many, 
                                     notifications.EventList_THolder eventList, 
                                     notifications.EventIteratorHolder eventIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllEMSActiveAlarms(excludeProbCauseList, how_many, eventList, 
                                         eventIt);
  }

  /**
   * <pre>
   *   multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getMultiLayerSubnetworkMgr();
  }

  /**
   * <pre>
   *   managedElementManager.ManagedElementMgr getManagedElementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public managedElementManager.ManagedElementMgr getManagedElementMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getManagedElementMgr();
  }

  /**
   * <pre>
   *   equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getEquipmentInventoryMgr();
  }

  /**
   * <pre>
   *   performance.PerformanceManagementMgr getPerformanceManagementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public performance.PerformanceManagementMgr getPerformanceManagementMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getPerformanceManagementMgr();
  }

  /**
   * <pre>
   *   protection.ProtectionMgr getProtectionMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public protection.ProtectionMgr getProtectionMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getProtectionMgr();
  }

  /**
   * <pre>
   *   trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getTrafficDescriptorMgr();
  }

  /**
   * <pre>
   *   guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getGuiCutThroughMgr();
  }

}
