package notifications;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/notifications.idl"
 * <li> <b>IDL Name</b>      ::notifications::ObjectType_T
 * <li> <b>Repository Id</b> IDL:notifications/ObjectType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ObjectType_T {OT_NETWORK_R1, OT_MANAGED_ELEMENT, OT_MULTILAYER_SUBNETWORK,
                   OT_TOPOLOGICAL_LINK, OT_SUBNETWORK_CONNECTION,
                   OT_TERMINATION_POINT, OT_EQUIPMENT, OT_PROTECTION_GROUP,
                   OT_TRAFFIC_DESCRIPTOR, OT_AID};
 * </pre>
 */
public final class ObjectType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _OT_NETWORK_R1 = 0;
  
  public static final int _OT_MANAGED_ELEMENT = 1;
  
  public static final int _OT_MULTILAYER_SUBNETWORK = 2;
  
  public static final int _OT_TOPOLOGICAL_LINK = 3;
  
  public static final int _OT_SUBNETWORK_CONNECTION = 4;
  
  public static final int _OT_TERMINATION_POINT = 5;
  
  public static final int _OT_EQUIPMENT = 6;
  
  public static final int _OT_PROTECTION_GROUP = 7;
  
  public static final int _OT_TRAFFIC_DESCRIPTOR = 8;
  
  public static final int _OT_AID = 9;

  
  public static final ObjectType_T OT_NETWORK_R1 = new ObjectType_T(_OT_NETWORK_R1);
  
  public static final ObjectType_T OT_MANAGED_ELEMENT = new ObjectType_T(_OT_MANAGED_ELEMENT);
  
  public static final ObjectType_T OT_MULTILAYER_SUBNETWORK = new ObjectType_T(_OT_MULTILAYER_SUBNETWORK);
  
  public static final ObjectType_T OT_TOPOLOGICAL_LINK = new ObjectType_T(_OT_TOPOLOGICAL_LINK);
  
  public static final ObjectType_T OT_SUBNETWORK_CONNECTION = new ObjectType_T(_OT_SUBNETWORK_CONNECTION);
  
  public static final ObjectType_T OT_TERMINATION_POINT = new ObjectType_T(_OT_TERMINATION_POINT);
  
  public static final ObjectType_T OT_EQUIPMENT = new ObjectType_T(_OT_EQUIPMENT);
  
  public static final ObjectType_T OT_PROTECTION_GROUP = new ObjectType_T(_OT_PROTECTION_GROUP);
  
  public static final ObjectType_T OT_TRAFFIC_DESCRIPTOR = new ObjectType_T(_OT_TRAFFIC_DESCRIPTOR);
  
  public static final ObjectType_T OT_AID = new ObjectType_T(_OT_AID);

  protected ObjectType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ObjectType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return OT_NETWORK_R1;
      case 1: return OT_MANAGED_ELEMENT;
      case 2: return OT_MULTILAYER_SUBNETWORK;
      case 3: return OT_TOPOLOGICAL_LINK;
      case 4: return OT_SUBNETWORK_CONNECTION;
      case 5: return OT_TERMINATION_POINT;
      case 6: return OT_EQUIPMENT;
      case 7: return OT_PROTECTION_GROUP;
      case 8: return OT_TRAFFIC_DESCRIPTOR;
      case 9: return OT_AID;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "OT_NETWORK_R1";
      case 1: return "OT_MANAGED_ELEMENT";
      case 2: return "OT_MULTILAYER_SUBNETWORK";
      case 3: return "OT_TOPOLOGICAL_LINK";
      case 4: return "OT_SUBNETWORK_CONNECTION";
      case 5: return "OT_TERMINATION_POINT";
      case 6: return "OT_EQUIPMENT";
      case 7: return "OT_PROTECTION_GROUP";
      case 8: return "OT_TRAFFIC_DESCRIPTOR";
      case 9: return "OT_AID";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof notifications.ObjectType_T
      ? this._value == ((notifications.ObjectType_T)o)._value
      : false;
  }
}
