package notifications;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/notifications.idl"
 * <li> <b>IDL Name</b>      ::notifications::PerceivedSeverity_T
 * <li> <b>Repository Id</b> IDL:notifications/PerceivedSeverity_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum PerceivedSeverity_T {PS_INDETERMINATE, PS_CRITICAL, PS_MAJOR, PS_MINOR,
                          PS_WARNING, PS_CLEARED};
 * </pre>
 */
public final class PerceivedSeverity_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _PS_INDETERMINATE = 0;
  
  public static final int _PS_CRITICAL = 1;
  
  public static final int _PS_MAJOR = 2;
  
  public static final int _PS_MINOR = 3;
  
  public static final int _PS_WARNING = 4;
  
  public static final int _PS_CLEARED = 5;

  
  public static final PerceivedSeverity_T PS_INDETERMINATE = new PerceivedSeverity_T(_PS_INDETERMINATE);
  
  public static final PerceivedSeverity_T PS_CRITICAL = new PerceivedSeverity_T(_PS_CRITICAL);
  
  public static final PerceivedSeverity_T PS_MAJOR = new PerceivedSeverity_T(_PS_MAJOR);
  
  public static final PerceivedSeverity_T PS_MINOR = new PerceivedSeverity_T(_PS_MINOR);
  
  public static final PerceivedSeverity_T PS_WARNING = new PerceivedSeverity_T(_PS_WARNING);
  
  public static final PerceivedSeverity_T PS_CLEARED = new PerceivedSeverity_T(_PS_CLEARED);

  protected PerceivedSeverity_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static PerceivedSeverity_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return PS_INDETERMINATE;
      case 1: return PS_CRITICAL;
      case 2: return PS_MAJOR;
      case 3: return PS_MINOR;
      case 4: return PS_WARNING;
      case 5: return PS_CLEARED;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "PS_INDETERMINATE";
      case 1: return "PS_CRITICAL";
      case 2: return "PS_MAJOR";
      case 3: return "PS_MINOR";
      case 4: return "PS_WARNING";
      case 5: return "PS_CLEARED";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof notifications.PerceivedSeverity_T
      ? this._value == ((notifications.PerceivedSeverity_T)o)._value
      : false;
  }
}
