package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PerformanceManagementMgr
 * <li> <b>Repository Id</b> IDL:performance/PerformanceManagementMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface PerformanceManagementMgr {
  ...
};
 * </pre>
 */
public abstract class PerformanceManagementMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, performance.PerformanceManagementMgrOperations {

  public performance.PerformanceManagementMgr _this () {
   return performance.PerformanceManagementMgrHelper.narrow(super._this_object());
  }

  public performance.PerformanceManagementMgr _this (org.omg.CORBA.ORB orb) {
    return performance.PerformanceManagementMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:performance/PerformanceManagementMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getMEPMcapabilities", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("disablePMData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("enablePMData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getHoldingTime", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getTCATPParameter", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
    _methods.put("getHistoryPMData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 5));
    _methods.put("getAllCurrentPMData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 6));
    _methods.put("setTCATPParameter", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 7));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return performance.PerformanceManagementMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (performance.PerformanceManagementMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        globaldefs.NameAndStringValue_T[] neName;
        neName = globaldefs.NamingAttributes_THelper.read(_input);
        short layerRate;
        layerRate = _input.read_short();
        performance.PMParameterList_THolder pmParameterList = new performance.PMParameterList_THolder();
        _self.getMEPMcapabilities(neName, layerRate, pmParameterList);
        _output = _handler.createReply();
        performance.PMParameterList_THelper.write(_output, pmParameterList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        performance.PMTPSelect_T[] pmTPSelectList;
        pmTPSelectList = performance.PMTPSelectList_THelper.read(_input);
        performance.PMTPSelectList_THolder failedTPSelectList = new performance.PMTPSelectList_THolder();
        _self.disablePMData(pmTPSelectList, failedTPSelectList);
        _output = _handler.createReply();
        performance.PMTPSelectList_THelper.write(_output, failedTPSelectList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        performance.PMTPSelect_T[] pmTPSelectList;
        pmTPSelectList = performance.PMTPSelectList_THelper.read(_input);
        performance.PMTPSelectList_THolder failedTPSelectList = new performance.PMTPSelectList_THolder();
        _self.enablePMData(pmTPSelectList, failedTPSelectList);
        _output = _handler.createReply();
        performance.PMTPSelectList_THelper.write(_output, failedTPSelectList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        performance.HoldingTime_THolder holdingTime = new performance.HoldingTime_THolder();
        _self.getHoldingTime(holdingTime);
        _output = _handler.createReply();
        performance.HoldingTime_THelper.write(_output, holdingTime.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        globaldefs.NameAndStringValue_T[] tpName;
        tpName = globaldefs.NamingAttributes_THelper.read(_input);
        short layerRate;
        layerRate = _input.read_short();
        java.lang.String granularity;
        granularity = _input.read_string();
        performance.TCAParameters_THolder tcaParameter = new performance.TCAParameters_THolder();
        _self.getTCATPParameter(tpName, layerRate, granularity, tcaParameter);
        _output = _handler.createReply();
        performance.TCAParameters_THelper.write(_output, tcaParameter.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 5: {
      try {
        java.lang.String destination;
        destination = _input.read_string();
        java.lang.String userName;
        userName = _input.read_string();
        java.lang.String password;
        password = _input.read_string();
        performance.PMTPSelect_T[] pmTPSelectList;
        pmTPSelectList = performance.PMTPSelectList_THelper.read(_input);
        java.lang.String startTime;
        startTime = _input.read_string();
        java.lang.String endTime;
        endTime = _input.read_string();
        _self.getHistoryPMData(destination, userName, password, pmTPSelectList, 
                               startTime, endTime);
        _output = _handler.createReply();
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 6: {
      try {
        performance.PMTPSelect_T[] pmTPSelectList;
        pmTPSelectList = performance.PMTPSelectList_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        performance.PMDataList_THolder pmDataList = new performance.PMDataList_THolder();
        performance.PMDataIteratorHolder pmIt = new performance.PMDataIteratorHolder();
        _self.getAllCurrentPMData(pmTPSelectList, how_many, pmDataList, pmIt);
        _output = _handler.createReply();
        performance.PMDataList_THelper.write(_output, pmDataList.value);
        performance.PMDataIteratorHelper.write(_output, pmIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 7: {
      try {
        globaldefs.NameAndStringValue_T[] name;
        name = globaldefs.NamingAttributes_THelper.read(_input);
        performance.TCAParameters_THolder tcaParameters = new performance.TCAParameters_THolder();
        tcaParameters.value = performance.TCAParameters_THelper.read(_input);
        _self.setTCATPParameter(name, tcaParameters);
        _output = _handler.createReply();
        performance.TCAParameters_THelper.write(_output, tcaParameters.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
