package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionGroupIterator
 * <li> <b>Repository Id</b> IDL:protection/ProtectionGroupIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ProtectionGroupIterator {
  ...
};
 * </pre>
 */
public class ProtectionGroupIteratorPOATie extends ProtectionGroupIteratorPOA {
  private protection.ProtectionGroupIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public ProtectionGroupIteratorPOATie (final protection.ProtectionGroupIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public ProtectionGroupIteratorPOATie (final protection.ProtectionGroupIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public protection.ProtectionGroupIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final protection.ProtectionGroupIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out protection.ProtectionGroup_T pgp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (protection.ProtectionGroup_THolder pgp) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(pgp);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out protection.ProtectionGroupList_T pgpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         protection.ProtectionGroupList_THolder pgpList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, pgpList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
