package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionSchemeState_T
 * <li> <b>Repository Id</b> IDL:protection/ProtectionSchemeState_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ProtectionSchemeState_T {PSS_NA, PSS_AUTOMATIC, PSS_FROZEN};
 * </pre>
 */
public final class ProtectionSchemeState_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _PSS_NA = 0;
  
  public static final int _PSS_AUTOMATIC = 1;
  
  public static final int _PSS_FROZEN = 2;

  
  public static final ProtectionSchemeState_T PSS_NA = new ProtectionSchemeState_T(_PSS_NA);
  
  public static final ProtectionSchemeState_T PSS_AUTOMATIC = new ProtectionSchemeState_T(_PSS_AUTOMATIC);
  
  public static final ProtectionSchemeState_T PSS_FROZEN = new ProtectionSchemeState_T(_PSS_FROZEN);

  protected ProtectionSchemeState_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ProtectionSchemeState_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return PSS_NA;
      case 1: return PSS_AUTOMATIC;
      case 2: return PSS_FROZEN;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "PSS_NA";
      case 1: return "PSS_AUTOMATIC";
      case 2: return "PSS_FROZEN";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof protection.ProtectionSchemeState_T
      ? this._value == ((protection.ProtectionSchemeState_T)o)._value
      : false;
  }
}
