package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::SwitchData_T
 * <li> <b>Repository Id</b> IDL:protection/SwitchData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SwitchData_T {
  ...
};
 * </pre>
 */
public final class SwitchData_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static protection.SwitchData_T read (final org.omg.CORBA.portable.InputStream _input) {
    final protection.SwitchData_T _result = new protection.SwitchData_T();
    _result.protectionType = protection.ProtectionType_THelper.read(_input);
    _result.switchReason = protection.SwitchReason_THelper.read(_input);
    _result.layerRate = _input.read_short();
    _result.groupName = globaldefs.NamingAttributes_THelper.read(_input);
    _result.protectedTP = globaldefs.NamingAttributes_THelper.read(_input);
    _result.switchAwayFromTP = globaldefs.NamingAttributes_THelper.read(_input);
    _result.switchToTP = globaldefs.NamingAttributes_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final protection.SwitchData_T _vis_value) {
    protection.ProtectionType_THelper.write(_output, _vis_value.protectionType);
    protection.SwitchReason_THelper.write(_output, _vis_value.switchReason);
    _output.write_short((short)_vis_value.layerRate);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.groupName);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.protectedTP);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.switchAwayFromTP);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.switchToTP);
  }

  public static void insert (final org.omg.CORBA.Any any, final protection.SwitchData_T _vis_value) {
    any.insert_Streamable(new protection.SwitchData_THolder(_vis_value));
  }

  public static protection.SwitchData_T extract (final org.omg.CORBA.Any any) {
    protection.SwitchData_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      protection.SwitchData_THolder _vis_holder = new protection.SwitchData_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = protection.SwitchData_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[7];
          members[0] = new org.omg.CORBA.StructMember("protectionType", protection.ProtectionType_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("switchReason", protection.SwitchReason_THelper.type(), null);
          members[2] = new org.omg.CORBA.StructMember("layerRate", transmissionParameters.LayerRate_THelper.type(), null);
          members[3] = new org.omg.CORBA.StructMember("groupName", globaldefs.NamingAttributes_THelper.type(), null);
          members[4] = new org.omg.CORBA.StructMember("protectedTP", globaldefs.NamingAttributes_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("switchAwayFromTP", globaldefs.NamingAttributes_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("switchToTP", globaldefs.NamingAttributes_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "SwitchData_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:protection/SwitchData_T:1.0";
  }
}
