package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::SwitchReason_T
 * <li> <b>Repository Id</b> IDL:protection/SwitchReason_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum SwitchReason_T {SR_NA, SR_WAIT_TO_RESTORE, SR_SIGNAL_FAIL,
                     SR_SIGNAL_MISMATCH, SR_SIGNAL_DEGRADE, SR_MANUAL};
 * </pre>
 */
public final class SwitchReason_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _SR_NA = 0;
  
  public static final int _SR_WAIT_TO_RESTORE = 1;
  
  public static final int _SR_SIGNAL_FAIL = 2;
  
  public static final int _SR_SIGNAL_MISMATCH = 3;
  
  public static final int _SR_SIGNAL_DEGRADE = 4;
  
  public static final int _SR_MANUAL = 5;

  
  public static final SwitchReason_T SR_NA = new SwitchReason_T(_SR_NA);
  
  public static final SwitchReason_T SR_WAIT_TO_RESTORE = new SwitchReason_T(_SR_WAIT_TO_RESTORE);
  
  public static final SwitchReason_T SR_SIGNAL_FAIL = new SwitchReason_T(_SR_SIGNAL_FAIL);
  
  public static final SwitchReason_T SR_SIGNAL_MISMATCH = new SwitchReason_T(_SR_SIGNAL_MISMATCH);
  
  public static final SwitchReason_T SR_SIGNAL_DEGRADE = new SwitchReason_T(_SR_SIGNAL_DEGRADE);
  
  public static final SwitchReason_T SR_MANUAL = new SwitchReason_T(_SR_MANUAL);

  protected SwitchReason_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static SwitchReason_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return SR_NA;
      case 1: return SR_WAIT_TO_RESTORE;
      case 2: return SR_SIGNAL_FAIL;
      case 3: return SR_SIGNAL_MISMATCH;
      case 4: return SR_SIGNAL_DEGRADE;
      case 5: return SR_MANUAL;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "SR_NA";
      case 1: return "SR_WAIT_TO_RESTORE";
      case 2: return "SR_SIGNAL_FAIL";
      case 3: return "SR_SIGNAL_MISMATCH";
      case 4: return "SR_SIGNAL_DEGRADE";
      case 5: return "SR_MANUAL";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof protection.SwitchReason_T
      ? this._value == ((protection.SwitchReason_T)o)._value
      : false;
  }
}
