package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::CCIterator
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/CCIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface CCIterator {
  ...
};
 * </pre>
 */
public class CCIteratorPOATie extends CCIteratorPOA {
  private subnetworkConnection.CCIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public CCIteratorPOATie (final subnetworkConnection.CCIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public CCIteratorPOATie (final subnetworkConnection.CCIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public subnetworkConnection.CCIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final subnetworkConnection.CCIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out subnetworkConnection.CrossConnect_T cc)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (subnetworkConnection.CrossConnect_THolder cc) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(cc);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out subnetworkConnection.CrossConnectList_T ccList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         subnetworkConnection.CrossConnectList_THolder ccList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, ccList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
