package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::CrossConnect_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/CrossConnect_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct CrossConnect_T {
  ...
};
 * </pre>
 */
public final class CrossConnect_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[][] aEndNameList;
  
  public globaldefs.NameAndStringValue_T[][] zEndNameList;
  
  public subnetworkConnection.ConnectionDirection_T direction;
  
  public subnetworkConnection.SNCType_T sncType;

  public CrossConnect_T () {
  }

  public CrossConnect_T (final globaldefs.NameAndStringValue_T[][] aEndNameList, 
                         final globaldefs.NameAndStringValue_T[][] zEndNameList, 
                         final subnetworkConnection.ConnectionDirection_T direction, 
                         final subnetworkConnection.SNCType_T sncType) {
    this.aEndNameList = aEndNameList;
    this.zEndNameList = zEndNameList;
    this.direction = direction;
    this.sncType = sncType;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct subnetworkConnection.CrossConnect_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[][] aEndNameList=");
    _ret.append("{");
    if (aEndNameList == null) {
      _ret.append(aEndNameList);
    } else {
      for (int $counter22 = 0; $counter22 < aEndNameList.length; $counter22++) {
        _ret.append("{");
        if (aEndNameList[$counter22] == null) {
          _ret.append(aEndNameList[$counter22]);
        } else {
          for (int $counter23 = 0; $counter23 < aEndNameList[$counter22].length; $counter23++) {
            _ret.append(aEndNameList[$counter22][$counter23]);
            if ($counter23 < aEndNameList[$counter22].length - 1) {
              _ret.append(",");
            }
          }
        }
        _ret.append("}");
        if ($counter22 < aEndNameList.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[][] zEndNameList=");
    _ret.append("{");
    if (zEndNameList == null) {
      _ret.append(zEndNameList);
    } else {
      for (int $counter24 = 0; $counter24 < zEndNameList.length; $counter24++) {
        _ret.append("{");
        if (zEndNameList[$counter24] == null) {
          _ret.append(zEndNameList[$counter24]);
        } else {
          for (int $counter25 = 0; $counter25 < zEndNameList[$counter24].length; $counter25++) {
            _ret.append(zEndNameList[$counter24][$counter25]);
            if ($counter25 < zEndNameList[$counter24].length - 1) {
              _ret.append(",");
            }
          }
        }
        _ret.append("}");
        if ($counter24 < zEndNameList.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ConnectionDirection_T direction=");
    _ret.append(direction);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.SNCType_T sncType=");
    _ret.append(sncType);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof subnetworkConnection.CrossConnect_T) {
      _cmpMap.put(_currentThread, o);
      final subnetworkConnection.CrossConnect_T obj = (subnetworkConnection.CrossConnect_T)o;
      boolean res = true;
      do {
          if (res = (this.aEndNameList.length == obj.aEndNameList.length)) {
            for (int $counter26 = 0; res && $counter26 < this.aEndNameList.length; $counter26++) {
                  if (res = (this.aEndNameList[$counter26].length == obj.aEndNameList[$counter26].length)) {
                    for (int $counter27 = 0; res && $counter27 < this.aEndNameList[$counter26].length; $counter27++) {
                      res = this.aEndNameList[$counter26][$counter27] == obj.aEndNameList[$counter26][$counter27] ||
                       (this.aEndNameList[$counter26][$counter27] != null && obj.aEndNameList[$counter26][$counter27] != null && this.aEndNameList[$counter26][$counter27].equals(obj.aEndNameList[$counter26][$counter27]));
                    }
                  }
            }
          }
        if (!res) break;
          if (res = (this.zEndNameList.length == obj.zEndNameList.length)) {
            for (int $counter28 = 0; res && $counter28 < this.zEndNameList.length; $counter28++) {
                  if (res = (this.zEndNameList[$counter28].length == obj.zEndNameList[$counter28].length)) {
                    for (int $counter29 = 0; res && $counter29 < this.zEndNameList[$counter28].length; $counter29++) {
                      res = this.zEndNameList[$counter28][$counter29] == obj.zEndNameList[$counter28][$counter29] ||
                       (this.zEndNameList[$counter28][$counter29] != null && obj.zEndNameList[$counter28][$counter29] != null && this.zEndNameList[$counter28][$counter29].equals(obj.zEndNameList[$counter28][$counter29]));
                    }
                  }
            }
          }
        if (!res) break;
        res = this.direction == obj.direction ||
         (this.direction != null && obj.direction != null && this.direction.equals(obj.direction));
        if (!res) break;
        res = this.sncType == obj.sncType ||
         (this.sncType != null && obj.sncType != null && this.sncType.equals(obj.sncType));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
