package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::GradesOfImpact_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/GradesOfImpact_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum GradesOfImpact_T {GOI_HITLESS, GOI_MINOR_IMPACT, GOI_MAJOR_IMPACT};
 * </pre>
 */
public final class GradesOfImpact_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _GOI_HITLESS = 0;
  
  public static final int _GOI_MINOR_IMPACT = 1;
  
  public static final int _GOI_MAJOR_IMPACT = 2;

  
  public static final GradesOfImpact_T GOI_HITLESS = new GradesOfImpact_T(_GOI_HITLESS);
  
  public static final GradesOfImpact_T GOI_MINOR_IMPACT = new GradesOfImpact_T(_GOI_MINOR_IMPACT);
  
  public static final GradesOfImpact_T GOI_MAJOR_IMPACT = new GradesOfImpact_T(_GOI_MAJOR_IMPACT);

  protected GradesOfImpact_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static GradesOfImpact_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return GOI_HITLESS;
      case 1: return GOI_MINOR_IMPACT;
      case 2: return GOI_MAJOR_IMPACT;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "GOI_HITLESS";
      case 1: return "GOI_MINOR_IMPACT";
      case 2: return "GOI_MAJOR_IMPACT";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof subnetworkConnection.GradesOfImpact_T
      ? this._value == ((subnetworkConnection.GradesOfImpact_T)o)._value
      : false;
  }
}
