package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCCreateData_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCCreateData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SNCCreateData_T {
  ...
};
 * </pre>
 */
public final class SNCCreateData_T implements org.omg.CORBA.portable.IDLEntity {
  
  public java.lang.String userLabel;
  
  public java.lang.String owner;
  
  public subnetworkConnection.ConnectionDirection_T direction;
  
  public subnetworkConnection.GradesOfImpact_T tolerableImpact;
  
  public subnetworkConnection.ResilienceMode_T resilienceMode;
  
  public subnetworkConnection.ResilienceEffort_T resilienceEffort;
  
  public subnetworkConnection.SNCType_T sncType;
  
  public subnetworkConnection.CrossConnect_T[] route;
  
  public subnetworkConnection.TPData_T[] aEnd;
  
  public subnetworkConnection.TPData_T[] zEnd;
  
  public java.lang.String potentialFutureSetupIndicator;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public SNCCreateData_T () {
  }

  public SNCCreateData_T (final java.lang.String userLabel, 
                          final java.lang.String owner, 
                          final subnetworkConnection.ConnectionDirection_T direction, 
                          final subnetworkConnection.GradesOfImpact_T tolerableImpact, 
                          final subnetworkConnection.ResilienceMode_T resilienceMode, 
                          final subnetworkConnection.ResilienceEffort_T resilienceEffort, 
                          final subnetworkConnection.SNCType_T sncType, 
                          final subnetworkConnection.CrossConnect_T[] route, 
                          final subnetworkConnection.TPData_T[] aEnd, 
                          final subnetworkConnection.TPData_T[] zEnd, 
                          final java.lang.String potentialFutureSetupIndicator, 
                          final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.userLabel = userLabel;
    this.owner = owner;
    this.direction = direction;
    this.tolerableImpact = tolerableImpact;
    this.resilienceMode = resilienceMode;
    this.resilienceEffort = resilienceEffort;
    this.sncType = sncType;
    this.route = route;
    this.aEnd = aEnd;
    this.zEnd = zEnd;
    this.potentialFutureSetupIndicator = potentialFutureSetupIndicator;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct subnetworkConnection.SNCCreateData_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ConnectionDirection_T direction=");
    _ret.append(direction);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.GradesOfImpact_T tolerableImpact=");
    _ret.append(tolerableImpact);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ResilienceMode_T resilienceMode=");
    _ret.append(resilienceMode);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ResilienceEffort_T resilienceEffort=");
    _ret.append(resilienceEffort);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.SNCType_T sncType=");
    _ret.append(sncType);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.CrossConnect_T[] route=");
    _ret.append("{");
    if (route == null) {
      _ret.append(route);
    } else {
      for (int $counter36 = 0; $counter36 < route.length; $counter36++) {
        _ret.append(route[$counter36]);
        if ($counter36 < route.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("subnetworkConnection.TPData_T[] aEnd=");
    _ret.append("{");
    if (aEnd == null) {
      _ret.append(aEnd);
    } else {
      for (int $counter37 = 0; $counter37 < aEnd.length; $counter37++) {
        _ret.append(aEnd[$counter37]);
        if ($counter37 < aEnd.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("subnetworkConnection.TPData_T[] zEnd=");
    _ret.append("{");
    if (zEnd == null) {
      _ret.append(zEnd);
    } else {
      for (int $counter38 = 0; $counter38 < zEnd.length; $counter38++) {
        _ret.append(zEnd[$counter38]);
        if ($counter38 < zEnd.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String potentialFutureSetupIndicator=");
    _ret.append(potentialFutureSetupIndicator != null?'\"' + potentialFutureSetupIndicator + '\"':null);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter39 = 0; $counter39 < additionalInfo.length; $counter39++) {
        _ret.append(additionalInfo[$counter39]);
        if ($counter39 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof subnetworkConnection.SNCCreateData_T) {
      _cmpMap.put(_currentThread, o);
      final subnetworkConnection.SNCCreateData_T obj = (subnetworkConnection.SNCCreateData_T)o;
      boolean res = true;
      do {
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.direction == obj.direction ||
         (this.direction != null && obj.direction != null && this.direction.equals(obj.direction));
        if (!res) break;
        res = this.tolerableImpact == obj.tolerableImpact ||
         (this.tolerableImpact != null && obj.tolerableImpact != null && this.tolerableImpact.equals(obj.tolerableImpact));
        if (!res) break;
        res = this.resilienceMode == obj.resilienceMode ||
         (this.resilienceMode != null && obj.resilienceMode != null && this.resilienceMode.equals(obj.resilienceMode));
        if (!res) break;
        res = this.resilienceEffort == obj.resilienceEffort ||
         (this.resilienceEffort != null && obj.resilienceEffort != null && this.resilienceEffort.equals(obj.resilienceEffort));
        if (!res) break;
        res = this.sncType == obj.sncType ||
         (this.sncType != null && obj.sncType != null && this.sncType.equals(obj.sncType));
        if (!res) break;
          if (res = (this.route.length == obj.route.length)) {
            for (int $counter40 = 0; res && $counter40 < this.route.length; $counter40++) {
              res = this.route[$counter40] == obj.route[$counter40] ||
               (this.route[$counter40] != null && obj.route[$counter40] != null && this.route[$counter40].equals(obj.route[$counter40]));
            }
          }
        if (!res) break;
          if (res = (this.aEnd.length == obj.aEnd.length)) {
            for (int $counter41 = 0; res && $counter41 < this.aEnd.length; $counter41++) {
              res = this.aEnd[$counter41] == obj.aEnd[$counter41] ||
               (this.aEnd[$counter41] != null && obj.aEnd[$counter41] != null && this.aEnd[$counter41].equals(obj.aEnd[$counter41]));
            }
          }
        if (!res) break;
          if (res = (this.zEnd.length == obj.zEnd.length)) {
            for (int $counter42 = 0; res && $counter42 < this.zEnd.length; $counter42++) {
              res = this.zEnd[$counter42] == obj.zEnd[$counter42] ||
               (this.zEnd[$counter42] != null && obj.zEnd[$counter42] != null && this.zEnd[$counter42].equals(obj.zEnd[$counter42]));
            }
          }
        if (!res) break;
          res = this.potentialFutureSetupIndicator == obj.potentialFutureSetupIndicator ||
           (this.potentialFutureSetupIndicator != null && obj.potentialFutureSetupIndicator != null && this.potentialFutureSetupIndicator.equals(obj.potentialFutureSetupIndicator));
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter43 = 0; res && $counter43 < this.additionalInfo.length; $counter43++) {
              res = this.additionalInfo[$counter43] == obj.additionalInfo[$counter43] ||
               (this.additionalInfo[$counter43] != null && obj.additionalInfo[$counter43] != null && this.additionalInfo[$counter43].equals(obj.additionalInfo[$counter43]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
