
package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCCreateData_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCCreateData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SNCCreateData_T {
  ...
};
 * </pre>
 */
public final class SNCCreateData_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static subnetworkConnection.SNCCreateData_T read (final org.omg.CORBA.portable.InputStream _input) {
    final subnetworkConnection.SNCCreateData_T _result = new subnetworkConnection.SNCCreateData_T();
    _result.userLabel = _input.read_string();
    _result.owner = _input.read_string();
    _result.direction = subnetworkConnection.ConnectionDirection_THelper.read(_input);
    _result.tolerableImpact = subnetworkConnection.GradesOfImpact_THelper.read(_input);
    _result.resilienceMode = subnetworkConnection.ResilienceMode_THelper.read(_input);
    _result.resilienceEffort = subnetworkConnection.ResilienceEffort_THelper.read(_input);
    _result.sncType = subnetworkConnection.SNCType_THelper.read(_input);
    _result.route = subnetworkConnection.Route_THelper.read(_input);
    _result.aEnd = subnetworkConnection.TPDataList_THelper.read(_input);
    _result.zEnd = subnetworkConnection.TPDataList_THelper.read(_input);
    _result.potentialFutureSetupIndicator = _input.read_string();
    _result.additionalInfo = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final subnetworkConnection.SNCCreateData_T _vis_value) {
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.owner);
    subnetworkConnection.ConnectionDirection_THelper.write(_output, _vis_value.direction);
    subnetworkConnection.GradesOfImpact_THelper.write(_output, _vis_value.tolerableImpact);
    subnetworkConnection.ResilienceMode_THelper.write(_output, _vis_value.resilienceMode);
    subnetworkConnection.ResilienceEffort_THelper.write(_output, _vis_value.resilienceEffort);
    subnetworkConnection.SNCType_THelper.write(_output, _vis_value.sncType);
    subnetworkConnection.Route_THelper.write(_output, _vis_value.route);
    subnetworkConnection.TPDataList_THelper.write(_output, _vis_value.aEnd);
    subnetworkConnection.TPDataList_THelper.write(_output, _vis_value.zEnd);
    _output.write_string((java.lang.String)_vis_value.potentialFutureSetupIndicator);
    globaldefs.NVSList_THelper.write(_output, _vis_value.additionalInfo);
  }

  public static void insert (final org.omg.CORBA.Any any, final subnetworkConnection.SNCCreateData_T _vis_value) {
    any.insert_Streamable(new subnetworkConnection.SNCCreateData_THolder(_vis_value));
  }

  public static subnetworkConnection.SNCCreateData_T extract (final org.omg.CORBA.Any any) {
    subnetworkConnection.SNCCreateData_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      subnetworkConnection.SNCCreateData_THolder _vis_holder = new subnetworkConnection.SNCCreateData_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = subnetworkConnection.SNCCreateData_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[12];
          members[0] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[1] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("direction", subnetworkConnection.ConnectionDirection_THelper.type(), null);
          members[3] = new org.omg.CORBA.StructMember("tolerableImpact", subnetworkConnection.GradesOfImpact_THelper.type(), null);
          members[4] = new org.omg.CORBA.StructMember("resilienceMode", subnetworkConnection.ResilienceMode_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("resilienceEffort", subnetworkConnection.ResilienceEffort_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("sncType", subnetworkConnection.SNCType_THelper.type(), null);
          members[7] = new org.omg.CORBA.StructMember("route", subnetworkConnection.Route_THelper.type(), null);
          members[8] = new org.omg.CORBA.StructMember("aEnd", subnetworkConnection.TPDataList_THelper.type(), null);
          members[9] = new org.omg.CORBA.StructMember("zEnd", subnetworkConnection.TPDataList_THelper.type(), null);
          members[10] = new org.omg.CORBA.StructMember("potentialFutureSetupIndicator", subnetworkConnection.ResourceSetup_THelper.type(), null);
          members[11] = new org.omg.CORBA.StructMember("additionalInfo", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "SNCCreateData_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:subnetworkConnection/SNCCreateData_T:1.0";
  }
}
