package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCIterator
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface SNCIterator {
  ...
};
 * </pre>
 */
public class SNCIteratorPOATie extends SNCIteratorPOA {
  private subnetworkConnection.SNCIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public SNCIteratorPOATie (final subnetworkConnection.SNCIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public SNCIteratorPOATie (final subnetworkConnection.SNCIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public subnetworkConnection.SNCIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final subnetworkConnection.SNCIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out subnetworkConnection.SubnetworkConnection_T tp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (subnetworkConnection.SubnetworkConnection_THolder tp) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(tp);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out subnetworkConnection.SubnetworkConnectionList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         subnetworkConnection.SubnetworkConnectionList_THolder tpList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, tpList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
