package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCState_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCState_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum SNCState_T {SNCS_NONEXISTENT, SNCS_PENDING, SNCS_ACTIVE, SNCS_PARTIAL};
 * </pre>
 */
public final class SNCState_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _SNCS_NONEXISTENT = 0;
  
  public static final int _SNCS_PENDING = 1;
  
  public static final int _SNCS_ACTIVE = 2;
  
  public static final int _SNCS_PARTIAL = 3;

  
  public static final SNCState_T SNCS_NONEXISTENT = new SNCState_T(_SNCS_NONEXISTENT);
  
  public static final SNCState_T SNCS_PENDING = new SNCState_T(_SNCS_PENDING);
  
  public static final SNCState_T SNCS_ACTIVE = new SNCState_T(_SNCS_ACTIVE);
  
  public static final SNCState_T SNCS_PARTIAL = new SNCState_T(_SNCS_PARTIAL);

  protected SNCState_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static SNCState_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return SNCS_NONEXISTENT;
      case 1: return SNCS_PENDING;
      case 2: return SNCS_ACTIVE;
      case 3: return SNCS_PARTIAL;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "SNCS_NONEXISTENT";
      case 1: return "SNCS_PENDING";
      case 2: return "SNCS_ACTIVE";
      case 3: return "SNCS_PARTIAL";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof subnetworkConnection.SNCState_T
      ? this._value == ((subnetworkConnection.SNCState_T)o)._value
      : false;
  }
}
