package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCType_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum SNCType_T {ST_NA, ST_SIMPLE, ST_NETWORK_ROUTED, ST_ADD_DROP,
                ST_OPEN_ADD_DROP, ST_INTERCONNECT, ST_DOUBLE_INTERCONNECT,
                ST_ADD_DROP_INTERCONNECT};
 * </pre>
 */
public final class SNCType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _ST_NA = 0;
  
  public static final int _ST_SIMPLE = 1;
  
  public static final int _ST_NETWORK_ROUTED = 2;
  
  public static final int _ST_ADD_DROP = 3;
  
  public static final int _ST_OPEN_ADD_DROP = 4;
  
  public static final int _ST_INTERCONNECT = 5;
  
  public static final int _ST_DOUBLE_INTERCONNECT = 6;
  
  public static final int _ST_ADD_DROP_INTERCONNECT = 7;

  
  public static final SNCType_T ST_NA = new SNCType_T(_ST_NA);
  
  public static final SNCType_T ST_SIMPLE = new SNCType_T(_ST_SIMPLE);
  
  public static final SNCType_T ST_NETWORK_ROUTED = new SNCType_T(_ST_NETWORK_ROUTED);
  
  public static final SNCType_T ST_ADD_DROP = new SNCType_T(_ST_ADD_DROP);
  
  public static final SNCType_T ST_OPEN_ADD_DROP = new SNCType_T(_ST_OPEN_ADD_DROP);
  
  public static final SNCType_T ST_INTERCONNECT = new SNCType_T(_ST_INTERCONNECT);
  
  public static final SNCType_T ST_DOUBLE_INTERCONNECT = new SNCType_T(_ST_DOUBLE_INTERCONNECT);
  
  public static final SNCType_T ST_ADD_DROP_INTERCONNECT = new SNCType_T(_ST_ADD_DROP_INTERCONNECT);

  protected SNCType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static SNCType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return ST_NA;
      case 1: return ST_SIMPLE;
      case 2: return ST_NETWORK_ROUTED;
      case 3: return ST_ADD_DROP;
      case 4: return ST_OPEN_ADD_DROP;
      case 5: return ST_INTERCONNECT;
      case 6: return ST_DOUBLE_INTERCONNECT;
      case 7: return ST_ADD_DROP_INTERCONNECT;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "ST_NA";
      case 1: return "ST_SIMPLE";
      case 2: return "ST_NETWORK_ROUTED";
      case 3: return "ST_ADD_DROP";
      case 4: return "ST_OPEN_ADD_DROP";
      case 5: return "ST_INTERCONNECT";
      case 6: return "ST_DOUBLE_INTERCONNECT";
      case 7: return "ST_ADD_DROP_INTERCONNECT";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof subnetworkConnection.SNCType_T
      ? this._value == ((subnetworkConnection.SNCType_T)o)._value
      : false;
  }
}
