package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::TPData_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/TPData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TPData_T {
  ...
};
 * </pre>
 */
public final class TPData_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] tpName;
  
  public java.lang.String userLabel;
  
  public terminationPoint.TerminationMode_T tpMappingMode;
  
  public transmissionParameters.LayeredParameters_T[] transmissionParameter;
  
  public globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName;
  
  public globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName;

  public TPData_T () {
  }

  public TPData_T (final globaldefs.NameAndStringValue_T[] tpName, 
                   final java.lang.String userLabel, 
                   final terminationPoint.TerminationMode_T tpMappingMode, 
                   final transmissionParameters.LayeredParameters_T[] transmissionParameter, 
                   final globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName, 
                   final globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName) {
    this.tpName = tpName;
    this.userLabel = userLabel;
    this.tpMappingMode = tpMappingMode;
    this.transmissionParameter = transmissionParameter;
    this.ingressTrafficDescriptorName = ingressTrafficDescriptorName;
    this.egressTrafficDescriptorName = egressTrafficDescriptorName;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct subnetworkConnection.TPData_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] tpName=");
    _ret.append("{");
    if (tpName == null) {
      _ret.append(tpName);
    } else {
      for (int $counter0 = 0; $counter0 < tpName.length; $counter0++) {
        _ret.append(tpName[$counter0]);
        if ($counter0 < tpName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("terminationPoint.TerminationMode_T tpMappingMode=");
    _ret.append(tpMappingMode);
    _ret.append(",\n");
    _ret.append("transmissionParameters.LayeredParameters_T[] transmissionParameter=");
    _ret.append("{");
    if (transmissionParameter == null) {
      _ret.append(transmissionParameter);
    } else {
      for (int $counter1 = 0; $counter1 < transmissionParameter.length; $counter1++) {
        _ret.append(transmissionParameter[$counter1]);
        if ($counter1 < transmissionParameter.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName=");
    _ret.append("{");
    if (ingressTrafficDescriptorName == null) {
      _ret.append(ingressTrafficDescriptorName);
    } else {
      for (int $counter2 = 0; $counter2 < ingressTrafficDescriptorName.length; $counter2++) {
        _ret.append(ingressTrafficDescriptorName[$counter2]);
        if ($counter2 < ingressTrafficDescriptorName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName=");
    _ret.append("{");
    if (egressTrafficDescriptorName == null) {
      _ret.append(egressTrafficDescriptorName);
    } else {
      for (int $counter3 = 0; $counter3 < egressTrafficDescriptorName.length; $counter3++) {
        _ret.append(egressTrafficDescriptorName[$counter3]);
        if ($counter3 < egressTrafficDescriptorName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof subnetworkConnection.TPData_T) {
      _cmpMap.put(_currentThread, o);
      final subnetworkConnection.TPData_T obj = (subnetworkConnection.TPData_T)o;
      boolean res = true;
      do {
            if (res = (this.tpName.length == obj.tpName.length)) {
              for (int $counter4 = 0; res && $counter4 < this.tpName.length; $counter4++) {
                res = this.tpName[$counter4] == obj.tpName[$counter4] ||
                 (this.tpName[$counter4] != null && obj.tpName[$counter4] != null && this.tpName[$counter4].equals(obj.tpName[$counter4]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.tpMappingMode == obj.tpMappingMode ||
         (this.tpMappingMode != null && obj.tpMappingMode != null && this.tpMappingMode.equals(obj.tpMappingMode));
        if (!res) break;
          if (res = (this.transmissionParameter.length == obj.transmissionParameter.length)) {
            for (int $counter5 = 0; res && $counter5 < this.transmissionParameter.length; $counter5++) {
              res = this.transmissionParameter[$counter5] == obj.transmissionParameter[$counter5] ||
               (this.transmissionParameter[$counter5] != null && obj.transmissionParameter[$counter5] != null && this.transmissionParameter[$counter5].equals(obj.transmissionParameter[$counter5]));
            }
          }
        if (!res) break;
            if (res = (this.ingressTrafficDescriptorName.length == obj.ingressTrafficDescriptorName.length)) {
              for (int $counter6 = 0; res && $counter6 < this.ingressTrafficDescriptorName.length; $counter6++) {
                res = this.ingressTrafficDescriptorName[$counter6] == obj.ingressTrafficDescriptorName[$counter6] ||
                 (this.ingressTrafficDescriptorName[$counter6] != null && obj.ingressTrafficDescriptorName[$counter6] != null && this.ingressTrafficDescriptorName[$counter6].equals(obj.ingressTrafficDescriptorName[$counter6]));
              }
            }
        if (!res) break;
            if (res = (this.egressTrafficDescriptorName.length == obj.egressTrafficDescriptorName.length)) {
              for (int $counter7 = 0; res && $counter7 < this.egressTrafficDescriptorName.length; $counter7++) {
                res = this.egressTrafficDescriptorName[$counter7] == obj.egressTrafficDescriptorName[$counter7] ||
                 (this.egressTrafficDescriptorName[$counter7] != null && obj.egressTrafficDescriptorName[$counter7] != null && this.egressTrafficDescriptorName[$counter7].equals(obj.egressTrafficDescriptorName[$counter7]));
              }
            }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
