package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TerminationMode_T
 * <li> <b>Repository Id</b> IDL:terminationPoint/TerminationMode_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum TerminationMode_T {TM_NA, TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING,
                        TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING};
 * </pre>
 */
public final class TerminationMode_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _TM_NA = 0;
  
  public static final int _TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING = 1;
  
  public static final int _TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING = 2;

  
  public static final TerminationMode_T TM_NA = new TerminationMode_T(_TM_NA);
  
  public static final TerminationMode_T TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING = new TerminationMode_T(_TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING);
  
  public static final TerminationMode_T TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING = new TerminationMode_T(_TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING);

  protected TerminationMode_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static TerminationMode_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return TM_NA;
      case 1: return TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING;
      case 2: return TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "TM_NA";
      case 1: return "TM_NEITHER_TERMINATED_NOR_AVAILABLE_FOR_MAPPING";
      case 2: return "TM_TERMINATED_AND_AVAILABLE_FOR_MAPPING";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof terminationPoint.TerminationMode_T
      ? this._value == ((terminationPoint.TerminationMode_T)o)._value
      : false;
  }
}
