package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TerminationPointIterator
 * <li> <b>Repository Id</b> IDL:terminationPoint/TerminationPointIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TerminationPointIterator {
  ...
};
 * </pre>
 */
public class TerminationPointIteratorPOATie extends TerminationPointIteratorPOA {
  private terminationPoint.TerminationPointIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public TerminationPointIteratorPOATie (final terminationPoint.TerminationPointIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public TerminationPointIteratorPOATie (final terminationPoint.TerminationPointIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public terminationPoint.TerminationPointIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final terminationPoint.TerminationPointIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out terminationPoint.TerminationPoint_T tp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (terminationPoint.TerminationPoint_THolder tp) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(tp);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out terminationPoint.TerminationPointList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         terminationPoint.TerminationPointList_THolder tpList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, tpList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
