package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TerminationPoint_T
 * <li> <b>Repository Id</b> IDL:terminationPoint/TerminationPoint_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TerminationPoint_T {
  ...
};
 * </pre>
 */
public final class TerminationPoint_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName;
  
  public globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName;
  
  public terminationPoint.TPType_T type;
  
  public terminationPoint.TPConnectionState_T connectionState;
  
  public terminationPoint.TerminationMode_T tpMappingMode;
  
  public terminationPoint.Directionality_T direction;
  
  public transmissionParameters.LayeredParameters_T[] transmissionParameter;
  
  public terminationPoint.TPProtectionAssociation_T tpProtectionAssociation;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public TerminationPoint_T () {
  }

  public TerminationPoint_T (final globaldefs.NameAndStringValue_T[] name, 
                             final java.lang.String userLabel, 
                             final java.lang.String nativeEMSName, 
                             final java.lang.String owner, 
                             final globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName, 
                             final globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName, 
                             final terminationPoint.TPType_T type, 
                             final terminationPoint.TPConnectionState_T connectionState, 
                             final terminationPoint.TerminationMode_T tpMappingMode, 
                             final terminationPoint.Directionality_T direction, 
                             final transmissionParameters.LayeredParameters_T[] transmissionParameter, 
                             final terminationPoint.TPProtectionAssociation_T tpProtectionAssociation, 
                             final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.ingressTrafficDescriptorName = ingressTrafficDescriptorName;
    this.egressTrafficDescriptorName = egressTrafficDescriptorName;
    this.type = type;
    this.connectionState = connectionState;
    this.tpMappingMode = tpMappingMode;
    this.direction = direction;
    this.transmissionParameter = transmissionParameter;
    this.tpProtectionAssociation = tpProtectionAssociation;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct terminationPoint.TerminationPoint_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] ingressTrafficDescriptorName=");
    _ret.append("{");
    if (ingressTrafficDescriptorName == null) {
      _ret.append(ingressTrafficDescriptorName);
    } else {
      for (int $counter1 = 0; $counter1 < ingressTrafficDescriptorName.length; $counter1++) {
        _ret.append(ingressTrafficDescriptorName[$counter1]);
        if ($counter1 < ingressTrafficDescriptorName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] egressTrafficDescriptorName=");
    _ret.append("{");
    if (egressTrafficDescriptorName == null) {
      _ret.append(egressTrafficDescriptorName);
    } else {
      for (int $counter2 = 0; $counter2 < egressTrafficDescriptorName.length; $counter2++) {
        _ret.append(egressTrafficDescriptorName[$counter2]);
        if ($counter2 < egressTrafficDescriptorName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("terminationPoint.TPType_T type=");
    _ret.append(type);
    _ret.append(",\n");
    _ret.append("terminationPoint.TPConnectionState_T connectionState=");
    _ret.append(connectionState);
    _ret.append(",\n");
    _ret.append("terminationPoint.TerminationMode_T tpMappingMode=");
    _ret.append(tpMappingMode);
    _ret.append(",\n");
    _ret.append("terminationPoint.Directionality_T direction=");
    _ret.append(direction);
    _ret.append(",\n");
    _ret.append("transmissionParameters.LayeredParameters_T[] transmissionParameter=");
    _ret.append("{");
    if (transmissionParameter == null) {
      _ret.append(transmissionParameter);
    } else {
      for (int $counter3 = 0; $counter3 < transmissionParameter.length; $counter3++) {
        _ret.append(transmissionParameter[$counter3]);
        if ($counter3 < transmissionParameter.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("terminationPoint.TPProtectionAssociation_T tpProtectionAssociation=");
    _ret.append(tpProtectionAssociation);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter4 = 0; $counter4 < additionalInfo.length; $counter4++) {
        _ret.append(additionalInfo[$counter4]);
        if ($counter4 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof terminationPoint.TerminationPoint_T) {
      _cmpMap.put(_currentThread, o);
      final terminationPoint.TerminationPoint_T obj = (terminationPoint.TerminationPoint_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter5 = 0; res && $counter5 < this.name.length; $counter5++) {
                res = this.name[$counter5] == obj.name[$counter5] ||
                 (this.name[$counter5] != null && obj.name[$counter5] != null && this.name[$counter5].equals(obj.name[$counter5]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
            if (res = (this.ingressTrafficDescriptorName.length == obj.ingressTrafficDescriptorName.length)) {
              for (int $counter6 = 0; res && $counter6 < this.ingressTrafficDescriptorName.length; $counter6++) {
                res = this.ingressTrafficDescriptorName[$counter6] == obj.ingressTrafficDescriptorName[$counter6] ||
                 (this.ingressTrafficDescriptorName[$counter6] != null && obj.ingressTrafficDescriptorName[$counter6] != null && this.ingressTrafficDescriptorName[$counter6].equals(obj.ingressTrafficDescriptorName[$counter6]));
              }
            }
        if (!res) break;
            if (res = (this.egressTrafficDescriptorName.length == obj.egressTrafficDescriptorName.length)) {
              for (int $counter7 = 0; res && $counter7 < this.egressTrafficDescriptorName.length; $counter7++) {
                res = this.egressTrafficDescriptorName[$counter7] == obj.egressTrafficDescriptorName[$counter7] ||
                 (this.egressTrafficDescriptorName[$counter7] != null && obj.egressTrafficDescriptorName[$counter7] != null && this.egressTrafficDescriptorName[$counter7].equals(obj.egressTrafficDescriptorName[$counter7]));
              }
            }
        if (!res) break;
        res = this.type == obj.type ||
         (this.type != null && obj.type != null && this.type.equals(obj.type));
        if (!res) break;
        res = this.connectionState == obj.connectionState ||
         (this.connectionState != null && obj.connectionState != null && this.connectionState.equals(obj.connectionState));
        if (!res) break;
        res = this.tpMappingMode == obj.tpMappingMode ||
         (this.tpMappingMode != null && obj.tpMappingMode != null && this.tpMappingMode.equals(obj.tpMappingMode));
        if (!res) break;
        res = this.direction == obj.direction ||
         (this.direction != null && obj.direction != null && this.direction.equals(obj.direction));
        if (!res) break;
          if (res = (this.transmissionParameter.length == obj.transmissionParameter.length)) {
            for (int $counter8 = 0; res && $counter8 < this.transmissionParameter.length; $counter8++) {
              res = this.transmissionParameter[$counter8] == obj.transmissionParameter[$counter8] ||
               (this.transmissionParameter[$counter8] != null && obj.transmissionParameter[$counter8] != null && this.transmissionParameter[$counter8].equals(obj.transmissionParameter[$counter8]));
            }
          }
        if (!res) break;
        res = this.tpProtectionAssociation == obj.tpProtectionAssociation ||
         (this.tpProtectionAssociation != null && obj.tpProtectionAssociation != null && this.tpProtectionAssociation.equals(obj.tpProtectionAssociation));
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter9 = 0; res && $counter9 < this.additionalInfo.length; $counter9++) {
              res = this.additionalInfo[$counter9] == obj.additionalInfo[$counter9] ||
               (this.additionalInfo[$counter9] != null && obj.additionalInfo[$counter9] != null && this.additionalInfo[$counter9].equals(obj.additionalInfo[$counter9]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
