package topologicalLink;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/topologicalLink.idl"
 * <li> <b>IDL Name</b>      ::topologicalLink::TopologicalLinkIterator
 * <li> <b>Repository Id</b> IDL:topologicalLink/TopologicalLinkIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TopologicalLinkIterator {
  ...
};
 * </pre>
 */
public interface TopologicalLinkIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out topologicalLink.TopologicalLink_T topoLink)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (topologicalLink.TopologicalLink_THolder topoLink) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out topologicalLink.TopologicalLinkList_T topoLinkList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         topologicalLink.TopologicalLinkList_THolder topoLinkList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
