package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorIterator
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorIterator {
  ...
};
 * </pre>
 */
public interface TrafficDescriptorIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out trafficDescriptor.TrafficDescriptor_T trafficDesc)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (trafficDescriptor.TrafficDescriptor_THolder trafficDesc) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out trafficDescriptor.TrafficDescriptorList_T trafficDescList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         trafficDescriptor.TrafficDescriptorList_THolder trafficDescList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
