package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorIterator
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorIterator {
  ...
};
 * </pre>
 */
public class TrafficDescriptorIteratorPOATie extends TrafficDescriptorIteratorPOA {
  private trafficDescriptor.TrafficDescriptorIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public TrafficDescriptorIteratorPOATie (final trafficDescriptor.TrafficDescriptorIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public TrafficDescriptorIteratorPOATie (final trafficDescriptor.TrafficDescriptorIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public trafficDescriptor.TrafficDescriptorIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final trafficDescriptor.TrafficDescriptorIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out trafficDescriptor.TrafficDescriptor_T trafficDesc)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (trafficDescriptor.TrafficDescriptor_THolder trafficDesc) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(trafficDesc);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out trafficDescriptor.TrafficDescriptorList_T trafficDescList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         trafficDescriptor.TrafficDescriptorList_THolder trafficDescList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, trafficDescList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
