package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptor_T
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptor_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TrafficDescriptor_T {
  ...
};
 * </pre>
 */
public final class TrafficDescriptor_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public trafficDescriptor.ServiceCategory_T serviceCategory;
  
  public globaldefs.NameAndStringValue_T[] trafficParameters;
  
  public java.lang.String conformanceDefinition;

  public TrafficDescriptor_T () {
  }

  public TrafficDescriptor_T (final globaldefs.NameAndStringValue_T[] name, 
                              final java.lang.String userLabel, 
                              final java.lang.String nativeEMSName, 
                              final java.lang.String owner, 
                              final trafficDescriptor.ServiceCategory_T serviceCategory, 
                              final globaldefs.NameAndStringValue_T[] trafficParameters, 
                              final java.lang.String conformanceDefinition) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.serviceCategory = serviceCategory;
    this.trafficParameters = trafficParameters;
    this.conformanceDefinition = conformanceDefinition;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct trafficDescriptor.TrafficDescriptor_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("trafficDescriptor.ServiceCategory_T serviceCategory=");
    _ret.append(serviceCategory);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] trafficParameters=");
    _ret.append("{");
    if (trafficParameters == null) {
      _ret.append(trafficParameters);
    } else {
      for (int $counter1 = 0; $counter1 < trafficParameters.length; $counter1++) {
        _ret.append(trafficParameters[$counter1]);
        if ($counter1 < trafficParameters.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String conformanceDefinition=");
    _ret.append(conformanceDefinition != null?'\"' + conformanceDefinition + '\"':null);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof trafficDescriptor.TrafficDescriptor_T) {
      _cmpMap.put(_currentThread, o);
      final trafficDescriptor.TrafficDescriptor_T obj = (trafficDescriptor.TrafficDescriptor_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter2 = 0; res && $counter2 < this.name.length; $counter2++) {
                res = this.name[$counter2] == obj.name[$counter2] ||
                 (this.name[$counter2] != null && obj.name[$counter2] != null && this.name[$counter2].equals(obj.name[$counter2]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.serviceCategory == obj.serviceCategory ||
         (this.serviceCategory != null && obj.serviceCategory != null && this.serviceCategory.equals(obj.serviceCategory));
        if (!res) break;
            if (res = (this.trafficParameters.length == obj.trafficParameters.length)) {
              for (int $counter3 = 0; res && $counter3 < this.trafficParameters.length; $counter3++) {
                res = this.trafficParameters[$counter3] == obj.trafficParameters[$counter3] ||
                 (this.trafficParameters[$counter3] != null && obj.trafficParameters[$counter3] != null && this.trafficParameters[$counter3].equals(obj.trafficParameters[$counter3]));
              }
            }
        if (!res) break;
        res = this.conformanceDefinition == obj.conformanceDefinition ||
         (this.conformanceDefinition != null && obj.conformanceDefinition != null && this.conformanceDefinition.equals(obj.conformanceDefinition));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
