package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptor_T
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptor_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TrafficDescriptor_T {
  ...
};
 * </pre>
 */
public final class TrafficDescriptor_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static trafficDescriptor.TrafficDescriptor_T read (final org.omg.CORBA.portable.InputStream _input) {
    final trafficDescriptor.TrafficDescriptor_T _result = new trafficDescriptor.TrafficDescriptor_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.serviceCategory = trafficDescriptor.ServiceCategory_THelper.read(_input);
    _result.trafficParameters = trafficDescriptor.TrafficParameterList_THelper.read(_input);
    _result.conformanceDefinition = _input.read_string();
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final trafficDescriptor.TrafficDescriptor_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    trafficDescriptor.ServiceCategory_THelper.write(_output, _vis_value.serviceCategory);
    trafficDescriptor.TrafficParameterList_THelper.write(_output, _vis_value.trafficParameters);
    _output.write_string((java.lang.String)_vis_value.conformanceDefinition);
  }

  public static void insert (final org.omg.CORBA.Any any, final trafficDescriptor.TrafficDescriptor_T _vis_value) {
    any.insert_Streamable(new trafficDescriptor.TrafficDescriptor_THolder(_vis_value));
  }

  public static trafficDescriptor.TrafficDescriptor_T extract (final org.omg.CORBA.Any any) {
    trafficDescriptor.TrafficDescriptor_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      trafficDescriptor.TrafficDescriptor_THolder _vis_holder = new trafficDescriptor.TrafficDescriptor_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = trafficDescriptor.TrafficDescriptor_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[7];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("serviceCategory", trafficDescriptor.ServiceCategory_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("trafficParameters", trafficDescriptor.TrafficParameterList_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("conformanceDefinition", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          _type = _orb().create_struct_tc(id(), "TrafficDescriptor_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:trafficDescriptor/TrafficDescriptor_T:1.0";
  }
}
