package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorMgr
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorMgr {
  ...
};
 * </pre>
 */
public class _TrafficDescriptorMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements TrafficDescriptorMgr {
  final public static java.lang.Class _opsClass = trafficDescriptor.TrafficDescriptorMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:trafficDescriptor/TrafficDescriptorMgr:1.0"
  };

  /**
   * <pre>
   *   void getAllTrafficDescriptors (in unsigned long how_many,
                                 out trafficDescriptor.TrafficDescriptorList_T trafficDescList,
                                 out trafficDescriptor.TrafficDescriptorIterator trafficDescIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTrafficDescriptors (int how_many, 
                                        trafficDescriptor.TrafficDescriptorList_THolder trafficDescList, 
                                        trafficDescriptor.TrafficDescriptorIteratorHolder trafficDescIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTrafficDescriptors", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          trafficDescList.value = trafficDescriptor.TrafficDescriptorList_THelper.read(_input);
          trafficDescIt.value = trafficDescriptor.TrafficDescriptorIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTrafficDescriptors", _opsClass);
        if (_so == null) {
          continue;
        }
        final trafficDescriptor.TrafficDescriptorMgrOperations _self = (trafficDescriptor.TrafficDescriptorMgrOperations)_so.servant;
        try {
          _self.getAllTrafficDescriptors(how_many, trafficDescList, trafficDescIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void createTrafficDescriptor (inout trafficDescriptor.TrafficDescriptor_T newTrafficDescriptor)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void createTrafficDescriptor (trafficDescriptor.TrafficDescriptor_THolder newTrafficDescriptor) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("createTrafficDescriptor", true);
          trafficDescriptor.TrafficDescriptor_THelper.write(_output, newTrafficDescriptor.value);
          _input = this._invoke(_output);
          newTrafficDescriptor.value = trafficDescriptor.TrafficDescriptor_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("createTrafficDescriptor", _opsClass);
        if (_so == null) {
          continue;
        }
        final trafficDescriptor.TrafficDescriptorMgrOperations _self = (trafficDescriptor.TrafficDescriptorMgrOperations)_so.servant;
        try {
          _self.createTrafficDescriptor(newTrafficDescriptor);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void deleteTrafficDescriptor (in globaldefs.NamingAttributes_T descriptorName)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deleteTrafficDescriptor (globaldefs.NameAndStringValue_T[] descriptorName) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("deleteTrafficDescriptor", true);
          globaldefs.NamingAttributes_THelper.write(_output, descriptorName);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("deleteTrafficDescriptor", _opsClass);
        if (_so == null) {
          continue;
        }
        final trafficDescriptor.TrafficDescriptorMgrOperations _self = (trafficDescriptor.TrafficDescriptorMgrOperations)_so.servant;
        try {
          _self.deleteTrafficDescriptor(descriptorName);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
