package version;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/version.idl"
 * <li> <b>IDL Name</b>      ::vursion::Version
 * <li> <b>Repository Id</b> IDL:vursion/Version:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Version {
  ...
};
 * </pre>
 */
public class VersionPOATie extends VersionPOA {
  private version.VersionOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public VersionPOATie (final version.VersionOperations _delegate) {
    this._delegate = _delegate;
  }

  public VersionPOATie (final version.VersionOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public version.VersionOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final version.VersionOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   string getVersion ();
   * </pre>
   */
  public java.lang.String getVersion () {
    return this._delegate.getVersion();
  }

}
