package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::ManagedElementIterator
 * <li> <b>Repository Id</b> IDL:Prova/ManagedElementIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementIterator {
  ...
};
 * </pre>
 */
public class ManagedElementIteratorPOATie extends ManagedElementIteratorPOA {
  private Prova.ManagedElementIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public ManagedElementIteratorPOATie (final Prova.ManagedElementIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public ManagedElementIteratorPOATie (final Prova.ManagedElementIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public Prova.ManagedElementIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final Prova.ManagedElementIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out Prova.ManagedElement_T me);
   * </pre>
   */
  public boolean next_one (Prova.ManagedElement_THolder me) {
    return this._delegate.next_one(me);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out Prova.ManagedElementList_T meList);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         Prova.ManagedElementList_THolder meList) {
    return this._delegate.next_n(how_many, meList);
  }

  /**
   * <pre>
   *   unsigned long getLength ();
   * </pre>
   */
  public int getLength () {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ();
   * </pre>
   */
  public void destroy () {
    this._delegate.destroy();
  }

}
