package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::Mgr2
 * <li> <b>Repository Id</b> IDL:Prova/Mgr2:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Mgr2 {
  ...
};
 * </pre>
 */
public class Mgr2POATie extends Mgr2POA {
  private Prova.Mgr2Operations _delegate;
  private org.omg.PortableServer.POA _poa;

  public Mgr2POATie (final Prova.Mgr2Operations _delegate) {
    this._delegate = _delegate;
  }

  public Mgr2POATie (final Prova.Mgr2Operations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public Prova.Mgr2Operations _delegate () {
    return this._delegate;
  }

  public void _delegate (final Prova.Mgr2Operations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   string metodoMgr2 (in string name);
   * </pre>
   */
  public java.lang.String metodoMgr2 (java.lang.String name) {
    return this._delegate.metodoMgr2(name);
  }

}
