package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::ManagedElementIterator
 * <li> <b>Repository Id</b> IDL:Prova/ManagedElementIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementIterator {
  ...
};
 * </pre>
 */
public class _ManagedElementIteratorStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements ManagedElementIterator {
  final public static java.lang.Class _opsClass = Prova.ManagedElementIteratorOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:Prova/ManagedElementIterator:1.0"
  };

  /**
   * <pre>
   *   boolean next_one (out Prova.ManagedElement_T me);
   * </pre>
   */
  public boolean next_one (Prova.ManagedElement_THolder me) {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        boolean _result;
        try {
          _output = this._request("next_one", true);
          _input = this._invoke(_output);
          _result = _input.read_boolean();
          me.value = Prova.ManagedElement_THelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("next_one", _opsClass);
        if (_so == null) {
          continue;
        }
        final Prova.ManagedElementIteratorOperations _self = (Prova.ManagedElementIteratorOperations)_so.servant;
        try {
          return _self.next_one(me);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out Prova.ManagedElementList_T meList);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         Prova.ManagedElementList_THolder meList) {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        boolean _result;
        try {
          _output = this._request("next_n", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          _result = _input.read_boolean();
          meList.value = Prova.ManagedElementList_THelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("next_n", _opsClass);
        if (_so == null) {
          continue;
        }
        final Prova.ManagedElementIteratorOperations _self = (Prova.ManagedElementIteratorOperations)_so.servant;
        try {
          return _self.next_n(how_many, meList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   unsigned long getLength ();
   * </pre>
   */
  public int getLength () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        int _result;
        try {
          _output = this._request("getLength", true);
          _input = this._invoke(_output);
          _result = _input.read_ulong();
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getLength", _opsClass);
        if (_so == null) {
          continue;
        }
        final Prova.ManagedElementIteratorOperations _self = (Prova.ManagedElementIteratorOperations)_so.servant;
        try {
          return _self.getLength();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   void destroy ();
   * </pre>
   */
  public void destroy () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("destroy", true);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("destroy", _opsClass);
        if (_so == null) {
          continue;
        }
        final Prova.ManagedElementIteratorOperations _self = (Prova.ManagedElementIteratorOperations)_so.servant;
        try {
          _self.destroy();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
