package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::AdminPropertiesAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/AdminPropertiesAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface AdminPropertiesAdmin {
  ...
};
 * </pre>
 */
public class AdminPropertiesAdminPOATie extends AdminPropertiesAdminPOA {
  private CosNotification.AdminPropertiesAdminOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public AdminPropertiesAdminPOATie (final CosNotification.AdminPropertiesAdminOperations _delegate) {
    this._delegate = _delegate;
  }

  public AdminPropertiesAdminPOATie (final CosNotification.AdminPropertiesAdminOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public CosNotification.AdminPropertiesAdminOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final CosNotification.AdminPropertiesAdminOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   CosNotification.AdminProperties get_admin ();
   * </pre>
   */
  public CosNotification.Property[] get_admin () {
    return this._delegate.get_admin();
  }

  /**
   * <pre>
   *   void set_admin (in CosNotification.AdminProperties admin)
    raises (CosNotification.UnsupportedAdmin);
   * </pre>
   */
  public void set_admin (CosNotification.Property[] admin) throws  CosNotification.UnsupportedAdmin {
    this._delegate.set_admin(admin);
  }

}
