package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::EventHeader
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/EventHeader:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct EventHeader {
  ...
};
 * </pre>
 */
public final class EventHeader implements org.omg.CORBA.portable.IDLEntity {
  
  public CosNotification.FixedEventHeader fixed_header;
  
  public CosNotification.Property[] variable_header;

  public EventHeader () {
  }

  public EventHeader (final CosNotification.FixedEventHeader fixed_header, 
                      final CosNotification.Property[] variable_header) {
    this.fixed_header = fixed_header;
    this.variable_header = variable_header;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct CosNotification.EventHeader {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("CosNotification.FixedEventHeader fixed_header=");
    _ret.append(fixed_header);
    _ret.append(",\n");
    _ret.append("CosNotification.Property[] variable_header=");
    _ret.append("{");
    if (variable_header == null) {
      _ret.append(variable_header);
    } else {
      for (int $counter16 = 0; $counter16 < variable_header.length; $counter16++) {
        _ret.append(variable_header[$counter16]);
        if ($counter16 < variable_header.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof CosNotification.EventHeader) {
      _cmpMap.put(_currentThread, o);
      final CosNotification.EventHeader obj = (CosNotification.EventHeader)o;
      boolean res = true;
      do {
        res = this.fixed_header == obj.fixed_header ||
         (this.fixed_header != null && obj.fixed_header != null && this.fixed_header.equals(obj.fixed_header));
        if (!res) break;
            if (res = (this.variable_header.length == obj.variable_header.length)) {
              for (int $counter17 = 0; res && $counter17 < this.variable_header.length; $counter17++) {
                res = this.variable_header[$counter17] == obj.variable_header[$counter17] ||
                 (this.variable_header[$counter17] != null && obj.variable_header[$counter17] != null && this.variable_header[$counter17].equals(obj.variable_header[$counter17]));
              }
            }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
