package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::PropertyRange
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/PropertyRange:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct PropertyRange {
  ...
};
 * </pre>
 */
public final class PropertyRange implements org.omg.CORBA.portable.IDLEntity {
  
  public org.omg.CORBA.Any low_val;
  
  public org.omg.CORBA.Any high_val;

  public PropertyRange () {
  }

  public PropertyRange (final org.omg.CORBA.Any low_val, 
                        final org.omg.CORBA.Any high_val) {
    this.low_val = low_val;
    this.high_val = high_val;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct CosNotification.PropertyRange {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("org.omg.CORBA.Any low_val=");
    _ret.append(low_val);
    _ret.append(",\n");
    _ret.append("org.omg.CORBA.Any high_val=");
    _ret.append(high_val);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof CosNotification.PropertyRange) {
      _cmpMap.put(_currentThread, o);
      final CosNotification.PropertyRange obj = (CosNotification.PropertyRange)o;
      boolean res = true;
      do {
          res = this.low_val == obj.low_val ||
           (this.low_val != null && obj.low_val != null && this.low_val.equals(obj.low_val));
        if (!res) break;
          res = this.high_val == obj.high_val ||
           (this.high_val != null && obj.high_val != null && this.high_val.equals(obj.high_val));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
