package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::QoSAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/QoSAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface QoSAdmin {
  ...
};
 * </pre>
 */
public abstract class QoSAdminPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, CosNotification.QoSAdminOperations {

  public CosNotification.QoSAdmin _this () {
   return CosNotification.QoSAdminHelper.narrow(super._this_object());
  }

  public CosNotification.QoSAdmin _this (org.omg.CORBA.ORB orb) {
    return CosNotification.QoSAdminHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:omg.org/CosNotification/QoSAdmin:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("get_qos", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("set_qos", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("validate_qos", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return CosNotification.QoSAdminPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (CosNotification.QoSAdminOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
        CosNotification.Property[] _result = _self.get_qos();
        _output = _handler.createReply();
        CosNotification.QoSPropertiesHelper.write(_output, _result);
        return _output;
      }
      case 1: {
      try {
        CosNotification.Property[] qos;
        qos = CosNotification.QoSPropertiesHelper.read(_input);
        _self.set_qos(qos);
        _output = _handler.createReply();
      }
      catch (CosNotification.UnsupportedQoS _exception) {
        _output = _handler.createExceptionReply();
        CosNotification.UnsupportedQoSHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        CosNotification.Property[] required_qos;
        required_qos = CosNotification.QoSPropertiesHelper.read(_input);
        CosNotification.NamedPropertyRangeSeqHolder available_qos = new CosNotification.NamedPropertyRangeSeqHolder();
        _self.validate_qos(required_qos, available_qos);
        _output = _handler.createReply();
        CosNotification.NamedPropertyRangeSeqHelper.write(_output, available_qos.value);
      }
      catch (CosNotification.UnsupportedQoS _exception) {
        _output = _handler.createExceptionReply();
        CosNotification.UnsupportedQoSHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
