package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::QoSAdmin
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/QoSAdmin:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface QoSAdmin {
  ...
};
 * </pre>
 */
public class QoSAdminPOATie extends QoSAdminPOA {
  private CosNotification.QoSAdminOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public QoSAdminPOATie (final CosNotification.QoSAdminOperations _delegate) {
    this._delegate = _delegate;
  }

  public QoSAdminPOATie (final CosNotification.QoSAdminOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public CosNotification.QoSAdminOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final CosNotification.QoSAdminOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   CosNotification.QoSProperties get_qos ();
   * </pre>
   */
  public CosNotification.Property[] get_qos () {
    return this._delegate.get_qos();
  }

  /**
   * <pre>
   *   void set_qos (in CosNotification.QoSProperties qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void set_qos (CosNotification.Property[] qos) throws  CosNotification.UnsupportedQoS {
    this._delegate.set_qos(qos);
  }

  /**
   * <pre>
   *   void validate_qos (in CosNotification.QoSProperties required_qos,
                     out CosNotification.NamedPropertyRangeSeq available_qos)
    raises (CosNotification.UnsupportedQoS);
   * </pre>
   */
  public void validate_qos (CosNotification.Property[] required_qos, 
                            CosNotification.NamedPropertyRangeSeqHolder available_qos) throws  CosNotification.UnsupportedQoS {
    this._delegate.validate_qos(required_qos, available_qos);
  }

}
