package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::StructuredEvent
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/StructuredEvent:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct StructuredEvent {
  ...
};
 * </pre>
 */
public final class StructuredEventHelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static CosNotification.StructuredEvent read (final org.omg.CORBA.portable.InputStream _input) {
    final CosNotification.StructuredEvent _result = new CosNotification.StructuredEvent();
    _result.header = CosNotification.EventHeaderHelper.read(_input);
    _result.filterable_data = CosNotification.FilterableEventBodyHelper.read(_input);
    _result.remainder_of_body = _input.read_any();
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final CosNotification.StructuredEvent _vis_value) {
    CosNotification.EventHeaderHelper.write(_output, _vis_value.header);
    CosNotification.FilterableEventBodyHelper.write(_output, _vis_value.filterable_data);
    _output.write_any((org.omg.CORBA.Any)_vis_value.remainder_of_body);
  }

  public static void insert (final org.omg.CORBA.Any any, final CosNotification.StructuredEvent _vis_value) {
    any.insert_Streamable(new CosNotification.StructuredEventHolder(_vis_value));
  }

  public static CosNotification.StructuredEvent extract (final org.omg.CORBA.Any any) {
    CosNotification.StructuredEvent _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      CosNotification.StructuredEventHolder _vis_holder = new CosNotification.StructuredEventHolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = CosNotification.StructuredEventHelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[3];
          members[0] = new org.omg.CORBA.StructMember("header", CosNotification.EventHeaderHelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("filterable_data", CosNotification.FilterableEventBodyHelper.type(), null);
          members[2] = new org.omg.CORBA.StructMember("remainder_of_body", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_any), null);
          _type = _orb().create_struct_tc(id(), "StructuredEvent", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:omg.org/CosNotification/StructuredEvent:1.0";
  }
}
