package CosNotification;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/CosNotification.idl"
 * <li> <b>IDL Name</b>      ::CosNotification::UnsupportedQoS
 * <li> <b>Repository Id</b> IDL:omg.org/CosNotification/UnsupportedQoS:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * exception UnsupportedQoS {
  ...
};
 * </pre>
 */
public final class UnsupportedQoS extends org.omg.CORBA.UserException {
  
  public CosNotification.PropertyError[] qos_err;

  public UnsupportedQoS () {
    super(CosNotification.UnsupportedQoSHelper.id());
  }

  public UnsupportedQoS (CosNotification.PropertyError[] qos_err) {
    this();
    this.qos_err = qos_err;
  }

  public UnsupportedQoS (java.lang.String _reason, CosNotification.PropertyError[] qos_err) {
    super(CosNotification.UnsupportedQoSHelper.id() + ' ' + _reason);
    this.qos_err = qos_err;
  }

  public java.lang.String toString () {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("exception CosNotification.UnsupportedQoS {");
    _ret.append("\n");
    _ret.append("CosNotification.PropertyError[] qos_err=");
    _ret.append("{");
    if (qos_err == null) {
      _ret.append(qos_err);
    } else {
      for (int $counter12 = 0; $counter12 < qos_err.length; $counter12++) {
        _ret.append(qos_err[$counter12]);
        if ($counter12 < qos_err.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _ret.append("}");
    return _ret.toString();
  }

  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;
    if (o instanceof CosNotification.UnsupportedQoS) {
      final CosNotification.UnsupportedQoS obj = (CosNotification.UnsupportedQoS)o;
      boolean res = true;
      do {
          if (res = (this.qos_err.length == obj.qos_err.length)) {
            for (int $counter13 = 0; res && $counter13 < this.qos_err.length; $counter13++) {
              res = this.qos_err[$counter13] == obj.qos_err[$counter13] ||
               (this.qos_err[$counter13] != null && obj.qos_err[$counter13] != null && this.qos_err[$counter13].equals(obj.qos_err[$counter13]));
            }
          }
      } while (false);
      return res;
    }
    else {
      return false;
    }
  }
}
