package common;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/common.idl"
 * <li> <b>IDL Name</b>      ::cummon::Common
 * <li> <b>Repository Id</b> IDL:cummon/Common:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface Common {
  ...
};
 * </pre>
 */
public class _CommonStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements Common {
  final public static java.lang.Class _opsClass = common.CommonOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:cummon/Common:1.0"
  };

  /**
   * <pre>
   *   void setUserLabel (in globaldefs.NamingAttributes_T objectName,
                     in string userLabel)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setUserLabel (globaldefs.NameAndStringValue_T[] objectName, 
                            java.lang.String userLabel) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("setUserLabel", true);
          globaldefs.NamingAttributes_THelper.write(_output, objectName);
          _output.write_string((java.lang.String)userLabel);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("setUserLabel", _opsClass);
        if (_so == null) {
          continue;
        }
        final common.CommonOperations _self = (common.CommonOperations)_so.servant;
        try {
          _self.setUserLabel(objectName, userLabel);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void setOwner (in globaldefs.NamingAttributes_T objectName,
                 in string owner)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setOwner (globaldefs.NameAndStringValue_T[] objectName, 
                        java.lang.String owner) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("setOwner", true);
          globaldefs.NamingAttributes_THelper.write(_output, objectName);
          _output.write_string((java.lang.String)owner);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("setOwner", _opsClass);
        if (_so == null) {
          continue;
        }
        final common.CommonOperations _self = (common.CommonOperations)_so.servant;
        try {
          _self.setOwner(objectName, owner);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
