package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::EquipmentInventoryMgr
 * <li> <b>Repository Id</b> IDL:equipmentInventory/EquipmentInventoryMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EquipmentInventoryMgr {
  ...
};
 * </pre>
 */
public abstract class EquipmentInventoryMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, equipmentInventory.EquipmentInventoryMgrOperations {

  public equipmentInventory.EquipmentInventoryMgr _this () {
   return equipmentInventory.EquipmentInventoryMgrHelper.narrow(super._this_object());
  }

  public equipmentInventory.EquipmentInventoryMgr _this (org.omg.CORBA.ORB orb) {
    return equipmentInventory.EquipmentInventoryMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:equipmentInventory/EquipmentInventoryMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getEquipment", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("getAllEquipment", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("getAllEquipmentNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getAllSupportedPTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getAllSupportingEquipmentNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return equipmentInventory.EquipmentInventoryMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (equipmentInventory.EquipmentInventoryMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        globaldefs.NameAndStringValue_T[] equipmentName;
        equipmentName = globaldefs.NamingAttributes_THelper.read(_input);
        equipmentInventory.Equipment_THolder equipment = new equipmentInventory.Equipment_THolder();
        _self.getEquipment(equipmentName, equipment);
        _output = _handler.createReply();
        equipmentInventory.Equipment_THelper.write(_output, equipment.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementOrEquipmentName;
        managedElementOrEquipmentName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        equipmentInventory.EquipmentList_THolder eqList = new equipmentInventory.EquipmentList_THolder();
        equipmentInventory.EquipmentIteratorHolder eqIt = new equipmentInventory.EquipmentIteratorHolder();
        _self.getAllEquipment(managedElementOrEquipmentName, how_many, eqList, 
                              eqIt);
        _output = _handler.createReply();
        equipmentInventory.EquipmentList_THelper.write(_output, eqList.value);
        equipmentInventory.EquipmentIteratorHelper.write(_output, eqIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        globaldefs.NameAndStringValue_T[] managedElementOrEquipmentName;
        managedElementOrEquipmentName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllEquipmentNames(managedElementOrEquipmentName, how_many, nameList, 
                                   nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        globaldefs.NameAndStringValue_T[] equipmentName;
        equipmentName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllSupportedPTPNames(equipmentName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        globaldefs.NameAndStringValue_T[] ptpName;
        ptpName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllSupportingEquipmentNames(ptpName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
