package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::EquipmentIterator
 * <li> <b>Repository Id</b> IDL:equipmentInventory/EquipmentIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EquipmentIterator {
  ...
};
 * </pre>
 */
public class EquipmentIteratorPOATie extends EquipmentIteratorPOA {
  private equipmentInventory.EquipmentIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public EquipmentIteratorPOATie (final equipmentInventory.EquipmentIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public EquipmentIteratorPOATie (final equipmentInventory.EquipmentIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public equipmentInventory.EquipmentIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final equipmentInventory.EquipmentIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out equipmentInventory.Equipment_T equipment)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (equipmentInventory.Equipment_THolder equipment) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(equipment);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out equipmentInventory.EquipmentList_T equipmentList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         equipmentInventory.EquipmentList_THolder equipmentList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, equipmentList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
