package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::Equipment_T
 * <li> <b>Repository Id</b> IDL:equipmentInventory/Equipment_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct Equipment_T {
  ...
};
 * </pre>
 */
public final class Equipment_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public java.lang.String equipmentType;
  
  public java.lang.String expectedProductName;
  
  public java.lang.String expectedVersion;
  
  public java.lang.String actualProductName;
  
  public java.lang.String actualVersion;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public Equipment_T () {
  }

  public Equipment_T (final globaldefs.NameAndStringValue_T[] name, 
                      final java.lang.String userLabel, 
                      final java.lang.String nativeEMSName, 
                      final java.lang.String owner, 
                      final java.lang.String equipmentType, 
                      final java.lang.String expectedProductName, 
                      final java.lang.String expectedVersion, 
                      final java.lang.String actualProductName, 
                      final java.lang.String actualVersion, 
                      final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.equipmentType = equipmentType;
    this.expectedProductName = expectedProductName;
    this.expectedVersion = expectedVersion;
    this.actualProductName = actualProductName;
    this.actualVersion = actualVersion;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct equipmentInventory.Equipment_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String equipmentType=");
    _ret.append(equipmentType != null?'\"' + equipmentType + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String expectedProductName=");
    _ret.append(expectedProductName != null?'\"' + expectedProductName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String expectedVersion=");
    _ret.append(expectedVersion != null?'\"' + expectedVersion + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String actualProductName=");
    _ret.append(actualProductName != null?'\"' + actualProductName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String actualVersion=");
    _ret.append(actualVersion != null?'\"' + actualVersion + '\"':null);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter1 = 0; $counter1 < additionalInfo.length; $counter1++) {
        _ret.append(additionalInfo[$counter1]);
        if ($counter1 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof equipmentInventory.Equipment_T) {
      _cmpMap.put(_currentThread, o);
      final equipmentInventory.Equipment_T obj = (equipmentInventory.Equipment_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter2 = 0; res && $counter2 < this.name.length; $counter2++) {
                res = this.name[$counter2] == obj.name[$counter2] ||
                 (this.name[$counter2] != null && obj.name[$counter2] != null && this.name[$counter2].equals(obj.name[$counter2]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.equipmentType == obj.equipmentType ||
         (this.equipmentType != null && obj.equipmentType != null && this.equipmentType.equals(obj.equipmentType));
        if (!res) break;
        res = this.expectedProductName == obj.expectedProductName ||
         (this.expectedProductName != null && obj.expectedProductName != null && this.expectedProductName.equals(obj.expectedProductName));
        if (!res) break;
        res = this.expectedVersion == obj.expectedVersion ||
         (this.expectedVersion != null && obj.expectedVersion != null && this.expectedVersion.equals(obj.expectedVersion));
        if (!res) break;
        res = this.actualProductName == obj.actualProductName ||
         (this.actualProductName != null && obj.actualProductName != null && this.actualProductName.equals(obj.actualProductName));
        if (!res) break;
        res = this.actualVersion == obj.actualVersion ||
         (this.actualVersion != null && obj.actualVersion != null && this.actualVersion.equals(obj.actualVersion));
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter3 = 0; res && $counter3 < this.additionalInfo.length; $counter3++) {
              res = this.additionalInfo[$counter3] == obj.additionalInfo[$counter3] ||
               (this.additionalInfo[$counter3] != null && obj.additionalInfo[$counter3] != null && this.additionalInfo[$counter3].equals(obj.additionalInfo[$counter3]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
