package equipmentInventory;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/equipment.idl"
 * <li> <b>IDL Name</b>      ::equipmentInventory::Equipment_T
 * <li> <b>Repository Id</b> IDL:equipmentInventory/Equipment_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct Equipment_T {
  ...
};
 * </pre>
 */
public final class Equipment_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static equipmentInventory.Equipment_T read (final org.omg.CORBA.portable.InputStream _input) {
    final equipmentInventory.Equipment_T _result = new equipmentInventory.Equipment_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.equipmentType = _input.read_string();
    _result.expectedProductName = _input.read_string();
    _result.expectedVersion = _input.read_string();
    _result.actualProductName = _input.read_string();
    _result.actualVersion = _input.read_string();
    _result.additionalInfo = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final equipmentInventory.Equipment_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    _output.write_string((java.lang.String)_vis_value.equipmentType);
    _output.write_string((java.lang.String)_vis_value.expectedProductName);
    _output.write_string((java.lang.String)_vis_value.expectedVersion);
    _output.write_string((java.lang.String)_vis_value.actualProductName);
    _output.write_string((java.lang.String)_vis_value.actualVersion);
    globaldefs.NVSList_THelper.write(_output, _vis_value.additionalInfo);
  }

  public static void insert (final org.omg.CORBA.Any any, final equipmentInventory.Equipment_T _vis_value) {
    any.insert_Streamable(new equipmentInventory.Equipment_THolder(_vis_value));
  }

  public static equipmentInventory.Equipment_T extract (final org.omg.CORBA.Any any) {
    equipmentInventory.Equipment_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      equipmentInventory.Equipment_THolder _vis_holder = new equipmentInventory.Equipment_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = equipmentInventory.Equipment_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[10];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("equipmentType", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[5] = new org.omg.CORBA.StructMember("expectedProductName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[6] = new org.omg.CORBA.StructMember("expectedVersion", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[7] = new org.omg.CORBA.StructMember("actualProductName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[8] = new org.omg.CORBA.StructMember("actualVersion", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[9] = new org.omg.CORBA.StructMember("additionalInfo", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "Equipment_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:equipmentInventory/Equipment_T:1.0";
  }
}
