package globaldefs;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/globaldefs.idl"
 * <li> <b>IDL Name</b>      ::globaldefs::ExceptionType_T
 * <li> <b>Repository Id</b> IDL:globaldefs/ExceptionType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ExceptionType_T {EXCPT_NOT_IMPLEMENTED, EXCPT_INTERNAL_ERROR,
                      EXCPT_INVALID_INPUT, EXCPT_TP_IN_USE,
                      EXCPT_TP_INVALID_ENDPOINT, EXCPT_ENTITY_NOT_FOUND,
                      EXCPT_TIMESLOT_IN_USE, EXCPT_PROTECTION_EFFORT_NOT_MET,
                      EXCPT_NOT_IN_VALID_STATE, EXCPT_UNABLE_TO_COMPLY,
                      EXCPT_TRAFFIC_DESCRIPTOR_IN_USE, EXCPT_NE_COMM_LOSS,
                      EXCPT_CAPACITY_EXCEEDED, EXCPT_TOO_MANY_OPEN_ITERATORS};
 * </pre>
 */
public final class ExceptionType_THelper {
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static globaldefs.ExceptionType_T read (final org.omg.CORBA.portable.InputStream _input) {
    return globaldefs.ExceptionType_T.from_int(_input.read_long());
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final globaldefs.ExceptionType_T _vis_value) {
    _output.write_long(_vis_value.value());
  }

  public static void insert (final org.omg.CORBA.Any any, final globaldefs.ExceptionType_T _vis_value) {
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      ((com.inprise.vbroker.CORBA.Any)any).insert_enum(_vis_value.value(), globaldefs.ExceptionType_THelper.type());
    }
    else {
      org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
      globaldefs.ExceptionType_THelper.write(output, _vis_value);
      any.read_value(output.create_input_stream(), globaldefs.ExceptionType_THelper.type());
    }

  }

  public static globaldefs.ExceptionType_T extract (final org.omg.CORBA.Any any) {
    globaldefs.ExceptionType_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      _vis_value = globaldefs.ExceptionType_T.from_int(((com.inprise.vbroker.CORBA.Any)any).extract_enum(type()));
    }
    else {
      _vis_value = globaldefs.ExceptionType_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          final java.lang.String members[] = new java.lang.String[] {"EXCPT_NOT_IMPLEMENTED",
                                                                     "EXCPT_INTERNAL_ERROR",
                                                                     "EXCPT_INVALID_INPUT",
                                                                     "EXCPT_TP_IN_USE",
                                                                     "EXCPT_TP_INVALID_ENDPOINT",
                                                                     "EXCPT_ENTITY_NOT_FOUND",
                                                                     "EXCPT_TIMESLOT_IN_USE",
                                                                     "EXCPT_PROTECTION_EFFORT_NOT_MET",
                                                                     "EXCPT_NOT_IN_VALID_STATE",
                                                                     "EXCPT_UNABLE_TO_COMPLY",
                                                                     "EXCPT_TRAFFIC_DESCRIPTOR_IN_USE",
                                                                     "EXCPT_NE_COMM_LOSS",
                                                                     "EXCPT_CAPACITY_EXCEEDED",
                                                                     "EXCPT_TOO_MANY_OPEN_ITERATORS"};
          _type = _orb().create_enum_tc(id(), "ExceptionType_T", members);
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:globaldefs/ExceptionType_T:1.0";
  }
}
