package globaldefs;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/globaldefs.idl"
 * <li> <b>IDL Name</b>      ::globaldefs::NamingAttributesIterator
 * <li> <b>Repository Id</b> IDL:globaldefs/NamingAttributesIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NamingAttributesIterator {
  ...
};
 * </pre>
 */
public interface NamingAttributesIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out globaldefs.NamingAttributes_T name)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (globaldefs.NamingAttributes_THolder name) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out globaldefs.NamingAttributesList_T nameList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         globaldefs.NamingAttributesList_THolder nameList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
