package globaldefs;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/globaldefs.idl"
 * <li> <b>IDL Name</b>      ::globaldefs::ProcessingFailureException
 * <li> <b>Repository Id</b> IDL:globaldefs/ProcessingFailureException:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * exception ProcessingFailureException {
  ...
};
 * </pre>
 */
public final class ProcessingFailureException extends org.omg.CORBA.UserException {
  
  public globaldefs.ExceptionType_T exceptionType;
  
  public java.lang.String errorReason;

  public ProcessingFailureException () {
    super(globaldefs.ProcessingFailureExceptionHelper.id());
  }

  public ProcessingFailureException (globaldefs.ExceptionType_T exceptionType,
                                     java.lang.String errorReason) {
    this();
    this.exceptionType = exceptionType;
    this.errorReason = errorReason;
  }

  public ProcessingFailureException (java.lang.String _reason, globaldefs.ExceptionType_T exceptionType, 
                                                               java.lang.String errorReason) {
    super(globaldefs.ProcessingFailureExceptionHelper.id() + ' ' + _reason);
    this.exceptionType = exceptionType;
    this.errorReason = errorReason;
  }

  public java.lang.String toString () {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("exception globaldefs.ProcessingFailureException {");
    _ret.append("\n");
    _ret.append("globaldefs.ExceptionType_T exceptionType=");
    _ret.append(exceptionType);
    _ret.append(",\n");
    _ret.append("java.lang.String errorReason=");
    _ret.append(errorReason != null?'\"' + errorReason + '\"':null);
    _ret.append("\n");
    _ret.append("}");
    return _ret.toString();
  }

  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;
    if (o instanceof globaldefs.ProcessingFailureException) {
      final globaldefs.ProcessingFailureException obj = (globaldefs.ProcessingFailureException)o;
      boolean res = true;
      do {
        res = this.exceptionType == obj.exceptionType ||
         (this.exceptionType != null && obj.exceptionType != null && this.exceptionType.equals(obj.exceptionType));
        if (!res) break;
        res = this.errorReason == obj.errorReason ||
         (this.errorReason != null && obj.errorReason != null && this.errorReason.equals(obj.errorReason));
      } while (false);
      return res;
    }
    else {
      return false;
    }
  }
}
