package managedElement;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElement.idl"
 * <li> <b>IDL Name</b>      ::managedElement::ManagedElementIterator
 * <li> <b>Repository Id</b> IDL:managedElement/ManagedElementIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementIterator {
  ...
};
 * </pre>
 */
public abstract class ManagedElementIteratorPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, managedElement.ManagedElementIteratorOperations {

  public managedElement.ManagedElementIterator _this () {
   return managedElement.ManagedElementIteratorHelper.narrow(super._this_object());
  }

  public managedElement.ManagedElementIterator _this (org.omg.CORBA.ORB orb) {
    return managedElement.ManagedElementIteratorHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:managedElement/ManagedElementIterator:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("next_one", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("next_n", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("getLength", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("destroy", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return managedElement.ManagedElementIteratorPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (managedElement.ManagedElementIteratorOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        managedElement.ManagedElement_THolder me = new managedElement.ManagedElement_THolder();
        boolean _result = _self.next_one(me);
        _output = _handler.createReply();
        _output.write_boolean((boolean)_result);
        managedElement.ManagedElement_THelper.write(_output, me.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        managedElement.ManagedElementList_THolder meList = new managedElement.ManagedElementList_THolder();
        boolean _result = _self.next_n(how_many, meList);
        _output = _handler.createReply();
        _output.write_boolean((boolean)_result);
        managedElement.ManagedElementList_THelper.write(_output, meList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        int _result = _self.getLength();
        _output = _handler.createReply();
        _output.write_ulong((int)_result);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        _self.destroy();
        _output = _handler.createReply();
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
