package managedElement;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/managedElement.idl"
 * <li> <b>IDL Name</b>      ::managedElement::ManagedElement_T
 * <li> <b>Repository Id</b> IDL:managedElement/ManagedElement_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct ManagedElement_T {
  ...
};
 * </pre>
 */
public final class ManagedElement_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public java.lang.String location;
  
  public java.lang.String version;
  
  public java.lang.String productName;
  
  public managedElement.ManagedElementType_T managedElementType;
  
  public managedElement.CommunicationState_T communicationState;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public ManagedElement_T () {
  }

  public ManagedElement_T (final globaldefs.NameAndStringValue_T[] name, 
                           final java.lang.String userLabel, 
                           final java.lang.String nativeEMSName, 
                           final java.lang.String owner, 
                           final java.lang.String location, 
                           final java.lang.String version, 
                           final java.lang.String productName, 
                           final managedElement.ManagedElementType_T managedElementType, 
                           final managedElement.CommunicationState_T communicationState, 
                           final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.location = location;
    this.version = version;
    this.productName = productName;
    this.managedElementType = managedElementType;
    this.communicationState = communicationState;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct managedElement.ManagedElement_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String location=");
    _ret.append(location != null?'\"' + location + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String version=");
    _ret.append(version != null?'\"' + version + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String productName=");
    _ret.append(productName != null?'\"' + productName + '\"':null);
    _ret.append(",\n");
    _ret.append("managedElement.ManagedElementType_T managedElementType=");
    _ret.append(managedElementType);
    _ret.append(",\n");
    _ret.append("managedElement.CommunicationState_T communicationState=");
    _ret.append(communicationState);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter1 = 0; $counter1 < additionalInfo.length; $counter1++) {
        _ret.append(additionalInfo[$counter1]);
        if ($counter1 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof managedElement.ManagedElement_T) {
      _cmpMap.put(_currentThread, o);
      final managedElement.ManagedElement_T obj = (managedElement.ManagedElement_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter2 = 0; res && $counter2 < this.name.length; $counter2++) {
                res = this.name[$counter2] == obj.name[$counter2] ||
                 (this.name[$counter2] != null && obj.name[$counter2] != null && this.name[$counter2].equals(obj.name[$counter2]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.location == obj.location ||
         (this.location != null && obj.location != null && this.location.equals(obj.location));
        if (!res) break;
        res = this.version == obj.version ||
         (this.version != null && obj.version != null && this.version.equals(obj.version));
        if (!res) break;
        res = this.productName == obj.productName ||
         (this.productName != null && obj.productName != null && this.productName.equals(obj.productName));
        if (!res) break;
        res = this.managedElementType == obj.managedElementType ||
         (this.managedElementType != null && obj.managedElementType != null && this.managedElementType.equals(obj.managedElementType));
        if (!res) break;
        res = this.communicationState == obj.communicationState ||
         (this.communicationState != null && obj.communicationState != null && this.communicationState.equals(obj.communicationState));
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter3 = 0; res && $counter3 < this.additionalInfo.length; $counter3++) {
              res = this.additionalInfo[$counter3] == obj.additionalInfo[$counter3] ||
               (this.additionalInfo[$counter3] != null && obj.additionalInfo[$counter3] != null && this.additionalInfo[$counter3].equals(obj.additionalInfo[$counter3]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
