package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::SubnetworkIterator
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/SubnetworkIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface SubnetworkIterator {
  ...
};
 * </pre>
 */
public interface SubnetworkIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out multiLayerSubnetwork.MultiLayerSubnetwork_T subnetwork)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (multiLayerSubnetwork.MultiLayerSubnetwork_THolder subnetwork) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out multiLayerSubnetwork.SubnetworkList_T subnetworkList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         multiLayerSubnetwork.SubnetworkList_THolder subnetworkList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
