package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::Topology_T
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/Topology_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum Topology_T {TOPO_SINGLETON, TOPO_POINTTOPOINT, TOPO_LINEAR, TOPO_MESH,
                 TOPO_UPSR, TOPO_OPEN_UPSR, TOPO_2_FIBER_BLSR,
                 TOPO_2_FIBER_OPEN_BLSR, TOPO_4_FIBER_BLSR,
                 TOPO_4_FIBER_OPEN_BLSR};
 * </pre>
 */
public final class Topology_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _TOPO_SINGLETON = 0;
  
  public static final int _TOPO_POINTTOPOINT = 1;
  
  public static final int _TOPO_LINEAR = 2;
  
  public static final int _TOPO_MESH = 3;
  
  public static final int _TOPO_UPSR = 4;
  
  public static final int _TOPO_OPEN_UPSR = 5;
  
  public static final int _TOPO_2_FIBER_BLSR = 6;
  
  public static final int _TOPO_2_FIBER_OPEN_BLSR = 7;
  
  public static final int _TOPO_4_FIBER_BLSR = 8;
  
  public static final int _TOPO_4_FIBER_OPEN_BLSR = 9;

  
  public static final Topology_T TOPO_SINGLETON = new Topology_T(_TOPO_SINGLETON);
  
  public static final Topology_T TOPO_POINTTOPOINT = new Topology_T(_TOPO_POINTTOPOINT);
  
  public static final Topology_T TOPO_LINEAR = new Topology_T(_TOPO_LINEAR);
  
  public static final Topology_T TOPO_MESH = new Topology_T(_TOPO_MESH);
  
  public static final Topology_T TOPO_UPSR = new Topology_T(_TOPO_UPSR);
  
  public static final Topology_T TOPO_OPEN_UPSR = new Topology_T(_TOPO_OPEN_UPSR);
  
  public static final Topology_T TOPO_2_FIBER_BLSR = new Topology_T(_TOPO_2_FIBER_BLSR);
  
  public static final Topology_T TOPO_2_FIBER_OPEN_BLSR = new Topology_T(_TOPO_2_FIBER_OPEN_BLSR);
  
  public static final Topology_T TOPO_4_FIBER_BLSR = new Topology_T(_TOPO_4_FIBER_BLSR);
  
  public static final Topology_T TOPO_4_FIBER_OPEN_BLSR = new Topology_T(_TOPO_4_FIBER_OPEN_BLSR);

  protected Topology_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static Topology_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return TOPO_SINGLETON;
      case 1: return TOPO_POINTTOPOINT;
      case 2: return TOPO_LINEAR;
      case 3: return TOPO_MESH;
      case 4: return TOPO_UPSR;
      case 5: return TOPO_OPEN_UPSR;
      case 6: return TOPO_2_FIBER_BLSR;
      case 7: return TOPO_2_FIBER_OPEN_BLSR;
      case 8: return TOPO_4_FIBER_BLSR;
      case 9: return TOPO_4_FIBER_OPEN_BLSR;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "TOPO_SINGLETON";
      case 1: return "TOPO_POINTTOPOINT";
      case 2: return "TOPO_LINEAR";
      case 3: return "TOPO_MESH";
      case 4: return "TOPO_UPSR";
      case 5: return "TOPO_OPEN_UPSR";
      case 6: return "TOPO_2_FIBER_BLSR";
      case 7: return "TOPO_2_FIBER_OPEN_BLSR";
      case 8: return "TOPO_4_FIBER_BLSR";
      case 9: return "TOPO_4_FIBER_OPEN_BLSR";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof multiLayerSubnetwork.Topology_T
      ? this._value == ((multiLayerSubnetwork.Topology_T)o)._value
      : false;
  }
}
