package multiLayerSubnetwork;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/multiLayerSubnetwork.idl"
 * <li> <b>IDL Name</b>      ::multiLayerSubnetwork::Topology_T
 * <li> <b>Repository Id</b> IDL:multiLayerSubnetwork/Topology_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum Topology_T {TOPO_SINGLETON, TOPO_POINTTOPOINT, TOPO_LINEAR, TOPO_MESH,
                 TOPO_UPSR, TOPO_OPEN_UPSR, TOPO_2_FIBER_BLSR,
                 TOPO_2_FIBER_OPEN_BLSR, TOPO_4_FIBER_BLSR,
                 TOPO_4_FIBER_OPEN_BLSR};
 * </pre>
 */
public final class Topology_THelper {
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static multiLayerSubnetwork.Topology_T read (final org.omg.CORBA.portable.InputStream _input) {
    return multiLayerSubnetwork.Topology_T.from_int(_input.read_long());
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final multiLayerSubnetwork.Topology_T _vis_value) {
    _output.write_long(_vis_value.value());
  }

  public static void insert (final org.omg.CORBA.Any any, final multiLayerSubnetwork.Topology_T _vis_value) {
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      ((com.inprise.vbroker.CORBA.Any)any).insert_enum(_vis_value.value(), multiLayerSubnetwork.Topology_THelper.type());
    }
    else {
      org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
      multiLayerSubnetwork.Topology_THelper.write(output, _vis_value);
      any.read_value(output.create_input_stream(), multiLayerSubnetwork.Topology_THelper.type());
    }

  }

  public static multiLayerSubnetwork.Topology_T extract (final org.omg.CORBA.Any any) {
    multiLayerSubnetwork.Topology_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      _vis_value = multiLayerSubnetwork.Topology_T.from_int(((com.inprise.vbroker.CORBA.Any)any).extract_enum(type()));
    }
    else {
      _vis_value = multiLayerSubnetwork.Topology_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          final java.lang.String members[] = new java.lang.String[] {"TOPO_SINGLETON",
                                                                     "TOPO_POINTTOPOINT",
                                                                     "TOPO_LINEAR",
                                                                     "TOPO_MESH",
                                                                     "TOPO_UPSR",
                                                                     "TOPO_OPEN_UPSR",
                                                                     "TOPO_2_FIBER_BLSR",
                                                                     "TOPO_2_FIBER_OPEN_BLSR",
                                                                     "TOPO_4_FIBER_BLSR",
                                                                     "TOPO_4_FIBER_OPEN_BLSR"};
          _type = _orb().create_enum_tc(id(), "Topology_T", members);
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:multiLayerSubnetwork/Topology_T:1.0";
  }
}
