package networkR1;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/networkR1.idl"
 * <li> <b>IDL Name</b>      ::nutworkR1::NetworkR1
 * <li> <b>Repository Id</b> IDL:nutworkR1/NetworkR1:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NetworkR1 {
  ...
};
 * </pre>
 */
public interface NetworkR1Operations {
  /**
   * <pre>
   *   readonly attribute string name;
   * </pre>
   */
  public java.lang.String name ();

  /**
   * <pre>
   *   readonly attribute string emsVersion;
   * </pre>
   */
  public java.lang.String emsVersion ();

  /**
   * <pre>
   *   readonly attribute string type;
   * </pre>
   */
  public java.lang.String type ();

  /**
   * <pre>
   *   void getAllTopLevelSubnetworks (in unsigned long how_many,
                                  out multiLayerSubnetwork.SubnetworkList_T sList,
                                  out multiLayerSubnetwork.SubnetworkIterator sIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworks (int how_many, 
                                         multiLayerSubnetwork.SubnetworkList_THolder sList, 
                                         multiLayerSubnetwork.SubnetworkIteratorHolder sIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void getAllTopLevelSubnetworkNames (in unsigned long how_many,
                                      out globaldefs.NamingAttributesList_T nameList,
                                      out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworkNames (int how_many, 
                                             globaldefs.NamingAttributesList_THolder nameList, 
                                             globaldefs.NamingAttributesIteratorHolder nameIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinks (in unsigned long how_many,
                                       out topologicalLink.TopologicalLinkList_T topoList,
                                       out topologicalLink.TopologicalLinkIterator topoIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinks (int how_many, 
                                              topologicalLink.TopologicalLinkList_THolder topoList, 
                                              topologicalLink.TopologicalLinkIteratorHolder topoIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinkNames (in unsigned long how_many,
                                           out globaldefs.NamingAttributesList_T nameList,
                                           out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinkNames (int how_many, 
                                                  globaldefs.NamingAttributesList_THolder nameList, 
                                                  globaldefs.NamingAttributesIteratorHolder nameIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void getAllEMSActiveAlarms (in notifications.ProbableCauseList_T excludeProbCauseList,
                              in unsigned long how_many,
                              out notifications.EventList_T eventList,
                              out notifications.EventIterator eventIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEMSActiveAlarms (java.lang.String[] excludeProbCauseList, 
                                     int how_many, 
                                     notifications.EventList_THolder eventList, 
                                     notifications.EventIteratorHolder eventIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   managedElementManager.ManagedElementMgr getManagedElementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public managedElementManager.ManagedElementMgr getManagedElementMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   performance.PerformanceManagementMgr getPerformanceManagementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public performance.PerformanceManagementMgr getPerformanceManagementMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   protection.ProtectionMgr getProtectionMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public protection.ProtectionMgr getProtectionMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr () throws globaldefs.ProcessingFailureException;

}
