package networkR1;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/networkR1.idl"
 * <li> <b>IDL Name</b>      ::nutworkR1::NetworkR1
 * <li> <b>Repository Id</b> IDL:nutworkR1/NetworkR1:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NetworkR1 {
  ...
};
 * </pre>
 */
public class _NetworkR1Stub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements NetworkR1 {
  final public static java.lang.Class _opsClass = networkR1.NetworkR1Operations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:nutworkR1/NetworkR1:1.0"
  };

  /**
   * <pre>
   *   readonly attribute string name;
   * </pre>
   */
  public java.lang.String name () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        java.lang.String _result;
        try {
          _output = this._request("_get_name", true);
          _input = this._invoke(_output);
          _result = _input.read_string();
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_name", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.name();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   readonly attribute string emsVersion;
   * </pre>
   */
  public java.lang.String emsVersion () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        java.lang.String _result;
        try {
          _output = this._request("_get_emsVersion", true);
          _input = this._invoke(_output);
          _result = _input.read_string();
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_emsVersion", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.emsVersion();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   readonly attribute string type;
   * </pre>
   */
  public java.lang.String type () {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        java.lang.String _result;
        try {
          _output = this._request("_get_type", true);
          _input = this._invoke(_output);
          _result = _input.read_string();
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("_get_type", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.type();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   void getAllTopLevelSubnetworks (in unsigned long how_many,
                                  out multiLayerSubnetwork.SubnetworkList_T sList,
                                  out multiLayerSubnetwork.SubnetworkIterator sIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworks (int how_many, 
                                         multiLayerSubnetwork.SubnetworkList_THolder sList, 
                                         multiLayerSubnetwork.SubnetworkIteratorHolder sIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTopLevelSubnetworks", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          sList.value = multiLayerSubnetwork.SubnetworkList_THelper.read(_input);
          sIt.value = multiLayerSubnetwork.SubnetworkIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTopLevelSubnetworks", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          _self.getAllTopLevelSubnetworks(how_many, sList, sIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllTopLevelSubnetworkNames (in unsigned long how_many,
                                      out globaldefs.NamingAttributesList_T nameList,
                                      out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelSubnetworkNames (int how_many, 
                                             globaldefs.NamingAttributesList_THolder nameList, 
                                             globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTopLevelSubnetworkNames", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTopLevelSubnetworkNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          _self.getAllTopLevelSubnetworkNames(how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinks (in unsigned long how_many,
                                       out topologicalLink.TopologicalLinkList_T topoList,
                                       out topologicalLink.TopologicalLinkIterator topoIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinks (int how_many, 
                                              topologicalLink.TopologicalLinkList_THolder topoList, 
                                              topologicalLink.TopologicalLinkIteratorHolder topoIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTopLevelTopologicalLinks", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          topoList.value = topologicalLink.TopologicalLinkList_THelper.read(_input);
          topoIt.value = topologicalLink.TopologicalLinkIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTopLevelTopologicalLinks", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          _self.getAllTopLevelTopologicalLinks(how_many, topoList, topoIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllTopLevelTopologicalLinkNames (in unsigned long how_many,
                                           out globaldefs.NamingAttributesList_T nameList,
                                           out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTopLevelTopologicalLinkNames (int how_many, 
                                                  globaldefs.NamingAttributesList_THolder nameList, 
                                                  globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllTopLevelTopologicalLinkNames", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllTopLevelTopologicalLinkNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          _self.getAllTopLevelTopologicalLinkNames(how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllEMSActiveAlarms (in notifications.ProbableCauseList_T excludeProbCauseList,
                              in unsigned long how_many,
                              out notifications.EventList_T eventList,
                              out notifications.EventIterator eventIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllEMSActiveAlarms (java.lang.String[] excludeProbCauseList, 
                                     int how_many, 
                                     notifications.EventList_THolder eventList, 
                                     notifications.EventIteratorHolder eventIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllEMSActiveAlarms", true);
          notifications.ProbableCauseList_THelper.write(_output, excludeProbCauseList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          eventList.value = notifications.EventList_THelper.read(_input);
          eventIt.value = notifications.EventIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllEMSActiveAlarms", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          _self.getAllEMSActiveAlarms(excludeProbCauseList, how_many, eventList, 
                                      eventIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public multiLayerSubnetwork.MultiLayerSubnetworkMgr getMultiLayerSubnetworkMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        multiLayerSubnetwork.MultiLayerSubnetworkMgr _result;
        try {
          _output = this._request("getMultiLayerSubnetworkMgr", true);
          _input = this._invoke(_output);
          _result = multiLayerSubnetwork.MultiLayerSubnetworkMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getMultiLayerSubnetworkMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getMultiLayerSubnetworkMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   managedElementManager.ManagedElementMgr getManagedElementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public managedElementManager.ManagedElementMgr getManagedElementMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        managedElementManager.ManagedElementMgr _result;
        try {
          _output = this._request("getManagedElementMgr", true);
          _input = this._invoke(_output);
          _result = managedElementManager.ManagedElementMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getManagedElementMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getManagedElementMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public equipmentInventory.EquipmentInventoryMgr getEquipmentInventoryMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        equipmentInventory.EquipmentInventoryMgr _result;
        try {
          _output = this._request("getEquipmentInventoryMgr", true);
          _input = this._invoke(_output);
          _result = equipmentInventory.EquipmentInventoryMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getEquipmentInventoryMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getEquipmentInventoryMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   performance.PerformanceManagementMgr getPerformanceManagementMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public performance.PerformanceManagementMgr getPerformanceManagementMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        performance.PerformanceManagementMgr _result;
        try {
          _output = this._request("getPerformanceManagementMgr", true);
          _input = this._invoke(_output);
          _result = performance.PerformanceManagementMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getPerformanceManagementMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getPerformanceManagementMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   protection.ProtectionMgr getProtectionMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public protection.ProtectionMgr getProtectionMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        protection.ProtectionMgr _result;
        try {
          _output = this._request("getProtectionMgr", true);
          _input = this._invoke(_output);
          _result = protection.ProtectionMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getProtectionMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getProtectionMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public trafficDescriptor.TrafficDescriptorMgr getTrafficDescriptorMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        trafficDescriptor.TrafficDescriptorMgr _result;
        try {
          _output = this._request("getTrafficDescriptorMgr", true);
          _input = this._invoke(_output);
          _result = trafficDescriptor.TrafficDescriptorMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getTrafficDescriptorMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getTrafficDescriptorMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

  /**
   * <pre>
   *   guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public guiCutThrough.GuiCutThroughMgr getGuiCutThroughMgr () throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        guiCutThrough.GuiCutThroughMgr _result;
        try {
          _output = this._request("getGuiCutThroughMgr", true);
          _input = this._invoke(_output);
          _result = guiCutThrough.GuiCutThroughMgrHelper.read(_input);
          return _result;
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getGuiCutThroughMgr", _opsClass);
        if (_so == null) {
          continue;
        }
        final networkR1.NetworkR1Operations _self = (networkR1.NetworkR1Operations)_so.servant;
        try {
          return _self.getGuiCutThroughMgr();
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
    }
  }

}
