package notifications;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/notifications.idl"
 * <li> <b>IDL Name</b>      ::notifications::AlarmType_T
 * <li> <b>Repository Id</b> IDL:notifications/AlarmType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum AlarmType_T {AT_ALARM, AT_EXTERNAL_ALARM, AT_TRANSIENT_EVENT};
 * </pre>
 */
public final class AlarmType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _AT_ALARM = 0;
  
  public static final int _AT_EXTERNAL_ALARM = 1;
  
  public static final int _AT_TRANSIENT_EVENT = 2;

  
  public static final AlarmType_T AT_ALARM = new AlarmType_T(_AT_ALARM);
  
  public static final AlarmType_T AT_EXTERNAL_ALARM = new AlarmType_T(_AT_EXTERNAL_ALARM);
  
  public static final AlarmType_T AT_TRANSIENT_EVENT = new AlarmType_T(_AT_TRANSIENT_EVENT);

  protected AlarmType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static AlarmType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return AT_ALARM;
      case 1: return AT_EXTERNAL_ALARM;
      case 2: return AT_TRANSIENT_EVENT;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "AT_ALARM";
      case 1: return "AT_EXTERNAL_ALARM";
      case 2: return "AT_TRANSIENT_EVENT";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof notifications.AlarmType_T
      ? this._value == ((notifications.AlarmType_T)o)._value
      : false;
  }
}
