package notifications;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/notifications.idl"
 * <li> <b>IDL Name</b>      ::notifications::EventIterator
 * <li> <b>Repository Id</b> IDL:notifications/EventIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface EventIterator {
  ...
};
 * </pre>
 */
public interface EventIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out CosNotification.StructuredEvent event)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (CosNotification.StructuredEventHolder event) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out notifications.EventList_T eventList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         notifications.EventList_THolder eventList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
