package notifications;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/notifications.idl"
 * <li> <b>IDL Name</b>      ::notifications::ObjectType_T
 * <li> <b>Repository Id</b> IDL:notifications/ObjectType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ObjectType_T {OT_NETWORK_R1, OT_MANAGED_ELEMENT, OT_MULTILAYER_SUBNETWORK,
                   OT_TOPOLOGICAL_LINK, OT_SUBNETWORK_CONNECTION,
                   OT_TERMINATION_POINT, OT_EQUIPMENT, OT_PROTECTION_GROUP,
                   OT_TRAFFIC_DESCRIPTOR, OT_AID};
 * </pre>
 */
public final class ObjectType_THelper {
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static notifications.ObjectType_T read (final org.omg.CORBA.portable.InputStream _input) {
    return notifications.ObjectType_T.from_int(_input.read_long());
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final notifications.ObjectType_T _vis_value) {
    _output.write_long(_vis_value.value());
  }

  public static void insert (final org.omg.CORBA.Any any, final notifications.ObjectType_T _vis_value) {
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      ((com.inprise.vbroker.CORBA.Any)any).insert_enum(_vis_value.value(), notifications.ObjectType_THelper.type());
    }
    else {
      org.omg.CORBA.portable.OutputStream output = any.create_output_stream();
      notifications.ObjectType_THelper.write(output, _vis_value);
      any.read_value(output.create_input_stream(), notifications.ObjectType_THelper.type());
    }

  }

  public static notifications.ObjectType_T extract (final org.omg.CORBA.Any any) {
    notifications.ObjectType_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      _vis_value = notifications.ObjectType_T.from_int(((com.inprise.vbroker.CORBA.Any)any).extract_enum(type()));
    }
    else {
      _vis_value = notifications.ObjectType_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          final java.lang.String members[] = new java.lang.String[] {"OT_NETWORK_R1",
                                                                     "OT_MANAGED_ELEMENT",
                                                                     "OT_MULTILAYER_SUBNETWORK",
                                                                     "OT_TOPOLOGICAL_LINK",
                                                                     "OT_SUBNETWORK_CONNECTION",
                                                                     "OT_TERMINATION_POINT",
                                                                     "OT_EQUIPMENT",
                                                                     "OT_PROTECTION_GROUP",
                                                                     "OT_TRAFFIC_DESCRIPTOR",
                                                                     "OT_AID"};
          _type = _orb().create_enum_tc(id(), "ObjectType_T", members);
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:notifications/ObjectType_T:1.0";
  }
}
