package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PMDataIterator
 * <li> <b>Repository Id</b> IDL:performance/PMDataIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface PMDataIterator {
  ...
};
 * </pre>
 */
public interface PMDataIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out performance.PMData_T pmData)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (performance.PMData_THolder pmData) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out performance.PMDataList_T pmDataList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         performance.PMDataList_THolder pmDataList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
