package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PMDataIterator
 * <li> <b>Repository Id</b> IDL:performance/PMDataIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface PMDataIterator {
  ...
};
 * </pre>
 */
public class PMDataIteratorPOATie extends PMDataIteratorPOA {
  private performance.PMDataIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public PMDataIteratorPOATie (final performance.PMDataIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public PMDataIteratorPOATie (final performance.PMDataIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public performance.PMDataIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final performance.PMDataIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out performance.PMData_T pmData)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (performance.PMData_THolder pmData) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(pmData);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out performance.PMDataList_T pmDataList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         performance.PMDataList_THolder pmDataList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, pmDataList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
