package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PMData_T
 * <li> <b>Repository Id</b> IDL:performance/PMData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct PMData_T {
  ...
};
 * </pre>
 */
public final class PMData_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] tpName;
  
  public short layerRate;
  
  public java.lang.String granularity;
  
  public java.lang.String startTime;
  
  public performance.PMMeasurement_T[] pmMeasurementList;

  public PMData_T () {
  }

  public PMData_T (final globaldefs.NameAndStringValue_T[] tpName, 
                   final short layerRate, 
                   final java.lang.String granularity, 
                   final java.lang.String startTime, 
                   final performance.PMMeasurement_T[] pmMeasurementList) {
    this.tpName = tpName;
    this.layerRate = layerRate;
    this.granularity = granularity;
    this.startTime = startTime;
    this.pmMeasurementList = pmMeasurementList;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct performance.PMData_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] tpName=");
    _ret.append("{");
    if (tpName == null) {
      _ret.append(tpName);
    } else {
      for (int $counter15 = 0; $counter15 < tpName.length; $counter15++) {
        _ret.append(tpName[$counter15]);
        if ($counter15 < tpName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("short layerRate=");
    _ret.append(layerRate);
    _ret.append(",\n");
    _ret.append("java.lang.String granularity=");
    _ret.append(granularity != null?'\"' + granularity + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String startTime=");
    _ret.append(startTime != null?'\"' + startTime + '\"':null);
    _ret.append(",\n");
    _ret.append("performance.PMMeasurement_T[] pmMeasurementList=");
    _ret.append("{");
    if (pmMeasurementList == null) {
      _ret.append(pmMeasurementList);
    } else {
      for (int $counter16 = 0; $counter16 < pmMeasurementList.length; $counter16++) {
        _ret.append(pmMeasurementList[$counter16]);
        if ($counter16 < pmMeasurementList.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof performance.PMData_T) {
      _cmpMap.put(_currentThread, o);
      final performance.PMData_T obj = (performance.PMData_T)o;
      boolean res = true;
      do {
            if (res = (this.tpName.length == obj.tpName.length)) {
              for (int $counter17 = 0; res && $counter17 < this.tpName.length; $counter17++) {
                res = this.tpName[$counter17] == obj.tpName[$counter17] ||
                 (this.tpName[$counter17] != null && obj.tpName[$counter17] != null && this.tpName[$counter17].equals(obj.tpName[$counter17]));
              }
            }
        if (!res) break;
          res = this.layerRate == obj.layerRate;
        if (!res) break;
          res = this.granularity == obj.granularity ||
           (this.granularity != null && obj.granularity != null && this.granularity.equals(obj.granularity));
        if (!res) break;
          res = this.startTime == obj.startTime ||
           (this.startTime != null && obj.startTime != null && this.startTime.equals(obj.startTime));
        if (!res) break;
          if (res = (this.pmMeasurementList.length == obj.pmMeasurementList.length)) {
            for (int $counter18 = 0; res && $counter18 < this.pmMeasurementList.length; $counter18++) {
              res = this.pmMeasurementList[$counter18] == obj.pmMeasurementList[$counter18] ||
               (this.pmMeasurementList[$counter18] != null && obj.pmMeasurementList[$counter18] != null && this.pmMeasurementList[$counter18].equals(obj.pmMeasurementList[$counter18]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
