package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PMData_T
 * <li> <b>Repository Id</b> IDL:performance/PMData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct PMData_T {
  ...
};
 * </pre>
 */
public final class PMData_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static performance.PMData_T read (final org.omg.CORBA.portable.InputStream _input) {
    final performance.PMData_T _result = new performance.PMData_T();
    _result.tpName = globaldefs.NamingAttributes_THelper.read(_input);
    _result.layerRate = _input.read_short();
    _result.granularity = _input.read_string();
    _result.startTime = _input.read_string();
    _result.pmMeasurementList = performance.PMMeasurementList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final performance.PMData_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.tpName);
    _output.write_short((short)_vis_value.layerRate);
    _output.write_string((java.lang.String)_vis_value.granularity);
    _output.write_string((java.lang.String)_vis_value.startTime);
    performance.PMMeasurementList_THelper.write(_output, _vis_value.pmMeasurementList);
  }

  public static void insert (final org.omg.CORBA.Any any, final performance.PMData_T _vis_value) {
    any.insert_Streamable(new performance.PMData_THolder(_vis_value));
  }

  public static performance.PMData_T extract (final org.omg.CORBA.Any any) {
    performance.PMData_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      performance.PMData_THolder _vis_holder = new performance.PMData_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = performance.PMData_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[5];
          members[0] = new org.omg.CORBA.StructMember("tpName", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("layerRate", transmissionParameters.LayerRate_THelper.type(), null);
          members[2] = new org.omg.CORBA.StructMember("granularity", performance.Granularity_THelper.type(), null);
          members[3] = new org.omg.CORBA.StructMember("startTime", globaldefs.Time_THelper.type(), null);
          members[4] = new org.omg.CORBA.StructMember("pmMeasurementList", performance.PMMeasurementList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "PMData_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:performance/PMData_T:1.0";
  }
}
