package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::TCAParameters_T
 * <li> <b>Repository Id</b> IDL:performance/TCAParameters_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TCAParameters_T {
  ...
};
 * </pre>
 */
public final class TCAParameters_T implements org.omg.CORBA.portable.IDLEntity {
  
  public short layer;
  
  public performance.PMParameterValue_T[] TCATypeValues;
  
  public java.lang.String granularity;
  
  public performance.ThresholdWaterMark_T thresholdwatermark;

  public TCAParameters_T () {
  }

  public TCAParameters_T (final short layer, 
                          final performance.PMParameterValue_T[] TCATypeValues, 
                          final java.lang.String granularity, 
                          final performance.ThresholdWaterMark_T thresholdwatermark) {
    this.layer = layer;
    this.TCATypeValues = TCATypeValues;
    this.granularity = granularity;
    this.thresholdwatermark = thresholdwatermark;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct performance.TCAParameters_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("short layer=");
    _ret.append(layer);
    _ret.append(",\n");
    _ret.append("performance.PMParameterValue_T[] TCATypeValues=");
    _ret.append("{");
    if (TCATypeValues == null) {
      _ret.append(TCATypeValues);
    } else {
      for (int $counter33 = 0; $counter33 < TCATypeValues.length; $counter33++) {
        _ret.append(TCATypeValues[$counter33]);
        if ($counter33 < TCATypeValues.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String granularity=");
    _ret.append(granularity != null?'\"' + granularity + '\"':null);
    _ret.append(",\n");
    _ret.append("performance.ThresholdWaterMark_T thresholdwatermark=");
    _ret.append(thresholdwatermark);
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof performance.TCAParameters_T) {
      _cmpMap.put(_currentThread, o);
      final performance.TCAParameters_T obj = (performance.TCAParameters_T)o;
      boolean res = true;
      do {
          res = this.layer == obj.layer;
        if (!res) break;
          if (res = (this.TCATypeValues.length == obj.TCATypeValues.length)) {
            for (int $counter34 = 0; res && $counter34 < this.TCATypeValues.length; $counter34++) {
              res = this.TCATypeValues[$counter34] == obj.TCATypeValues[$counter34] ||
               (this.TCATypeValues[$counter34] != null && obj.TCATypeValues[$counter34] != null && this.TCATypeValues[$counter34].equals(obj.TCATypeValues[$counter34]));
            }
          }
        if (!res) break;
          res = this.granularity == obj.granularity ||
           (this.granularity != null && obj.granularity != null && this.granularity.equals(obj.granularity));
        if (!res) break;
        res = this.thresholdwatermark == obj.thresholdwatermark ||
         (this.thresholdwatermark != null && obj.thresholdwatermark != null && this.thresholdwatermark.equals(obj.thresholdwatermark));
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
