package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::TCAParameters_T
 * <li> <b>Repository Id</b> IDL:performance/TCAParameters_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TCAParameters_T {
  ...
};
 * </pre>
 */
public final class TCAParameters_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static performance.TCAParameters_T read (final org.omg.CORBA.portable.InputStream _input) {
    final performance.TCAParameters_T _result = new performance.TCAParameters_T();
    _result.layer = _input.read_short();
    _result.TCATypeValues = performance.PMParameterValueList_THelper.read(_input);
    _result.granularity = _input.read_string();
    _result.thresholdwatermark = performance.ThresholdWaterMark_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final performance.TCAParameters_T _vis_value) {
    _output.write_short((short)_vis_value.layer);
    performance.PMParameterValueList_THelper.write(_output, _vis_value.TCATypeValues);
    _output.write_string((java.lang.String)_vis_value.granularity);
    performance.ThresholdWaterMark_THelper.write(_output, _vis_value.thresholdwatermark);
  }

  public static void insert (final org.omg.CORBA.Any any, final performance.TCAParameters_T _vis_value) {
    any.insert_Streamable(new performance.TCAParameters_THolder(_vis_value));
  }

  public static performance.TCAParameters_T extract (final org.omg.CORBA.Any any) {
    performance.TCAParameters_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      performance.TCAParameters_THolder _vis_holder = new performance.TCAParameters_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = performance.TCAParameters_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[4];
          members[0] = new org.omg.CORBA.StructMember("layer", transmissionParameters.LayerRate_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("TCATypeValues", performance.PMParameterValueList_THelper.type(), null);
          members[2] = new org.omg.CORBA.StructMember("granularity", performance.Granularity_THelper.type(), null);
          members[3] = new org.omg.CORBA.StructMember("thresholdwatermark", performance.ThresholdWaterMark_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "TCAParameters_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:performance/TCAParameters_T:1.0";
  }
}
