package performance;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/performance.idl"
 * <li> <b>IDL Name</b>      ::performance::PerformanceManagementMgr
 * <li> <b>Repository Id</b> IDL:performance/PerformanceManagementMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface PerformanceManagementMgr {
  ...
};
 * </pre>
 */
public class _PerformanceManagementMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements PerformanceManagementMgr {
  final public static java.lang.Class _opsClass = performance.PerformanceManagementMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:performance/PerformanceManagementMgr:1.0"
  };

  /**
   * <pre>
   *   void getMEPMcapabilities (in globaldefs.NamingAttributes_T neName,
                            in transmissionParameters.LayerRate_T layerRate,
                            out performance.PMParameterList_T pmParameterList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getMEPMcapabilities (globaldefs.NameAndStringValue_T[] neName, 
                                   short layerRate, 
                                   performance.PMParameterList_THolder pmParameterList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getMEPMcapabilities", true);
          globaldefs.NamingAttributes_THelper.write(_output, neName);
          _output.write_short((short)layerRate);
          _input = this._invoke(_output);
          pmParameterList.value = performance.PMParameterList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getMEPMcapabilities", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.getMEPMcapabilities(neName, layerRate, pmParameterList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void disablePMData (in performance.PMTPSelectList_T pmTPSelectList,
                      out performance.PMTPSelectList_T failedTPSelectList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void disablePMData (performance.PMTPSelect_T[] pmTPSelectList, 
                             performance.PMTPSelectList_THolder failedTPSelectList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("disablePMData", true);
          performance.PMTPSelectList_THelper.write(_output, pmTPSelectList);
          _input = this._invoke(_output);
          failedTPSelectList.value = performance.PMTPSelectList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("disablePMData", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.disablePMData(pmTPSelectList, failedTPSelectList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void enablePMData (in performance.PMTPSelectList_T pmTPSelectList,
                     out performance.PMTPSelectList_T failedTPSelectList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void enablePMData (performance.PMTPSelect_T[] pmTPSelectList, 
                            performance.PMTPSelectList_THolder failedTPSelectList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("enablePMData", true);
          performance.PMTPSelectList_THelper.write(_output, pmTPSelectList);
          _input = this._invoke(_output);
          failedTPSelectList.value = performance.PMTPSelectList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("enablePMData", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.enablePMData(pmTPSelectList, failedTPSelectList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getHoldingTime (out performance.HoldingTime_T holdingTime)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getHoldingTime (performance.HoldingTime_THolder holdingTime) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getHoldingTime", true);
          _input = this._invoke(_output);
          holdingTime.value = performance.HoldingTime_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getHoldingTime", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.getHoldingTime(holdingTime);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getTCATPParameter (in globaldefs.NamingAttributes_T tpName,
                          in transmissionParameters.LayerRate_T layerRate,
                          in performance.Granularity_T granularity,
                          out performance.TCAParameters_T tcaParameter)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getTCATPParameter (globaldefs.NameAndStringValue_T[] tpName, 
                                 short layerRate, 
                                 java.lang.String granularity, 
                                 performance.TCAParameters_THolder tcaParameter) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getTCATPParameter", true);
          globaldefs.NamingAttributes_THelper.write(_output, tpName);
          _output.write_short((short)layerRate);
          _output.write_string((java.lang.String)granularity);
          _input = this._invoke(_output);
          tcaParameter.value = performance.TCAParameters_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getTCATPParameter", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.getTCATPParameter(tpName, layerRate, granularity, tcaParameter);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getHistoryPMData (in performance.Destination_T destination,
                         in string userName, in string password,
                         in performance.PMTPSelectList_T pmTPSelectList,
                         in globaldefs.Time_T startTime,
                         in globaldefs.Time_T endTime)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getHistoryPMData (java.lang.String destination, 
                                java.lang.String userName, 
                                java.lang.String password, 
                                performance.PMTPSelect_T[] pmTPSelectList, 
                                java.lang.String startTime, 
                                java.lang.String endTime) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getHistoryPMData", true);
          _output.write_string((java.lang.String)destination);
          _output.write_string((java.lang.String)userName);
          _output.write_string((java.lang.String)password);
          performance.PMTPSelectList_THelper.write(_output, pmTPSelectList);
          _output.write_string((java.lang.String)startTime);
          _output.write_string((java.lang.String)endTime);
          _input = this._invoke(_output);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getHistoryPMData", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.getHistoryPMData(destination, userName, password, pmTPSelectList, 
                                 startTime, endTime);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllCurrentPMData (in performance.PMTPSelectList_T pmTPSelectList,
                            in unsigned long how_many,
                            out performance.PMDataList_T pmDataList,
                            out performance.PMDataIterator pmIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllCurrentPMData (performance.PMTPSelect_T[] pmTPSelectList, 
                                   int how_many, 
                                   performance.PMDataList_THolder pmDataList, 
                                   performance.PMDataIteratorHolder pmIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllCurrentPMData", true);
          performance.PMTPSelectList_THelper.write(_output, pmTPSelectList);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          pmDataList.value = performance.PMDataList_THelper.read(_input);
          pmIt.value = performance.PMDataIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllCurrentPMData", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.getAllCurrentPMData(pmTPSelectList, how_many, pmDataList, pmIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void setTCATPParameter (in globaldefs.NamingAttributes_T name,
                          inout performance.TCAParameters_T tcaParameters)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void setTCATPParameter (globaldefs.NameAndStringValue_T[] name, 
                                 performance.TCAParameters_THolder tcaParameters) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("setTCATPParameter", true);
          globaldefs.NamingAttributes_THelper.write(_output, name);
          performance.TCAParameters_THelper.write(_output, tcaParameters.value);
          _input = this._invoke(_output);
          tcaParameters.value = performance.TCAParameters_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("setTCATPParameter", _opsClass);
        if (_so == null) {
          continue;
        }
        final performance.PerformanceManagementMgrOperations _self = (performance.PerformanceManagementMgrOperations)_so.servant;
        try {
          _self.setTCATPParameter(name, tcaParameters);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
