package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionGroupIterator
 * <li> <b>Repository Id</b> IDL:protection/ProtectionGroupIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ProtectionGroupIterator {
  ...
};
 * </pre>
 */
public interface ProtectionGroupIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out protection.ProtectionGroup_T pgp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (protection.ProtectionGroup_THolder pgp) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out protection.ProtectionGroupList_T pgpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         protection.ProtectionGroupList_THolder pgpList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
