package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionGroupType_T
 * <li> <b>Repository Id</b> IDL:protection/ProtectionGroupType_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ProtectionGroupType_T {PGT_MSP_1_PLUS_1, PGT_MSP_1_FOR_N,
                            PGT_2_FIBER_BLSR, PGT_4_FIBER_BLSR};
 * </pre>
 */
public final class ProtectionGroupType_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _PGT_MSP_1_PLUS_1 = 0;
  
  public static final int _PGT_MSP_1_FOR_N = 1;
  
  public static final int _PGT_2_FIBER_BLSR = 2;
  
  public static final int _PGT_4_FIBER_BLSR = 3;

  
  public static final ProtectionGroupType_T PGT_MSP_1_PLUS_1 = new ProtectionGroupType_T(_PGT_MSP_1_PLUS_1);
  
  public static final ProtectionGroupType_T PGT_MSP_1_FOR_N = new ProtectionGroupType_T(_PGT_MSP_1_FOR_N);
  
  public static final ProtectionGroupType_T PGT_2_FIBER_BLSR = new ProtectionGroupType_T(_PGT_2_FIBER_BLSR);
  
  public static final ProtectionGroupType_T PGT_4_FIBER_BLSR = new ProtectionGroupType_T(_PGT_4_FIBER_BLSR);

  protected ProtectionGroupType_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ProtectionGroupType_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return PGT_MSP_1_PLUS_1;
      case 1: return PGT_MSP_1_FOR_N;
      case 2: return PGT_2_FIBER_BLSR;
      case 3: return PGT_4_FIBER_BLSR;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "PGT_MSP_1_PLUS_1";
      case 1: return "PGT_MSP_1_FOR_N";
      case 2: return "PGT_2_FIBER_BLSR";
      case 3: return "PGT_4_FIBER_BLSR";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof protection.ProtectionGroupType_T
      ? this._value == ((protection.ProtectionGroupType_T)o)._value
      : false;
  }
}
