package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionGroup_T
 * <li> <b>Repository Id</b> IDL:protection/ProtectionGroup_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct ProtectionGroup_T {
  ...
};
 * </pre>
 */
public final class ProtectionGroup_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public protection.ProtectionGroupType_T protectionType;
  
  public protection.ProtectionSchemeState_T protectionSchemeState;
  
  public protection.ReversionMode_T reversionMode;
  
  public boolean nonPreEmptibleTraffic;
  
  public short wtrTime;
  
  public short rate;
  
  public globaldefs.NameAndStringValue_T[][] pgpTPList;
  
  public globaldefs.NameAndStringValue_T[] pgpParameters;

  public ProtectionGroup_T () {
  }

  public ProtectionGroup_T (final globaldefs.NameAndStringValue_T[] name, 
                            final java.lang.String userLabel, 
                            final java.lang.String nativeEMSName, 
                            final java.lang.String owner, 
                            final protection.ProtectionGroupType_T protectionType, 
                            final protection.ProtectionSchemeState_T protectionSchemeState, 
                            final protection.ReversionMode_T reversionMode, 
                            final boolean nonPreEmptibleTraffic, 
                            final short wtrTime, 
                            final short rate, 
                            final globaldefs.NameAndStringValue_T[][] pgpTPList, 
                            final globaldefs.NameAndStringValue_T[] pgpParameters) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.protectionType = protectionType;
    this.protectionSchemeState = protectionSchemeState;
    this.reversionMode = reversionMode;
    this.nonPreEmptibleTraffic = nonPreEmptibleTraffic;
    this.wtrTime = wtrTime;
    this.rate = rate;
    this.pgpTPList = pgpTPList;
    this.pgpParameters = pgpParameters;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct protection.ProtectionGroup_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("protection.ProtectionGroupType_T protectionType=");
    _ret.append(protectionType);
    _ret.append(",\n");
    _ret.append("protection.ProtectionSchemeState_T protectionSchemeState=");
    _ret.append(protectionSchemeState);
    _ret.append(",\n");
    _ret.append("protection.ReversionMode_T reversionMode=");
    _ret.append(reversionMode);
    _ret.append(",\n");
    _ret.append("boolean nonPreEmptibleTraffic=");
    _ret.append(nonPreEmptibleTraffic);
    _ret.append(",\n");
    _ret.append("short wtrTime=");
    _ret.append(wtrTime);
    _ret.append(",\n");
    _ret.append("short rate=");
    _ret.append(rate);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[][] pgpTPList=");
    _ret.append("{");
    if (pgpTPList == null) {
      _ret.append(pgpTPList);
    } else {
      for (int $counter1 = 0; $counter1 < pgpTPList.length; $counter1++) {
        _ret.append("{");
        if (pgpTPList[$counter1] == null) {
          _ret.append(pgpTPList[$counter1]);
        } else {
          for (int $counter2 = 0; $counter2 < pgpTPList[$counter1].length; $counter2++) {
            _ret.append(pgpTPList[$counter1][$counter2]);
            if ($counter2 < pgpTPList[$counter1].length - 1) {
              _ret.append(",");
            }
          }
        }
        _ret.append("}");
        if ($counter1 < pgpTPList.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] pgpParameters=");
    _ret.append("{");
    if (pgpParameters == null) {
      _ret.append(pgpParameters);
    } else {
      for (int $counter3 = 0; $counter3 < pgpParameters.length; $counter3++) {
        _ret.append(pgpParameters[$counter3]);
        if ($counter3 < pgpParameters.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof protection.ProtectionGroup_T) {
      _cmpMap.put(_currentThread, o);
      final protection.ProtectionGroup_T obj = (protection.ProtectionGroup_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter4 = 0; res && $counter4 < this.name.length; $counter4++) {
                res = this.name[$counter4] == obj.name[$counter4] ||
                 (this.name[$counter4] != null && obj.name[$counter4] != null && this.name[$counter4].equals(obj.name[$counter4]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.protectionType == obj.protectionType ||
         (this.protectionType != null && obj.protectionType != null && this.protectionType.equals(obj.protectionType));
        if (!res) break;
        res = this.protectionSchemeState == obj.protectionSchemeState ||
         (this.protectionSchemeState != null && obj.protectionSchemeState != null && this.protectionSchemeState.equals(obj.protectionSchemeState));
        if (!res) break;
        res = this.reversionMode == obj.reversionMode ||
         (this.reversionMode != null && obj.reversionMode != null && this.reversionMode.equals(obj.reversionMode));
        if (!res) break;
        res = this.nonPreEmptibleTraffic == obj.nonPreEmptibleTraffic;
        if (!res) break;
        res = this.wtrTime == obj.wtrTime;
        if (!res) break;
          res = this.rate == obj.rate;
        if (!res) break;
          if (res = (this.pgpTPList.length == obj.pgpTPList.length)) {
            for (int $counter5 = 0; res && $counter5 < this.pgpTPList.length; $counter5++) {
                  if (res = (this.pgpTPList[$counter5].length == obj.pgpTPList[$counter5].length)) {
                    for (int $counter6 = 0; res && $counter6 < this.pgpTPList[$counter5].length; $counter6++) {
                      res = this.pgpTPList[$counter5][$counter6] == obj.pgpTPList[$counter5][$counter6] ||
                       (this.pgpTPList[$counter5][$counter6] != null && obj.pgpTPList[$counter5][$counter6] != null && this.pgpTPList[$counter5][$counter6].equals(obj.pgpTPList[$counter5][$counter6]));
                    }
                  }
            }
          }
        if (!res) break;
          if (res = (this.pgpParameters.length == obj.pgpParameters.length)) {
            for (int $counter7 = 0; res && $counter7 < this.pgpParameters.length; $counter7++) {
              res = this.pgpParameters[$counter7] == obj.pgpParameters[$counter7] ||
               (this.pgpParameters[$counter7] != null && obj.pgpParameters[$counter7] != null && this.pgpParameters[$counter7].equals(obj.pgpParameters[$counter7]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
