package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionGroup_T
 * <li> <b>Repository Id</b> IDL:protection/ProtectionGroup_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct ProtectionGroup_T {
  ...
};
 * </pre>
 */
public final class ProtectionGroup_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static protection.ProtectionGroup_T read (final org.omg.CORBA.portable.InputStream _input) {
    final protection.ProtectionGroup_T _result = new protection.ProtectionGroup_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.protectionType = protection.ProtectionGroupType_THelper.read(_input);
    _result.protectionSchemeState = protection.ProtectionSchemeState_THelper.read(_input);
    _result.reversionMode = protection.ReversionMode_THelper.read(_input);
    _result.nonPreEmptibleTraffic = _input.read_boolean();
    _result.wtrTime = _input.read_short();
    _result.rate = _input.read_short();
    _result.pgpTPList = globaldefs.NamingAttributesList_THelper.read(_input);
    _result.pgpParameters = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final protection.ProtectionGroup_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    protection.ProtectionGroupType_THelper.write(_output, _vis_value.protectionType);
    protection.ProtectionSchemeState_THelper.write(_output, _vis_value.protectionSchemeState);
    protection.ReversionMode_THelper.write(_output, _vis_value.reversionMode);
    _output.write_boolean((boolean)_vis_value.nonPreEmptibleTraffic);
    _output.write_short((short)_vis_value.wtrTime);
    _output.write_short((short)_vis_value.rate);
    globaldefs.NamingAttributesList_THelper.write(_output, _vis_value.pgpTPList);
    globaldefs.NVSList_THelper.write(_output, _vis_value.pgpParameters);
  }

  public static void insert (final org.omg.CORBA.Any any, final protection.ProtectionGroup_T _vis_value) {
    any.insert_Streamable(new protection.ProtectionGroup_THolder(_vis_value));
  }

  public static protection.ProtectionGroup_T extract (final org.omg.CORBA.Any any) {
    protection.ProtectionGroup_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      protection.ProtectionGroup_THolder _vis_holder = new protection.ProtectionGroup_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = protection.ProtectionGroup_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[12];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("protectionType", protection.ProtectionGroupType_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("protectionSchemeState", protection.ProtectionSchemeState_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("reversionMode", protection.ReversionMode_THelper.type(), null);
          members[7] = new org.omg.CORBA.StructMember("nonPreEmptibleTraffic", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_boolean), null);
          members[8] = new org.omg.CORBA.StructMember("wtrTime", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_short), null);
          members[9] = new org.omg.CORBA.StructMember("rate", transmissionParameters.LayerRate_THelper.type(), null);
          members[10] = new org.omg.CORBA.StructMember("pgpTPList", globaldefs.NamingAttributesList_THelper.type(), null);
          members[11] = new org.omg.CORBA.StructMember("pgpParameters", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "ProtectionGroup_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:protection/ProtectionGroup_T:1.0";
  }
}
