package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionMgr
 * <li> <b>Repository Id</b> IDL:protection/ProtectionMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ProtectionMgr {
  ...
};
 * </pre>
 */
public abstract class ProtectionMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, protection.ProtectionMgrOperations {

  public protection.ProtectionMgr _this () {
   return protection.ProtectionMgrHelper.narrow(super._this_object());
  }

  public protection.ProtectionMgr _this (org.omg.CORBA.ORB orb) {
    return protection.ProtectionMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:protection/ProtectionMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getAllProtectionGroups", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("getProtectionGroup", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("getAllNPPATPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
    _methods.put("getAllPreemptibleTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 3));
    _methods.put("getAllProtectedTPNames", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 4));
    _methods.put("retrieveSwitchData", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 5));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return protection.ProtectionMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (protection.ProtectionMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        globaldefs.NameAndStringValue_T[] meName;
        meName = globaldefs.NamingAttributes_THelper.read(_input);
        protection.ProtectionGroupList_THolder pgList = new protection.ProtectionGroupList_THolder();
        _self.getAllProtectionGroups(meName, pgList);
        _output = _handler.createReply();
        protection.ProtectionGroupList_THelper.write(_output, pgList.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        globaldefs.NameAndStringValue_T[] pgName;
        pgName = globaldefs.NamingAttributes_THelper.read(_input);
        protection.ProtectionGroup_THolder protectionGroup = new protection.ProtectionGroup_THolder();
        _self.getProtectionGroup(pgName, protectionGroup);
        _output = _handler.createReply();
        protection.ProtectionGroup_THelper.write(_output, protectionGroup.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        globaldefs.NameAndStringValue_T[] pgName;
        pgName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllNPPATPNames(pgName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 3: {
      try {
        globaldefs.NameAndStringValue_T[] pgName;
        pgName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllPreemptibleTPNames(pgName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 4: {
      try {
        globaldefs.NameAndStringValue_T[] pgName;
        pgName = globaldefs.NamingAttributes_THelper.read(_input);
        int how_many;
        how_many = _input.read_ulong();
        globaldefs.NamingAttributesList_THolder nameList = new globaldefs.NamingAttributesList_THolder();
        globaldefs.NamingAttributesIteratorHolder nameIt = new globaldefs.NamingAttributesIteratorHolder();
        _self.getAllProtectedTPNames(pgName, how_many, nameList, nameIt);
        _output = _handler.createReply();
        globaldefs.NamingAttributesList_THelper.write(_output, nameList.value);
        globaldefs.NamingAttributesIteratorHelper.write(_output, nameIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 5: {
      try {
        globaldefs.NameAndStringValue_T[] reliableSinkCtpOrGroupName;
        reliableSinkCtpOrGroupName = globaldefs.NamingAttributes_THelper.read(_input);
        protection.SwitchDataList_THolder switchData = new protection.SwitchDataList_THolder();
        _self.retrieveSwitchData(reliableSinkCtpOrGroupName, switchData);
        _output = _handler.createReply();
        protection.SwitchDataList_THelper.write(_output, switchData.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
