package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::SwitchData_T
 * <li> <b>Repository Id</b> IDL:protection/SwitchData_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SwitchData_T {
  ...
};
 * </pre>
 */
public final class SwitchData_T implements org.omg.CORBA.portable.IDLEntity {
  
  public protection.ProtectionType_T protectionType;
  
  public protection.SwitchReason_T switchReason;
  
  public short layerRate;
  
  public globaldefs.NameAndStringValue_T[] groupName;
  
  public globaldefs.NameAndStringValue_T[] protectedTP;
  
  public globaldefs.NameAndStringValue_T[] switchAwayFromTP;
  
  public globaldefs.NameAndStringValue_T[] switchToTP;

  public SwitchData_T () {
  }

  public SwitchData_T (final protection.ProtectionType_T protectionType, 
                       final protection.SwitchReason_T switchReason, 
                       final short layerRate, 
                       final globaldefs.NameAndStringValue_T[] groupName, 
                       final globaldefs.NameAndStringValue_T[] protectedTP, 
                       final globaldefs.NameAndStringValue_T[] switchAwayFromTP, 
                       final globaldefs.NameAndStringValue_T[] switchToTP) {
    this.protectionType = protectionType;
    this.switchReason = switchReason;
    this.layerRate = layerRate;
    this.groupName = groupName;
    this.protectedTP = protectedTP;
    this.switchAwayFromTP = switchAwayFromTP;
    this.switchToTP = switchToTP;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct protection.SwitchData_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("protection.ProtectionType_T protectionType=");
    _ret.append(protectionType);
    _ret.append(",\n");
    _ret.append("protection.SwitchReason_T switchReason=");
    _ret.append(switchReason);
    _ret.append(",\n");
    _ret.append("short layerRate=");
    _ret.append(layerRate);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] groupName=");
    _ret.append("{");
    if (groupName == null) {
      _ret.append(groupName);
    } else {
      for (int $counter11 = 0; $counter11 < groupName.length; $counter11++) {
        _ret.append(groupName[$counter11]);
        if ($counter11 < groupName.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] protectedTP=");
    _ret.append("{");
    if (protectedTP == null) {
      _ret.append(protectedTP);
    } else {
      for (int $counter12 = 0; $counter12 < protectedTP.length; $counter12++) {
        _ret.append(protectedTP[$counter12]);
        if ($counter12 < protectedTP.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] switchAwayFromTP=");
    _ret.append("{");
    if (switchAwayFromTP == null) {
      _ret.append(switchAwayFromTP);
    } else {
      for (int $counter13 = 0; $counter13 < switchAwayFromTP.length; $counter13++) {
        _ret.append(switchAwayFromTP[$counter13]);
        if ($counter13 < switchAwayFromTP.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] switchToTP=");
    _ret.append("{");
    if (switchToTP == null) {
      _ret.append(switchToTP);
    } else {
      for (int $counter14 = 0; $counter14 < switchToTP.length; $counter14++) {
        _ret.append(switchToTP[$counter14]);
        if ($counter14 < switchToTP.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof protection.SwitchData_T) {
      _cmpMap.put(_currentThread, o);
      final protection.SwitchData_T obj = (protection.SwitchData_T)o;
      boolean res = true;
      do {
        res = this.protectionType == obj.protectionType ||
         (this.protectionType != null && obj.protectionType != null && this.protectionType.equals(obj.protectionType));
        if (!res) break;
        res = this.switchReason == obj.switchReason ||
         (this.switchReason != null && obj.switchReason != null && this.switchReason.equals(obj.switchReason));
        if (!res) break;
          res = this.layerRate == obj.layerRate;
        if (!res) break;
            if (res = (this.groupName.length == obj.groupName.length)) {
              for (int $counter15 = 0; res && $counter15 < this.groupName.length; $counter15++) {
                res = this.groupName[$counter15] == obj.groupName[$counter15] ||
                 (this.groupName[$counter15] != null && obj.groupName[$counter15] != null && this.groupName[$counter15].equals(obj.groupName[$counter15]));
              }
            }
        if (!res) break;
            if (res = (this.protectedTP.length == obj.protectedTP.length)) {
              for (int $counter16 = 0; res && $counter16 < this.protectedTP.length; $counter16++) {
                res = this.protectedTP[$counter16] == obj.protectedTP[$counter16] ||
                 (this.protectedTP[$counter16] != null && obj.protectedTP[$counter16] != null && this.protectedTP[$counter16].equals(obj.protectedTP[$counter16]));
              }
            }
        if (!res) break;
            if (res = (this.switchAwayFromTP.length == obj.switchAwayFromTP.length)) {
              for (int $counter17 = 0; res && $counter17 < this.switchAwayFromTP.length; $counter17++) {
                res = this.switchAwayFromTP[$counter17] == obj.switchAwayFromTP[$counter17] ||
                 (this.switchAwayFromTP[$counter17] != null && obj.switchAwayFromTP[$counter17] != null && this.switchAwayFromTP[$counter17].equals(obj.switchAwayFromTP[$counter17]));
              }
            }
        if (!res) break;
            if (res = (this.switchToTP.length == obj.switchToTP.length)) {
              for (int $counter18 = 0; res && $counter18 < this.switchToTP.length; $counter18++) {
                res = this.switchToTP[$counter18] == obj.switchToTP[$counter18] ||
                 (this.switchToTP[$counter18] != null && obj.switchToTP[$counter18] != null && this.switchToTP[$counter18].equals(obj.switchToTP[$counter18]));
              }
            }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
