package protection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/protection.idl"
 * <li> <b>IDL Name</b>      ::protection::ProtectionMgr
 * <li> <b>Repository Id</b> IDL:protection/ProtectionMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ProtectionMgr {
  ...
};
 * </pre>
 */
public class _ProtectionMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements ProtectionMgr {
  final public static java.lang.Class _opsClass = protection.ProtectionMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:protection/ProtectionMgr:1.0"
  };

  /**
   * <pre>
   *   void getAllProtectionGroups (in globaldefs.NamingAttributes_T meName,
                               out protection.ProtectionGroupList_T pgList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllProtectionGroups (globaldefs.NameAndStringValue_T[] meName, 
                                      protection.ProtectionGroupList_THolder pgList) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllProtectionGroups", true);
          globaldefs.NamingAttributes_THelper.write(_output, meName);
          _input = this._invoke(_output);
          pgList.value = protection.ProtectionGroupList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllProtectionGroups", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.getAllProtectionGroups(meName, pgList);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getProtectionGroup (in globaldefs.NamingAttributes_T pgName,
                           out protection.ProtectionGroup_T protectionGroup)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getProtectionGroup (globaldefs.NameAndStringValue_T[] pgName, 
                                  protection.ProtectionGroup_THolder protectionGroup) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getProtectionGroup", true);
          globaldefs.NamingAttributes_THelper.write(_output, pgName);
          _input = this._invoke(_output);
          protectionGroup.value = protection.ProtectionGroup_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getProtectionGroup", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.getProtectionGroup(pgName, protectionGroup);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllNPPATPNames (in globaldefs.NamingAttributes_T pgName,
                          in unsigned long how_many,
                          out globaldefs.NamingAttributesList_T nameList,
                          out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllNPPATPNames (globaldefs.NameAndStringValue_T[] pgName, 
                                 int how_many, 
                                 globaldefs.NamingAttributesList_THolder nameList, 
                                 globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllNPPATPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, pgName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllNPPATPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.getAllNPPATPNames(pgName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllPreemptibleTPNames (in globaldefs.NamingAttributes_T pgName,
                                 in unsigned long how_many,
                                 out globaldefs.NamingAttributesList_T nameList,
                                 out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllPreemptibleTPNames (globaldefs.NameAndStringValue_T[] pgName, 
                                        int how_many, 
                                        globaldefs.NamingAttributesList_THolder nameList, 
                                        globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllPreemptibleTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, pgName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllPreemptibleTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.getAllPreemptibleTPNames(pgName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void getAllProtectedTPNames (in globaldefs.NamingAttributes_T pgName,
                               in unsigned long how_many,
                               out globaldefs.NamingAttributesList_T nameList,
                               out globaldefs.NamingAttributesIterator nameIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllProtectedTPNames (globaldefs.NameAndStringValue_T[] pgName, 
                                      int how_many, 
                                      globaldefs.NamingAttributesList_THolder nameList, 
                                      globaldefs.NamingAttributesIteratorHolder nameIt) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllProtectedTPNames", true);
          globaldefs.NamingAttributes_THelper.write(_output, pgName);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          nameList.value = globaldefs.NamingAttributesList_THelper.read(_input);
          nameIt.value = globaldefs.NamingAttributesIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllProtectedTPNames", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.getAllProtectedTPNames(pgName, how_many, nameList, nameIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

  /**
   * <pre>
   *   void retrieveSwitchData (in globaldefs.NamingAttributes_T reliableSinkCtpOrGroupName,
                           out protection.SwitchDataList_T switchData)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void retrieveSwitchData (globaldefs.NameAndStringValue_T[] reliableSinkCtpOrGroupName, 
                                  protection.SwitchDataList_THolder switchData) throws  globaldefs.ProcessingFailureException {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("retrieveSwitchData", true);
          globaldefs.NamingAttributes_THelper.write(_output, reliableSinkCtpOrGroupName);
          _input = this._invoke(_output);
          switchData.value = protection.SwitchDataList_THelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          if (_exception_id.equals(globaldefs.ProcessingFailureExceptionHelper.id())) {
            throw             globaldefs.ProcessingFailureExceptionHelper.read(_exception.getInputStream());
          }
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("retrieveSwitchData", _opsClass);
        if (_so == null) {
          continue;
        }
        final protection.ProtectionMgrOperations _self = (protection.ProtectionMgrOperations)_so.servant;
        try {
          _self.retrieveSwitchData(reliableSinkCtpOrGroupName, switchData);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
