package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::CCIterator
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/CCIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface CCIterator {
  ...
};
 * </pre>
 */
public interface CCIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out subnetworkConnection.CrossConnect_T cc)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (subnetworkConnection.CrossConnect_THolder cc) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out subnetworkConnection.CrossConnectList_T ccList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         subnetworkConnection.CrossConnectList_THolder ccList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
