package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::ResilienceMode_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/ResilienceMode_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ResilienceMode_T {RMODE_NA, RMODE_LEAST_RESILIENT, RMODE_LOW_RESILIENCE,
                       RMODE_RESILIENT};
 * </pre>
 */
public final class ResilienceMode_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _RMODE_NA = 0;
  
  public static final int _RMODE_LEAST_RESILIENT = 1;
  
  public static final int _RMODE_LOW_RESILIENCE = 2;
  
  public static final int _RMODE_RESILIENT = 3;

  
  public static final ResilienceMode_T RMODE_NA = new ResilienceMode_T(_RMODE_NA);
  
  public static final ResilienceMode_T RMODE_LEAST_RESILIENT = new ResilienceMode_T(_RMODE_LEAST_RESILIENT);
  
  public static final ResilienceMode_T RMODE_LOW_RESILIENCE = new ResilienceMode_T(_RMODE_LOW_RESILIENCE);
  
  public static final ResilienceMode_T RMODE_RESILIENT = new ResilienceMode_T(_RMODE_RESILIENT);

  protected ResilienceMode_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ResilienceMode_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return RMODE_NA;
      case 1: return RMODE_LEAST_RESILIENT;
      case 2: return RMODE_LOW_RESILIENCE;
      case 3: return RMODE_RESILIENT;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "RMODE_NA";
      case 1: return "RMODE_LEAST_RESILIENT";
      case 2: return "RMODE_LOW_RESILIENCE";
      case 3: return "RMODE_RESILIENT";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof subnetworkConnection.ResilienceMode_T
      ? this._value == ((subnetworkConnection.ResilienceMode_T)o)._value
      : false;
  }
}
