package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SNCIterator
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SNCIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface SNCIterator {
  ...
};
 * </pre>
 */
public interface SNCIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out subnetworkConnection.SubnetworkConnection_T tp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (subnetworkConnection.SubnetworkConnection_THolder tp) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out subnetworkConnection.SubnetworkConnectionList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         subnetworkConnection.SubnetworkConnectionList_THolder tpList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
