package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SubnetworkConnection_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SubnetworkConnection_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SubnetworkConnection_T {
  ...
};
 * </pre>
 */
public final class SubnetworkConnection_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public subnetworkConnection.SNCState_T sncState;
  
  public subnetworkConnection.ConnectionDirection_T direction;
  
  public short rate;
  
  public subnetworkConnection.ResilienceMode_T resilienceMode;
  
  public subnetworkConnection.SNCType_T snctype;
  
  public subnetworkConnection.TPData_T[] aEnd;
  
  public subnetworkConnection.TPData_T[] zEnd;
  
  public java.lang.String potentialFutureSetupIndicator;
  
  public java.lang.String errorReason;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public SubnetworkConnection_T () {
  }

  public SubnetworkConnection_T (final globaldefs.NameAndStringValue_T[] name, 
                                 final java.lang.String userLabel, 
                                 final java.lang.String nativeEMSName, 
                                 final java.lang.String owner, 
                                 final subnetworkConnection.SNCState_T sncState, 
                                 final subnetworkConnection.ConnectionDirection_T direction, 
                                 final short rate, 
                                 final subnetworkConnection.ResilienceMode_T resilienceMode, 
                                 final subnetworkConnection.SNCType_T snctype, 
                                 final subnetworkConnection.TPData_T[] aEnd, 
                                 final subnetworkConnection.TPData_T[] zEnd, 
                                 final java.lang.String potentialFutureSetupIndicator, 
                                 final java.lang.String errorReason, 
                                 final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.sncState = sncState;
    this.direction = direction;
    this.rate = rate;
    this.resilienceMode = resilienceMode;
    this.snctype = snctype;
    this.aEnd = aEnd;
    this.zEnd = zEnd;
    this.potentialFutureSetupIndicator = potentialFutureSetupIndicator;
    this.errorReason = errorReason;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct subnetworkConnection.SubnetworkConnection_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter11 = 0; $counter11 < name.length; $counter11++) {
        _ret.append(name[$counter11]);
        if ($counter11 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.SNCState_T sncState=");
    _ret.append(sncState);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ConnectionDirection_T direction=");
    _ret.append(direction);
    _ret.append(",\n");
    _ret.append("short rate=");
    _ret.append(rate);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.ResilienceMode_T resilienceMode=");
    _ret.append(resilienceMode);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.SNCType_T snctype=");
    _ret.append(snctype);
    _ret.append(",\n");
    _ret.append("subnetworkConnection.TPData_T[] aEnd=");
    _ret.append("{");
    if (aEnd == null) {
      _ret.append(aEnd);
    } else {
      for (int $counter12 = 0; $counter12 < aEnd.length; $counter12++) {
        _ret.append(aEnd[$counter12]);
        if ($counter12 < aEnd.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("subnetworkConnection.TPData_T[] zEnd=");
    _ret.append("{");
    if (zEnd == null) {
      _ret.append(zEnd);
    } else {
      for (int $counter13 = 0; $counter13 < zEnd.length; $counter13++) {
        _ret.append(zEnd[$counter13]);
        if ($counter13 < zEnd.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String potentialFutureSetupIndicator=");
    _ret.append(potentialFutureSetupIndicator != null?'\"' + potentialFutureSetupIndicator + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String errorReason=");
    _ret.append(errorReason != null?'\"' + errorReason + '\"':null);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter14 = 0; $counter14 < additionalInfo.length; $counter14++) {
        _ret.append(additionalInfo[$counter14]);
        if ($counter14 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof subnetworkConnection.SubnetworkConnection_T) {
      _cmpMap.put(_currentThread, o);
      final subnetworkConnection.SubnetworkConnection_T obj = (subnetworkConnection.SubnetworkConnection_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter15 = 0; res && $counter15 < this.name.length; $counter15++) {
                res = this.name[$counter15] == obj.name[$counter15] ||
                 (this.name[$counter15] != null && obj.name[$counter15] != null && this.name[$counter15].equals(obj.name[$counter15]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
        res = this.sncState == obj.sncState ||
         (this.sncState != null && obj.sncState != null && this.sncState.equals(obj.sncState));
        if (!res) break;
        res = this.direction == obj.direction ||
         (this.direction != null && obj.direction != null && this.direction.equals(obj.direction));
        if (!res) break;
          res = this.rate == obj.rate;
        if (!res) break;
        res = this.resilienceMode == obj.resilienceMode ||
         (this.resilienceMode != null && obj.resilienceMode != null && this.resilienceMode.equals(obj.resilienceMode));
        if (!res) break;
        res = this.snctype == obj.snctype ||
         (this.snctype != null && obj.snctype != null && this.snctype.equals(obj.snctype));
        if (!res) break;
          if (res = (this.aEnd.length == obj.aEnd.length)) {
            for (int $counter16 = 0; res && $counter16 < this.aEnd.length; $counter16++) {
              res = this.aEnd[$counter16] == obj.aEnd[$counter16] ||
               (this.aEnd[$counter16] != null && obj.aEnd[$counter16] != null && this.aEnd[$counter16].equals(obj.aEnd[$counter16]));
            }
          }
        if (!res) break;
          if (res = (this.zEnd.length == obj.zEnd.length)) {
            for (int $counter17 = 0; res && $counter17 < this.zEnd.length; $counter17++) {
              res = this.zEnd[$counter17] == obj.zEnd[$counter17] ||
               (this.zEnd[$counter17] != null && obj.zEnd[$counter17] != null && this.zEnd[$counter17].equals(obj.zEnd[$counter17]));
            }
          }
        if (!res) break;
          res = this.potentialFutureSetupIndicator == obj.potentialFutureSetupIndicator ||
           (this.potentialFutureSetupIndicator != null && obj.potentialFutureSetupIndicator != null && this.potentialFutureSetupIndicator.equals(obj.potentialFutureSetupIndicator));
        if (!res) break;
        res = this.errorReason == obj.errorReason ||
         (this.errorReason != null && obj.errorReason != null && this.errorReason.equals(obj.errorReason));
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter18 = 0; res && $counter18 < this.additionalInfo.length; $counter18++) {
              res = this.additionalInfo[$counter18] == obj.additionalInfo[$counter18] ||
               (this.additionalInfo[$counter18] != null && obj.additionalInfo[$counter18] != null && this.additionalInfo[$counter18].equals(obj.additionalInfo[$counter18]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
