package subnetworkConnection;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/subnetworkConnection.idl"
 * <li> <b>IDL Name</b>      ::subnetworkConnection::SubnetworkConnection_T
 * <li> <b>Repository Id</b> IDL:subnetworkConnection/SubnetworkConnection_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct SubnetworkConnection_T {
  ...
};
 * </pre>
 */
public final class SubnetworkConnection_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static subnetworkConnection.SubnetworkConnection_T read (final org.omg.CORBA.portable.InputStream _input) {
    final subnetworkConnection.SubnetworkConnection_T _result = new subnetworkConnection.SubnetworkConnection_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.sncState = subnetworkConnection.SNCState_THelper.read(_input);
    _result.direction = subnetworkConnection.ConnectionDirection_THelper.read(_input);
    _result.rate = _input.read_short();
    _result.resilienceMode = subnetworkConnection.ResilienceMode_THelper.read(_input);
    _result.snctype = subnetworkConnection.SNCType_THelper.read(_input);
    _result.aEnd = subnetworkConnection.TPDataList_THelper.read(_input);
    _result.zEnd = subnetworkConnection.TPDataList_THelper.read(_input);
    _result.potentialFutureSetupIndicator = _input.read_string();
    _result.errorReason = _input.read_string();
    _result.additionalInfo = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final subnetworkConnection.SubnetworkConnection_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    subnetworkConnection.SNCState_THelper.write(_output, _vis_value.sncState);
    subnetworkConnection.ConnectionDirection_THelper.write(_output, _vis_value.direction);
    _output.write_short((short)_vis_value.rate);
    subnetworkConnection.ResilienceMode_THelper.write(_output, _vis_value.resilienceMode);
    subnetworkConnection.SNCType_THelper.write(_output, _vis_value.snctype);
    subnetworkConnection.TPDataList_THelper.write(_output, _vis_value.aEnd);
    subnetworkConnection.TPDataList_THelper.write(_output, _vis_value.zEnd);
    _output.write_string((java.lang.String)_vis_value.potentialFutureSetupIndicator);
    _output.write_string((java.lang.String)_vis_value.errorReason);
    globaldefs.NVSList_THelper.write(_output, _vis_value.additionalInfo);
  }

  public static void insert (final org.omg.CORBA.Any any, final subnetworkConnection.SubnetworkConnection_T _vis_value) {
    any.insert_Streamable(new subnetworkConnection.SubnetworkConnection_THolder(_vis_value));
  }

  public static subnetworkConnection.SubnetworkConnection_T extract (final org.omg.CORBA.Any any) {
    subnetworkConnection.SubnetworkConnection_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      subnetworkConnection.SubnetworkConnection_THolder _vis_holder = new subnetworkConnection.SubnetworkConnection_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = subnetworkConnection.SubnetworkConnection_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[14];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("sncState", subnetworkConnection.SNCState_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("direction", subnetworkConnection.ConnectionDirection_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("rate", transmissionParameters.LayerRate_THelper.type(), null);
          members[7] = new org.omg.CORBA.StructMember("resilienceMode", subnetworkConnection.ResilienceMode_THelper.type(), null);
          members[8] = new org.omg.CORBA.StructMember("snctype", subnetworkConnection.SNCType_THelper.type(), null);
          members[9] = new org.omg.CORBA.StructMember("aEnd", subnetworkConnection.TPDataList_THelper.type(), null);
          members[10] = new org.omg.CORBA.StructMember("zEnd", subnetworkConnection.TPDataList_THelper.type(), null);
          members[11] = new org.omg.CORBA.StructMember("potentialFutureSetupIndicator", subnetworkConnection.ResourceSetup_THelper.type(), null);
          members[12] = new org.omg.CORBA.StructMember("errorReason", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[13] = new org.omg.CORBA.StructMember("additionalInfo", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "SubnetworkConnection_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:subnetworkConnection/SubnetworkConnection_T:1.0";
  }
}
