package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::Directionality_T
 * <li> <b>Repository Id</b> IDL:terminationPoint/Directionality_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum Directionality_T {D_NA, D_BIDIRECTIONAL, D_SOURCE, D_SINK};
 * </pre>
 */
public final class Directionality_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _D_NA = 0;
  
  public static final int _D_BIDIRECTIONAL = 1;
  
  public static final int _D_SOURCE = 2;
  
  public static final int _D_SINK = 3;

  
  public static final Directionality_T D_NA = new Directionality_T(_D_NA);
  
  public static final Directionality_T D_BIDIRECTIONAL = new Directionality_T(_D_BIDIRECTIONAL);
  
  public static final Directionality_T D_SOURCE = new Directionality_T(_D_SOURCE);
  
  public static final Directionality_T D_SINK = new Directionality_T(_D_SINK);

  protected Directionality_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static Directionality_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return D_NA;
      case 1: return D_BIDIRECTIONAL;
      case 2: return D_SOURCE;
      case 3: return D_SINK;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "D_NA";
      case 1: return "D_BIDIRECTIONAL";
      case 2: return "D_SOURCE";
      case 3: return "D_SINK";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof terminationPoint.Directionality_T
      ? this._value == ((terminationPoint.Directionality_T)o)._value
      : false;
  }
}
