package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TPConnectionState_T
 * <li> <b>Repository Id</b> IDL:terminationPoint/TPConnectionState_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum TPConnectionState_T {TPCS_SOURCE_CONNECTED, TPCS_SINK_CONNECTED,
                          TPCS_BI_CONNECTED, TPCS_NOT_CONNECTED};
 * </pre>
 */
public final class TPConnectionState_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _TPCS_SOURCE_CONNECTED = 0;
  
  public static final int _TPCS_SINK_CONNECTED = 1;
  
  public static final int _TPCS_BI_CONNECTED = 2;
  
  public static final int _TPCS_NOT_CONNECTED = 3;

  
  public static final TPConnectionState_T TPCS_SOURCE_CONNECTED = new TPConnectionState_T(_TPCS_SOURCE_CONNECTED);
  
  public static final TPConnectionState_T TPCS_SINK_CONNECTED = new TPConnectionState_T(_TPCS_SINK_CONNECTED);
  
  public static final TPConnectionState_T TPCS_BI_CONNECTED = new TPConnectionState_T(_TPCS_BI_CONNECTED);
  
  public static final TPConnectionState_T TPCS_NOT_CONNECTED = new TPConnectionState_T(_TPCS_NOT_CONNECTED);

  protected TPConnectionState_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static TPConnectionState_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return TPCS_SOURCE_CONNECTED;
      case 1: return TPCS_SINK_CONNECTED;
      case 2: return TPCS_BI_CONNECTED;
      case 3: return TPCS_NOT_CONNECTED;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "TPCS_SOURCE_CONNECTED";
      case 1: return "TPCS_SINK_CONNECTED";
      case 2: return "TPCS_BI_CONNECTED";
      case 3: return "TPCS_NOT_CONNECTED";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof terminationPoint.TPConnectionState_T
      ? this._value == ((terminationPoint.TPConnectionState_T)o)._value
      : false;
  }
}
