package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TerminationPointIterator
 * <li> <b>Repository Id</b> IDL:terminationPoint/TerminationPointIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TerminationPointIterator {
  ...
};
 * </pre>
 */
public interface TerminationPointIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out terminationPoint.TerminationPoint_T tp)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (terminationPoint.TerminationPoint_THolder tp) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out terminationPoint.TerminationPointList_T tpList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         terminationPoint.TerminationPointList_THolder tpList) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws globaldefs.ProcessingFailureException;

}
