package terminationPoint;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/terminationPoint.idl"
 * <li> <b>IDL Name</b>      ::terminationPoint::TerminationPoint_T
 * <li> <b>Repository Id</b> IDL:terminationPoint/TerminationPoint_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TerminationPoint_T {
  ...
};
 * </pre>
 */
public final class TerminationPoint_THelper {
  private static boolean _inited = false;
  private static boolean _initing = false;
  private static org.omg.CORBA.TypeCode _type;
  private static boolean _initializing;

  private static org.omg.CORBA.ORB _orb () {
    return org.omg.CORBA.ORB.init();
  }

  public static terminationPoint.TerminationPoint_T read (final org.omg.CORBA.portable.InputStream _input) {
    final terminationPoint.TerminationPoint_T _result = new terminationPoint.TerminationPoint_T();
    _result.name = globaldefs.NamingAttributes_THelper.read(_input);
    _result.userLabel = _input.read_string();
    _result.nativeEMSName = _input.read_string();
    _result.owner = _input.read_string();
    _result.ingressTrafficDescriptorName = globaldefs.NamingAttributes_THelper.read(_input);
    _result.egressTrafficDescriptorName = globaldefs.NamingAttributes_THelper.read(_input);
    _result.type = terminationPoint.TPType_THelper.read(_input);
    _result.connectionState = terminationPoint.TPConnectionState_THelper.read(_input);
    _result.tpMappingMode = terminationPoint.TerminationMode_THelper.read(_input);
    _result.direction = terminationPoint.Directionality_THelper.read(_input);
    _result.transmissionParameter = transmissionParameters.LayeredParameterList_THelper.read(_input);
    _result.tpProtectionAssociation = terminationPoint.TPProtectionAssociation_THelper.read(_input);
    _result.additionalInfo = globaldefs.NVSList_THelper.read(_input);
    return _result;
  }

  public static void write (final org.omg.CORBA.portable.OutputStream _output, final terminationPoint.TerminationPoint_T _vis_value) {
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.name);
    _output.write_string((java.lang.String)_vis_value.userLabel);
    _output.write_string((java.lang.String)_vis_value.nativeEMSName);
    _output.write_string((java.lang.String)_vis_value.owner);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.ingressTrafficDescriptorName);
    globaldefs.NamingAttributes_THelper.write(_output, _vis_value.egressTrafficDescriptorName);
    terminationPoint.TPType_THelper.write(_output, _vis_value.type);
    terminationPoint.TPConnectionState_THelper.write(_output, _vis_value.connectionState);
    terminationPoint.TerminationMode_THelper.write(_output, _vis_value.tpMappingMode);
    terminationPoint.Directionality_THelper.write(_output, _vis_value.direction);
    transmissionParameters.LayeredParameterList_THelper.write(_output, _vis_value.transmissionParameter);
    terminationPoint.TPProtectionAssociation_THelper.write(_output, _vis_value.tpProtectionAssociation);
    globaldefs.NVSList_THelper.write(_output, _vis_value.additionalInfo);
  }

  public static void insert (final org.omg.CORBA.Any any, final terminationPoint.TerminationPoint_T _vis_value) {
    any.insert_Streamable(new terminationPoint.TerminationPoint_THolder(_vis_value));
  }

  public static terminationPoint.TerminationPoint_T extract (final org.omg.CORBA.Any any) {
    terminationPoint.TerminationPoint_T _vis_value;
    if (any instanceof com.inprise.vbroker.CORBA.Any) {
      terminationPoint.TerminationPoint_THolder _vis_holder = new terminationPoint.TerminationPoint_THolder();
      ((com.inprise.vbroker.CORBA.Any)any).extract_Streamable(_vis_holder);
      _vis_value = _vis_holder.value;
    }
    else {
      _vis_value = terminationPoint.TerminationPoint_THelper.read(any.create_input_stream());
    }
    return _vis_value;
  }

  public static org.omg.CORBA.TypeCode type () {
    if (_type == null) {
      synchronized (org.omg.CORBA.TypeCode.class) {
        if (_type == null) {
          if (_initializing) {
            return _orb().create_recursive_tc(id());
          }
          _initializing = true;
          final org.omg.CORBA.StructMember[] members = new org.omg.CORBA.StructMember[13];
          members[0] = new org.omg.CORBA.StructMember("name", globaldefs.NamingAttributes_THelper.type(), null);
          members[1] = new org.omg.CORBA.StructMember("userLabel", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[2] = new org.omg.CORBA.StructMember("nativeEMSName", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[3] = new org.omg.CORBA.StructMember("owner", _orb().get_primitive_tc(org.omg.CORBA.TCKind.tk_string), null);
          members[4] = new org.omg.CORBA.StructMember("ingressTrafficDescriptorName", globaldefs.NamingAttributes_THelper.type(), null);
          members[5] = new org.omg.CORBA.StructMember("egressTrafficDescriptorName", globaldefs.NamingAttributes_THelper.type(), null);
          members[6] = new org.omg.CORBA.StructMember("type", terminationPoint.TPType_THelper.type(), null);
          members[7] = new org.omg.CORBA.StructMember("connectionState", terminationPoint.TPConnectionState_THelper.type(), null);
          members[8] = new org.omg.CORBA.StructMember("tpMappingMode", terminationPoint.TerminationMode_THelper.type(), null);
          members[9] = new org.omg.CORBA.StructMember("direction", terminationPoint.Directionality_THelper.type(), null);
          members[10] = new org.omg.CORBA.StructMember("transmissionParameter", transmissionParameters.LayeredParameterList_THelper.type(), null);
          members[11] = new org.omg.CORBA.StructMember("tpProtectionAssociation", terminationPoint.TPProtectionAssociation_THelper.type(), null);
          members[12] = new org.omg.CORBA.StructMember("additionalInfo", globaldefs.NVSList_THelper.type(), null);
          _type = _orb().create_struct_tc(id(), "TerminationPoint_T", members);
          _initializing = false;
        }
      }
    }
    return _type;
  }

  public static java.lang.String id () {
    return "IDL:terminationPoint/TerminationPoint_T:1.0";
  }
}
