package topologicalLink;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/topologicalLink.idl"
 * <li> <b>IDL Name</b>      ::topologicalLink::TopologicalLinkIterator
 * <li> <b>Repository Id</b> IDL:topologicalLink/TopologicalLinkIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TopologicalLinkIterator {
  ...
};
 * </pre>
 */
public class TopologicalLinkIteratorPOATie extends TopologicalLinkIteratorPOA {
  private topologicalLink.TopologicalLinkIteratorOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public TopologicalLinkIteratorPOATie (final topologicalLink.TopologicalLinkIteratorOperations _delegate) {
    this._delegate = _delegate;
  }

  public TopologicalLinkIteratorPOATie (final topologicalLink.TopologicalLinkIteratorOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public topologicalLink.TopologicalLinkIteratorOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final topologicalLink.TopologicalLinkIteratorOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   boolean next_one (out topologicalLink.TopologicalLink_T topoLink)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_one (topologicalLink.TopologicalLink_THolder topoLink) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_one(topoLink);
  }

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out topologicalLink.TopologicalLinkList_T topoLinkList)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         topologicalLink.TopologicalLinkList_THolder topoLinkList) throws  globaldefs.ProcessingFailureException {
    return this._delegate.next_n(how_many, topoLinkList);
  }

  /**
   * <pre>
   *   unsigned long getLength ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public int getLength () throws  globaldefs.ProcessingFailureException {
    return this._delegate.getLength();
  }

  /**
   * <pre>
   *   void destroy ()
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void destroy () throws  globaldefs.ProcessingFailureException {
    this._delegate.destroy();
  }

}
