package topologicalLink;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/topologicalLink.idl"
 * <li> <b>IDL Name</b>      ::topologicalLink::TopologicalLink_T
 * <li> <b>Repository Id</b> IDL:topologicalLink/TopologicalLink_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct TopologicalLink_T {
  ...
};
 * </pre>
 */
public final class TopologicalLink_T implements org.omg.CORBA.portable.IDLEntity {
  
  public globaldefs.NameAndStringValue_T[] name;
  
  public java.lang.String userLabel;
  
  public java.lang.String nativeEMSName;
  
  public java.lang.String owner;
  
  public short rate;
  
  public globaldefs.NameAndStringValue_T[] aEndTP;
  
  public globaldefs.NameAndStringValue_T[] zEndTP;
  
  public globaldefs.NameAndStringValue_T[] additionalInfo;

  public TopologicalLink_T () {
  }

  public TopologicalLink_T (final globaldefs.NameAndStringValue_T[] name, 
                            final java.lang.String userLabel, 
                            final java.lang.String nativeEMSName, 
                            final java.lang.String owner, 
                            final short rate, 
                            final globaldefs.NameAndStringValue_T[] aEndTP, 
                            final globaldefs.NameAndStringValue_T[] zEndTP, 
                            final globaldefs.NameAndStringValue_T[] additionalInfo) {
    this.name = name;
    this.userLabel = userLabel;
    this.nativeEMSName = nativeEMSName;
    this.owner = owner;
    this.rate = rate;
    this.aEndTP = aEndTP;
    this.zEndTP = zEndTP;
    this.additionalInfo = additionalInfo;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct topologicalLink.TopologicalLink_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("globaldefs.NameAndStringValue_T[] name=");
    _ret.append("{");
    if (name == null) {
      _ret.append(name);
    } else {
      for (int $counter0 = 0; $counter0 < name.length; $counter0++) {
        _ret.append(name[$counter0]);
        if ($counter0 < name.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("java.lang.String userLabel=");
    _ret.append(userLabel != null?'\"' + userLabel + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String nativeEMSName=");
    _ret.append(nativeEMSName != null?'\"' + nativeEMSName + '\"':null);
    _ret.append(",\n");
    _ret.append("java.lang.String owner=");
    _ret.append(owner != null?'\"' + owner + '\"':null);
    _ret.append(",\n");
    _ret.append("short rate=");
    _ret.append(rate);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] aEndTP=");
    _ret.append("{");
    if (aEndTP == null) {
      _ret.append(aEndTP);
    } else {
      for (int $counter1 = 0; $counter1 < aEndTP.length; $counter1++) {
        _ret.append(aEndTP[$counter1]);
        if ($counter1 < aEndTP.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] zEndTP=");
    _ret.append("{");
    if (zEndTP == null) {
      _ret.append(zEndTP);
    } else {
      for (int $counter2 = 0; $counter2 < zEndTP.length; $counter2++) {
        _ret.append(zEndTP[$counter2]);
        if ($counter2 < zEndTP.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] additionalInfo=");
    _ret.append("{");
    if (additionalInfo == null) {
      _ret.append(additionalInfo);
    } else {
      for (int $counter3 = 0; $counter3 < additionalInfo.length; $counter3++) {
        _ret.append(additionalInfo[$counter3]);
        if ($counter3 < additionalInfo.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof topologicalLink.TopologicalLink_T) {
      _cmpMap.put(_currentThread, o);
      final topologicalLink.TopologicalLink_T obj = (topologicalLink.TopologicalLink_T)o;
      boolean res = true;
      do {
            if (res = (this.name.length == obj.name.length)) {
              for (int $counter4 = 0; res && $counter4 < this.name.length; $counter4++) {
                res = this.name[$counter4] == obj.name[$counter4] ||
                 (this.name[$counter4] != null && obj.name[$counter4] != null && this.name[$counter4].equals(obj.name[$counter4]));
              }
            }
        if (!res) break;
        res = this.userLabel == obj.userLabel ||
         (this.userLabel != null && obj.userLabel != null && this.userLabel.equals(obj.userLabel));
        if (!res) break;
        res = this.nativeEMSName == obj.nativeEMSName ||
         (this.nativeEMSName != null && obj.nativeEMSName != null && this.nativeEMSName.equals(obj.nativeEMSName));
        if (!res) break;
        res = this.owner == obj.owner ||
         (this.owner != null && obj.owner != null && this.owner.equals(obj.owner));
        if (!res) break;
          res = this.rate == obj.rate;
        if (!res) break;
            if (res = (this.aEndTP.length == obj.aEndTP.length)) {
              for (int $counter5 = 0; res && $counter5 < this.aEndTP.length; $counter5++) {
                res = this.aEndTP[$counter5] == obj.aEndTP[$counter5] ||
                 (this.aEndTP[$counter5] != null && obj.aEndTP[$counter5] != null && this.aEndTP[$counter5].equals(obj.aEndTP[$counter5]));
              }
            }
        if (!res) break;
            if (res = (this.zEndTP.length == obj.zEndTP.length)) {
              for (int $counter6 = 0; res && $counter6 < this.zEndTP.length; $counter6++) {
                res = this.zEndTP[$counter6] == obj.zEndTP[$counter6] ||
                 (this.zEndTP[$counter6] != null && obj.zEndTP[$counter6] != null && this.zEndTP[$counter6].equals(obj.zEndTP[$counter6]));
              }
            }
        if (!res) break;
          if (res = (this.additionalInfo.length == obj.additionalInfo.length)) {
            for (int $counter7 = 0; res && $counter7 < this.additionalInfo.length; $counter7++) {
              res = this.additionalInfo[$counter7] == obj.additionalInfo[$counter7] ||
               (this.additionalInfo[$counter7] != null && obj.additionalInfo[$counter7] != null && this.additionalInfo[$counter7].equals(obj.additionalInfo[$counter7]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
