package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::ServiceCategory_T
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/ServiceCategory_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * enum ServiceCategory_T {SC_CBR, SC_VBRRT, SC_VBRNRT, SC_ABR, SC_UBR, SC_NA};
 * </pre>
 */
public final class ServiceCategory_T implements org.omg.CORBA.portable.IDLEntity {
  private /* [JDK 1.1.x BUG] final */ int _value;

  
  public static final int _SC_CBR = 0;
  
  public static final int _SC_VBRRT = 1;
  
  public static final int _SC_VBRNRT = 2;
  
  public static final int _SC_ABR = 3;
  
  public static final int _SC_UBR = 4;
  
  public static final int _SC_NA = 5;

  
  public static final ServiceCategory_T SC_CBR = new ServiceCategory_T(_SC_CBR);
  
  public static final ServiceCategory_T SC_VBRRT = new ServiceCategory_T(_SC_VBRRT);
  
  public static final ServiceCategory_T SC_VBRNRT = new ServiceCategory_T(_SC_VBRNRT);
  
  public static final ServiceCategory_T SC_ABR = new ServiceCategory_T(_SC_ABR);
  
  public static final ServiceCategory_T SC_UBR = new ServiceCategory_T(_SC_UBR);
  
  public static final ServiceCategory_T SC_NA = new ServiceCategory_T(_SC_NA);

  protected ServiceCategory_T (final int _vis_value) {
    this._value = _vis_value;
  }

  public int value () {
    return _value;
  }

  public static ServiceCategory_T from_int (final int _vis_value) {
    switch (_vis_value) {
      case 0: return SC_CBR;
      case 1: return SC_VBRRT;
      case 2: return SC_VBRNRT;
      case 3: return SC_ABR;
      case 4: return SC_UBR;
      case 5: return SC_NA;
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }
  public java.lang.String toString() {
    switch (_value) {
      case 0: return "SC_CBR";
      case 1: return "SC_VBRRT";
      case 2: return "SC_VBRNRT";
      case 3: return "SC_ABR";
      case 4: return "SC_UBR";
      case 5: return "SC_NA";
      default: throw new org.omg.CORBA.BAD_PARAM();
    }
  }

  public boolean equals (java.lang.Object o) {
    if (this == o)
      return true;
    if (o == null)
      return false;
    return o instanceof trafficDescriptor.ServiceCategory_T
      ? this._value == ((trafficDescriptor.ServiceCategory_T)o)._value
      : false;
  }
}
