package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorMgr
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorMgr {
  ...
};
 * </pre>
 */
public interface TrafficDescriptorMgrOperations {
  /**
   * <pre>
   *   void getAllTrafficDescriptors (in unsigned long how_many,
                                 out trafficDescriptor.TrafficDescriptorList_T trafficDescList,
                                 out trafficDescriptor.TrafficDescriptorIterator trafficDescIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTrafficDescriptors (int how_many, 
                                        trafficDescriptor.TrafficDescriptorList_THolder trafficDescList, 
                                        trafficDescriptor.TrafficDescriptorIteratorHolder trafficDescIt) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void createTrafficDescriptor (inout trafficDescriptor.TrafficDescriptor_T newTrafficDescriptor)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void createTrafficDescriptor (trafficDescriptor.TrafficDescriptor_THolder newTrafficDescriptor) throws globaldefs.ProcessingFailureException;

  /**
   * <pre>
   *   void deleteTrafficDescriptor (in globaldefs.NamingAttributes_T descriptorName)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deleteTrafficDescriptor (globaldefs.NameAndStringValue_T[] descriptorName) throws globaldefs.ProcessingFailureException;

}
