package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorMgr
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorMgr {
  ...
};
 * </pre>
 */
public abstract class TrafficDescriptorMgrPOA extends org.omg.PortableServer.Servant implements 
  org.omg.CORBA.portable.InvokeHandler, trafficDescriptor.TrafficDescriptorMgrOperations {

  public trafficDescriptor.TrafficDescriptorMgr _this () {
   return trafficDescriptor.TrafficDescriptorMgrHelper.narrow(super._this_object());
  }

  public trafficDescriptor.TrafficDescriptorMgr _this (org.omg.CORBA.ORB orb) {
    return trafficDescriptor.TrafficDescriptorMgrHelper.narrow(super._this_object(orb));
  }

  public java.lang.String[] _all_interfaces (final org.omg.PortableServer.POA poa, final byte[] objectId) {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:trafficDescriptor/TrafficDescriptorMgr:1.0"
  };

  private static java.util.Dictionary _methods = new java.util.Hashtable();

  static {
    _methods.put("getAllTrafficDescriptors", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 0));
    _methods.put("createTrafficDescriptor", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 1));
    _methods.put("deleteTrafficDescriptor", new com.inprise.vbroker.CORBA.portable.MethodPointer(0, 2));
  }

  public org.omg.CORBA.portable.OutputStream _invoke (java.lang.String opName,
                                                      org.omg.CORBA.portable.InputStream _input,
                                                      org.omg.CORBA.portable.ResponseHandler handler) {
    com.inprise.vbroker.CORBA.portable.MethodPointer method =
      (com.inprise.vbroker.CORBA.portable.MethodPointer) _methods.get(opName);
    if (method == null) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    switch (method.interface_id) {
      case 0: {
        return trafficDescriptor.TrafficDescriptorMgrPOA._invoke(this, method.method_id, _input, handler);
      }
    }
    throw new org.omg.CORBA.BAD_OPERATION();
  }

  public static org.omg.CORBA.portable.OutputStream _invoke (trafficDescriptor.TrafficDescriptorMgrOperations _self,
                                                             int _method_id,
                                                             org.omg.CORBA.portable.InputStream _input,
                                                             org.omg.CORBA.portable.ResponseHandler _handler) {
    org.omg.CORBA.portable.OutputStream _output = null;
    {
      switch (_method_id) {
      case 0: {
      try {
        int how_many;
        how_many = _input.read_ulong();
        trafficDescriptor.TrafficDescriptorList_THolder trafficDescList = new trafficDescriptor.TrafficDescriptorList_THolder();
        trafficDescriptor.TrafficDescriptorIteratorHolder trafficDescIt = new trafficDescriptor.TrafficDescriptorIteratorHolder();
        _self.getAllTrafficDescriptors(how_many, trafficDescList, trafficDescIt);
        _output = _handler.createReply();
        trafficDescriptor.TrafficDescriptorList_THelper.write(_output, trafficDescList.value);
        trafficDescriptor.TrafficDescriptorIteratorHelper.write(_output, trafficDescIt.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 1: {
      try {
        trafficDescriptor.TrafficDescriptor_THolder newTrafficDescriptor = new trafficDescriptor.TrafficDescriptor_THolder();
        newTrafficDescriptor.value = trafficDescriptor.TrafficDescriptor_THelper.read(_input);
        _self.createTrafficDescriptor(newTrafficDescriptor);
        _output = _handler.createReply();
        trafficDescriptor.TrafficDescriptor_THelper.write(_output, newTrafficDescriptor.value);
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      case 2: {
      try {
        globaldefs.NameAndStringValue_T[] descriptorName;
        descriptorName = globaldefs.NamingAttributes_THelper.read(_input);
        _self.deleteTrafficDescriptor(descriptorName);
        _output = _handler.createReply();
      }
      catch (globaldefs.ProcessingFailureException _exception) {
        _output = _handler.createExceptionReply();
        globaldefs.ProcessingFailureExceptionHelper.write(_output, _exception);
      }
        return _output;
      }
      }
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
}
