package trafficDescriptor;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/trafficDescriptor.idl"
 * <li> <b>IDL Name</b>      ::trafficDescriptor::TrafficDescriptorMgr
 * <li> <b>Repository Id</b> IDL:trafficDescriptor/TrafficDescriptorMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface TrafficDescriptorMgr {
  ...
};
 * </pre>
 */
public class TrafficDescriptorMgrPOATie extends TrafficDescriptorMgrPOA {
  private trafficDescriptor.TrafficDescriptorMgrOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public TrafficDescriptorMgrPOATie (final trafficDescriptor.TrafficDescriptorMgrOperations _delegate) {
    this._delegate = _delegate;
  }

  public TrafficDescriptorMgrPOATie (final trafficDescriptor.TrafficDescriptorMgrOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public trafficDescriptor.TrafficDescriptorMgrOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final trafficDescriptor.TrafficDescriptorMgrOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   void getAllTrafficDescriptors (in unsigned long how_many,
                                 out trafficDescriptor.TrafficDescriptorList_T trafficDescList,
                                 out trafficDescriptor.TrafficDescriptorIterator trafficDescIt)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void getAllTrafficDescriptors (int how_many, 
                                        trafficDescriptor.TrafficDescriptorList_THolder trafficDescList, 
                                        trafficDescriptor.TrafficDescriptorIteratorHolder trafficDescIt) throws  globaldefs.ProcessingFailureException {
    this._delegate.getAllTrafficDescriptors(how_many, trafficDescList, trafficDescIt);
  }

  /**
   * <pre>
   *   void createTrafficDescriptor (inout trafficDescriptor.TrafficDescriptor_T newTrafficDescriptor)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void createTrafficDescriptor (trafficDescriptor.TrafficDescriptor_THolder newTrafficDescriptor) throws  globaldefs.ProcessingFailureException {
    this._delegate.createTrafficDescriptor(newTrafficDescriptor);
  }

  /**
   * <pre>
   *   void deleteTrafficDescriptor (in globaldefs.NamingAttributes_T descriptorName)
    raises (globaldefs.ProcessingFailureException);
   * </pre>
   */
  public void deleteTrafficDescriptor (globaldefs.NameAndStringValue_T[] descriptorName) throws  globaldefs.ProcessingFailureException {
    this._delegate.deleteTrafficDescriptor(descriptorName);
  }

}
