package transmissionParameters;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "C:/WINNT/Profiles/venni/jbproject/project/src/project/transmissionParameters.idl"
 * <li> <b>IDL Name</b>      ::transmissionParameters::LayeredParameters_T
 * <li> <b>Repository Id</b> IDL:transmissionParameters/LayeredParameters_T:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * struct LayeredParameters_T {
  ...
};
 * </pre>
 */
public final class LayeredParameters_T implements org.omg.CORBA.portable.IDLEntity {
  
  public short layer;
  
  public globaldefs.NameAndStringValue_T[] transmissionParameters;

  public LayeredParameters_T () {
  }

  public LayeredParameters_T (final short layer, 
                              final globaldefs.NameAndStringValue_T[] transmissionParameters) {
    this.layer = layer;
    this.transmissionParameters = transmissionParameters;
  }

  private transient java.util.Hashtable _printMap = null;
  public java.lang.String toString() {
    final java.lang.StringBuffer _ret = new java.lang.StringBuffer("struct transmissionParameters.LayeredParameters_T {");
    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_printMap == null) {
      synchronized (this) {
        if (_printMap == null) {
          justCreated = true;
          _printMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      if (_printMap.get(_currentThread) != null) {
        _ret.append("...}");
        return _ret.toString();
      }
    }
    _printMap.put(_currentThread, this);
    _ret.append("\n");
    _ret.append("short layer=");
    _ret.append(layer);
    _ret.append(",\n");
    _ret.append("globaldefs.NameAndStringValue_T[] transmissionParameters=");
    _ret.append("{");
    if (transmissionParameters == null) {
      _ret.append(transmissionParameters);
    } else {
      for (int $counter1 = 0; $counter1 < transmissionParameters.length; $counter1++) {
        _ret.append(transmissionParameters[$counter1]);
        if ($counter1 < transmissionParameters.length - 1) {
          _ret.append(",");
        }
      }
    }
    _ret.append("}");
    _ret.append("\n");
    _printMap.remove(_currentThread);
    _ret.append("}");
    return _ret.toString();
  }

  private transient java.util.Hashtable _cmpMap = null;
  public boolean equals (java.lang.Object o) {
    if (this == o) return true;
    if (o == null) return false;

    final java.lang.Thread _currentThread = java.lang.Thread.currentThread();
    boolean justCreated = false;
    if (_cmpMap == null) {
      synchronized (this) {
        if (_cmpMap == null) {
          justCreated = true;
          _cmpMap = new java.util.Hashtable();
        }
      }
    }
    if (!justCreated) {
      final java.lang.Object _cmpObj;
      _cmpObj= _cmpMap.get(_currentThread);
      if (_cmpObj != null) return o == _cmpObj;
    }
    if (o instanceof transmissionParameters.LayeredParameters_T) {
      _cmpMap.put(_currentThread, o);
      final transmissionParameters.LayeredParameters_T obj = (transmissionParameters.LayeredParameters_T)o;
      boolean res = true;
      do {
          res = this.layer == obj.layer;
        if (!res) break;
          if (res = (this.transmissionParameters.length == obj.transmissionParameters.length)) {
            for (int $counter2 = 0; res && $counter2 < this.transmissionParameters.length; $counter2++) {
              res = this.transmissionParameters[$counter2] == obj.transmissionParameters[$counter2] ||
               (this.transmissionParameters[$counter2] != null && obj.transmissionParameters[$counter2] != null && this.transmissionParameters[$counter2].equals(obj.transmissionParameters[$counter2]));
            }
          }
      } while (false);
      _cmpMap.remove(_currentThread);
      return res;
    }
    else {
      return false;
    }
  }
}
