package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::ManagedElMgr
 * <li> <b>Repository Id</b> IDL:Prova/ManagedElMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElMgr {
  ...
};
 * </pre>
 */
public class ManagedElMgrPOATie extends ManagedElMgrPOA {
  private Prova.ManagedElMgrOperations _delegate;
  private org.omg.PortableServer.POA _poa;

  public ManagedElMgrPOATie (final Prova.ManagedElMgrOperations _delegate) {
    this._delegate = _delegate;
  }

  public ManagedElMgrPOATie (final Prova.ManagedElMgrOperations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public Prova.ManagedElMgrOperations _delegate () {
    return this._delegate;
  }

  public void _delegate (final Prova.ManagedElMgrOperations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   void getAllManagedEl (in unsigned long how_many,
                        out Prova.ManagedElementList_T meList,
                        out Prova.ManagedElementIterator meIt);
   * </pre>
   */
  public void getAllManagedEl (int how_many, 
                               Prova.ManagedElementList_THolder meList, 
                               Prova.ManagedElementIteratorHolder meIt) {
    this._delegate.getAllManagedEl(how_many, meList, meIt);
  }

}
