package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::ManagedElementIterator
 * <li> <b>Repository Id</b> IDL:Prova/ManagedElementIterator:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElementIterator {
  ...
};
 * </pre>
 */
public interface ManagedElementIteratorOperations {
  /**
   * <pre>
   *   boolean next_one (out Prova.ManagedElement_T me);
   * </pre>
   */
  public boolean next_one (Prova.ManagedElement_THolder me);

  /**
   * <pre>
   *   boolean next_n (in unsigned long how_many,
                  out Prova.ManagedElementList_T meList);
   * </pre>
   */
  public boolean next_n (int how_many, 
                         Prova.ManagedElementList_THolder meList);

  /**
   * <pre>
   *   unsigned long getLength ();
   * </pre>
   */
  public int getLength ();

  /**
   * <pre>
   *   void destroy ();
   * </pre>
   */
  public void destroy ();

}
