package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::NetR1
 * <li> <b>Repository Id</b> IDL:Prova/NetR1:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface NetR1 {
  ...
};
 * </pre>
 */
public class NetR1POATie extends NetR1POA {
  private Prova.NetR1Operations _delegate;
  private org.omg.PortableServer.POA _poa;

  public NetR1POATie (final Prova.NetR1Operations _delegate) {
    this._delegate = _delegate;
  }

  public NetR1POATie (final Prova.NetR1Operations _delegate, 
                              final org.omg.PortableServer.POA _poa) {
    this._delegate = _delegate;
    this._poa = _poa;
  }

  public Prova.NetR1Operations _delegate () {
    return this._delegate;
  }

  public void _delegate (final Prova.NetR1Operations delegate) {
    this._delegate = delegate;
  }

  public org.omg.PortableServer.POA _default_POA () {
    if (_poa != null) {
      return _poa;
    } 
    else {
      return super._default_POA();
    }
  }

  /**
   * <pre>
   *   string metodoR1 (in string name);
   * </pre>
   */
  public java.lang.String metodoR1 (java.lang.String name) {
    return this._delegate.metodoR1(name);
  }

  /**
   * <pre>
   *   Prova.ManagedElMgr getManagedElMgr ();
   * </pre>
   */
  public Prova.ManagedElMgr getManagedElMgr () {
    return this._delegate.getManagedElMgr();
  }

  /**
   * <pre>
   *   Prova.Mgr2 getMgr2 ();
   * </pre>
   */
  public Prova.Mgr2 getMgr2 () {
    return this._delegate.getMgr2();
  }

}
