package Prova;

/**
 * <ul>
 * <li> <b>IDL Source</b>    "Prova.idl"
 * <li> <b>IDL Name</b>      ::Prova::ManagedElMgr
 * <li> <b>Repository Id</b> IDL:Prova/ManagedElMgr:1.0
 * </ul>
 * <b>IDL definition:</b>
 * <pre>
 * interface ManagedElMgr {
  ...
};
 * </pre>
 */
public class _ManagedElMgrStub extends com.inprise.vbroker.CORBA.portable.ObjectImpl implements ManagedElMgr {
  final public static java.lang.Class _opsClass = Prova.ManagedElMgrOperations.class;

  public java.lang.String[] _ids () {
    return __ids;
  }

  private static java.lang.String[] __ids = {
    "IDL:Prova/ManagedElMgr:1.0"
  };

  /**
   * <pre>
   *   void getAllManagedEl (in unsigned long how_many,
                        out Prova.ManagedElementList_T meList,
                        out Prova.ManagedElementIterator meIt);
   * </pre>
   */
  public void getAllManagedEl (int how_many, 
                               Prova.ManagedElementList_THolder meList, 
                               Prova.ManagedElementIteratorHolder meIt) {

    while (true) {
      if (!_is_local()) {
        org.omg.CORBA.portable.OutputStream _output = null;
        org.omg.CORBA.portable.InputStream  _input  = null;
        try {
          _output = this._request("getAllManagedEl", true);
          _output.write_ulong((int)how_many);
          _input = this._invoke(_output);
          meList.value = Prova.ManagedElementList_THelper.read(_input);
          meIt.value = Prova.ManagedElementIteratorHelper.read(_input);
        }
        catch (org.omg.CORBA.portable.ApplicationException _exception) {
          final org.omg.CORBA.portable.InputStream in = _exception.getInputStream();
          java.lang.String _exception_id = _exception.getId();
          throw new org.omg.CORBA.UNKNOWN("Unexpected User Exception: " + _exception_id);
        }
        catch (org.omg.CORBA.portable.RemarshalException _exception) {
          continue;
        }
        finally {
          this._releaseReply(_input);
        }
      } else {
        final org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke("getAllManagedEl", _opsClass);
        if (_so == null) {
          continue;
        }
        final Prova.ManagedElMgrOperations _self = (Prova.ManagedElMgrOperations)_so.servant;
        try {
          _self.getAllManagedEl(how_many, meList, meIt);
        }
        finally {
          _servant_postinvoke(_so);
        }
      }
      break;
    }
  }

}
